/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : DESB  v2.n                                                  */
/*    Fichier : foconf.c                                                    */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Marc LAURENTIN                        le : 06/09/1991     */
/*                                                                          */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/

#include "head.h"


befig_list * VHB_HEDFIG = NULL ;
int          FCF_MAX_NODE = 200000 ;

short total_conf=0, no_conf=0, total_hz=0, no_hz=0;
short profondeur=0; short index_bdd = 0 ;
short fausse_b=0;
short passe=0;
FILE *res=NULL;
long MaxNoeud =0;

int FCF_PASSES = 0 ;
int FCF_FALSE_PATHES=0;
int FCF_DEBUG = 0 ;

int FCF_MLT_DIRTY[20];
int FCF_MLT_TREATED[20];
int FCF_MLT_CONF[20];
int FCF_MLT_HZ[20];
int FCF_TREAT_CONF[20];
int FCF_TREAT_HZ[20];
short FCF_HZ_TRAVERSE ;

static short fcfDiag = 1  ; /*creation d'un fichier de diagnostique*/

pCircuit badnode;
char FCF_LANG ;
short FCF_BDD_ORDER ; /* ordonancement par defaut */

/*****************************************************************************
*                            function fxConfHz()                             *
*****************************************************************************/
/*---------------------------------------------------------------------------+
| Refute les faux conflits et les faux tristate d'une figure desb            |
| Entree : FIG, la pour laquelle on veut evaluer les conflits et les etats   |
|          tri-state.                                                        |
|          CONEiNDEX. Si cette valeur est non nulle, alors un fichier vhdl   |
|          du cone de logique du cone d'index coneIndex est genere           |
|          TRACE. Si cette valeur est non nulle, un message accompagne le    |
|          traitement de chaque nouveau cone                                 |
| Sortie : Neant.                                                            |
+---------------------------------------------------------------------------*/ 
void fxConfHz( fig, coneIndex,trace,prof,firstPassProf,order,hz_traverse,lang )
desafig_list * fig ;
int coneIndex ;
short trace ;
int prof ;
int firstPassProf ;
short order ;
char lang ;
{
char  RES_FILE[200]; 
char  FILENAME[200];
int total_fb=0;
long Tstart=0, Tend=0;
cone_list  *dirty_cone, *ptr;
int i  ;
static int goOn = 0 ;

char *libfcfVersion=namealloc("@(#)libfcf version 1.63 du 17 06 92 ");

PROF_MAX = prof;
FCF_LANG = lang ;
FCF_BDD_ORDER = order ;
FCF_HZ_TRAVERSE = hz_traverse ;

   for(i=0;i<20;i++)
   {
   FCF_MLT_DIRTY[i]=0;
   FCF_MLT_TREATED[i]=0;
   FCF_MLT_CONF[i]=0;
   FCF_MLT_HZ[i]=0;
   FCF_TREAT_CONF[i]=0;
   FCF_TREAT_HZ[i]=0;
   }

/*---------------------------------------+
|  Ouverture du fichier de diagnostique  |
+---------------------------------------*/
   if(fcfDiag !=0)
   {
   (void)strcpy(FILENAME,fig->NAME) ;
   res = mbkfopen(FILENAME,"fcf",WRITE_TEXT); 
   (void)fprintf(res,"FOCONF\t%s/%s\n\n",*CATA_LIB,fig->NAME);
   }

/*--------------------------------+
 | Initialisation des contrainte  |
 *-------------------------------*/                 
 InitContrainte();

/*------------------------------------------------*
 | Initialisation du champs USER ABL_UP des cones |
 *------------------------------------------------*
{
cone_list * cone;
   for(cone=fig->CONE;cone!=NULL;cone=cone->NEXT)
      if(getptype(cone->USER,ABL_UP)!=NULL) cone->USER=delptype(cone->USER,ABL_UP);
}

/*--------------*
 |   myfunc     |
 *--------------*/
   do 
   {  
   befig_list * bfig = NULL;
   passe++;
   total_fb=0;
   total_conf=0;
   no_conf=0;
   total_hz=0;
   no_hz=0; 

   FCF_PASSES++;

      if(firstPassProf !=0) PROF_MAX=firstPassProf ;
      else PROF_MAX=prof;
      
      if(((fig->CONE->TYPE)&(CONFLICT | HZ))!=0)
      dirty_cone=fig->CONE ;
      else dirty_cone=next_conflit(fig->CONE);

      for (ptr=dirty_cone; ptr; ptr=next_conflit(ptr)) 
      {
      short jePasse = 0 ;
      short signChanged = 0;
      ptype_list * user;
      FCF_X_CONTR = 0 ;
      FCF_PRIM_INDEX = NULL ;
      FCF_TRAV_CONE = NULL ;
      FCF_TRAV_CONX = NULL ;
      fausse_b=0;

      FCF_MLT_DIRTY[FCF_PASSES]++;

         if (((ptr->TYPE & CONFLICT) == CONFLICT)) 
         FCF_MLT_CONF[FCF_PASSES]++;
         if ((ptr->TYPE & HZ) == HZ) 
         FCF_MLT_HZ[FCF_PASSES]++;

         if(trace !=0)
         {
         printf("\n--- Foconf sur (%d)%s ---\n",ptr->INDEX,ptr->NAME);
         printf("\n--- prof =  (%d) ---\n",PROF_MAX);
         fflush(stdout);
         }

         /*--------------------------------------------+
         | Si le cone n'a pas de branche fonctionnelle |
         | On passe au suivant                         |
         +--------------------------------------------*/
         if(fcfPathInCone(ptr)==-1) continue ;

      /*------------------------------------+
      | Creation de la befig et des Abl/Bdd |
      +------------------------------------*/
      if((ptr->INDEX==coneIndex))
      FCF_DEBUG = 1 ;

      bfig=makeBefigFromCone(fig,ptr,coneIndex,trace,&signChanged);         
      FCF_DEBUG = 0 ;

         /*------------------------------------+
         | La signature est identique  a celle | 
         | calcule a l'iteration precedente    |
         +------------------------------------*/
         if(signChanged <= 0)
         {
         jePasse=1;

            if(trace!=0)
            {
               if(signChanged == 0)
               printf("Je passe ce cone. Signature Identique\n");
               else
               printf("Je passe ce cone. Pas de reconvergence\n");
            fflush(stdout);
            }
         }
         else FCF_MLT_TREATED[FCF_PASSES]++;

         if((trace != 0)&&(jePasse==0))
         {
         printf("Apres MakeBefig: Bdd Node = %d\n",numberNodeAllBdd());
         fflush(stdout);
         }

         if(numberNodeAllBdd()>=FCF_MAX_NODE)
         {
         jePasse =1 ;
            if(FCF_LANG == 'F')
            fprintf(stderr,"[WAR] %d noeuds Bdd :je passe le cone (%d)%s\n",numberNodeAllBdd(),ptr->INDEX,ptr->NAME);
            else if (FCF_LANG == 'E')
            fprintf(stderr,"[WAR] %d Bdd nodes : Skipping the cone (%d)%s\n",numberNodeAllBdd(),ptr->INDEX,ptr->NAME);
         fflush(stdout);
         }

         /*----------------------*
         | Refutation de conflit |
         +----------------------*/
         if (((ptr->TYPE & CONFLICT) == CONFLICT)) 
         {
         short test = 0;
         total_conf++;


            if((trace != 0)&&(jePasse==0))
            {
            printf("Refutation de conflits\n");
            fflush(stdout);
            }

            if(jePasse == 0) 
            {
            test=fcfConflit(bfig,ptr); 
            FCF_TREAT_CONF[FCF_PASSES]++;
            }
            
            if(test != 0)
            {
            jePasse=1;
            printf("je passe Cf() et Hz()\n");
            fflush(stdout);
            }
         }

         /*--------------------------*
         | Refutation de three-state |
         +--------------------------*/
         if ((ptr->TYPE & HZ) == HZ) 
         {
         short test=0;
         total_hz++;


            if((trace != 0)&&(jePasse == 0))
            {
            printf("Refutation de tri-state \n");
            fflush(stdout);
            }

            if(jePasse == 0) 
            {
            test=fcfHz(bfig,ptr);
            FCF_TREAT_HZ[FCF_PASSES]++;
            }

            if(test !=0)
            {
            printf("Je passe Hz()\n");
            fflush(stdout);
            }
         }

      MaxNoeud=(MaxNoeud<sysBdd.pRT->compteur?sysBdd.pRT->compteur:MaxNoeud);

      total_fb +=fausse_b;

         if (fausse_b >0) marq_incone(ptr);

         if (signChanged > 0) resetCct(bfig->CIRCUI);

      freetag();
      CleanPath(ptr);
      CleanAllCone();
      CleanAllConect();
      resetBdd();

         if(FCF_PRIM_INDEX != NULL) freechain(FCF_PRIM_INDEX);
         if(FCF_TRAV_CONE !=NULL) freechain(FCF_TRAV_CONE);
         if(FCF_TRAV_CONX !=NULL) freechain(FCF_TRAV_CONX);

      VHB_HEDFIG=beh_delbefig(VHB_HEDFIG,bfig,'Y');
      }
   FCF_FALSE_PATHES+=total_fb;


      /*---------------------------------------------------+
      | On continue ou pas ??"?                            |
      +---------------------------------------------------*/
      if((total_fb !=0)||(no_conf != 0)||(no_hz != 0))  
      goOn = 1 ;
      else 
      {
         if(firstPassProf!=0)
         {
         goOn=1;
         firstPassProf=0;
         }
         else goOn=0;
      }
   } while (goOn != 0) ;  

   /*----------------+
   | On nettoie tout |
   +----------------*/
   {
   cone_list * cone;
      for(cone=fig->CONE;cone != NULL ; cone=cone->NEXT)
      {
      rmvBleedPath(cone);
      rmvLoopIn(cone);
      rmvLoopOut(cone);
      }
   }

   /*------------------+
   | diagnostique      |
   +------------------*/
   if(fcfDiag !=0)
   {
   fprintf(res,"prof : %d\n",PROF_MAX);
   fprintf(res,"passes : %d\n",FCF_PASSES);
   fprintf(res,"false pathes : %d\n",FCF_FALSE_PATHES);

      for(i=1;i<=FCF_PASSES;i++)
      {
      fprintf(res,"passe %d : %d conf/hz %d treated \n",i,
                              FCF_MLT_DIRTY[i],FCF_MLT_TREATED[i]);
      fprintf(res,"%d conf %d treated \n%d hz %d treated \n\n",
                              FCF_MLT_CONF[i],FCF_TREAT_CONF[i],
                              FCF_MLT_HZ[i],FCF_TREAT_HZ[i]);
      }
   fflush(res);
   fclose(res);
   }
}

