/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                  Panel.h                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  25/02/93                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# ifndef DREAL_VIEW_PANEL
# define DREAL_VIEW_PANEL

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
 
# define DREAL_RDS_NWELL   0
# define DREAL_RDS_PWELL   1
# define DREAL_RDS_NIMP    2
# define DREAL_RDS_PIMP    3
# define DREAL_RDS_ACTIV   4
# define DREAL_RDS_NDIF    5
# define DREAL_RDS_PDIF    6
# define DREAL_RDS_NTIE    7
# define DREAL_RDS_PTIE    8
# define DREAL_RDS_POLY    9
# define DREAL_RDS_GATE    10
# define DREAL_RDS_TPOLY   11
# define DREAL_RDS_CONT    12
# define DREAL_RDS_ALU1    13
# define DREAL_RDS_TALU1   14
# define DREAL_RDS_VIA1    15
# define DREAL_RDS_ALU2    16
# define DREAL_RDS_TALU2   17
# define DREAL_RDS_VIA2    18
# define DREAL_RDS_ALU3    19
# define DREAL_RDS_TALU3   20
# define DREAL_RDS_VIA3    21
# define DREAL_RDS_ALU4    22
# define DREAL_RDS_CPAS    23
# define DREAL_RDS_REF     24
# define DREAL_RDS_ABOX    25

# define DREAL_RDS_MAX_LAYER ( DREAL_RDS_ABOX + 1 )

# define DREAL_VIEW_ARROWS_X     990
# define DREAL_VIEW_ARROWS_Y      80
# define DREAL_VIEW_ZOOM_X       990
# define DREAL_VIEW_ZOOM_Y       230
# define DREAL_VIEW_LAYER_X      430
# define DREAL_VIEW_LAYER_Y      190
# define DREAL_VIEW_GRID_X       470
# define DREAL_VIEW_GRID_Y       330

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Callback View Panel                   |
|                                                             |
\------------------------------------------------------------*/

  extern void CallbackLeftArrow();
  extern void CallbackRightArrow();
  extern void CallbackUpArrow();
  extern void CallbackDownArrow();
  extern void CallbackMoveSet();
  extern void CallbackCloseArrows();

  extern void CallbackZoomRefresh();
  extern void CallbackZoomPrevious();
  extern void CallbackZoomLess();
  extern void CallbackZoomMore();
  extern void CallbackZoomSet();
  extern void CallbackZoomIn();
  extern void CallbackZoomFit();
  extern void CallbackZoomCenter();
  extern void CallbackZoomGoto();
  extern void CallbackZoomPan();
  extern void CallbackCloseZoom();

  extern void CallbackLayerAllVisible();
  extern void CallbackLayerAllInvisible();
  extern void CallbackNameVisible();
  extern void CallbackNameInvisible();
  extern void CallbackLayerVisible();
  extern void CallbackLayerInvisible();
  extern void CallbackLayerFillMode();
  extern void CallbackLayerInterface();
  extern void CallbackLayerApply();
  extern void CallbackCloseLayer();

  extern void DrealSetLayerVisible();
  extern void DrealSetLayerInvisible();
  extern void DrealSetNameVisible();
  extern void DrealSetNameInvisible();
  extern void DrealLayerAllVisible();
  extern void DrealLayerAllInvisible();
  extern void DrealChangeFillMode();
  extern void DrealChangeInterface();

  extern void CallbackSetGridX();
  extern void CallbackSetGridY();
  extern void CallbackGridOnOff();
  extern void CallbackCloseGrid();

  extern void DrealInitializeLayer();

# endif 
