

/*          Alliance CAD System 3.0                                         */
/*             FpGen Package 1.05                                           */
/*                                                                          */
/*  Copyright(c) 93-95, MASI, CAO-VLSI Team                                 */
/*                                                                          */
/*  Author      :          Jean-Paul CHAPUT                                 */
/*  E-mail      :      cao-vlsi@masi.ibp.fr                                 */
/* ************************************************************************ */
/*  Header      :      "GenericGN.h"                                        */


#ifndef  __GfpGN__
#define  __GfpGN__


/* Module external constants. */
#define        C_GfpGN_LimitsMinWidthDP     1
#define        C_GfpGN_LimitsMaxWidthDP   128

#define        C_GfpGN_FunctionInv          0
#define        C_GfpGN_FunctionBuff         1
#define        C_GfpGN_FunctionNand2        2
#define        C_GfpGN_FunctionNand3        3
#define        C_GfpGN_FunctionAnd2         4
#define        C_GfpGN_FunctionAnd3         5
#define        C_GfpGN_FunctionNor2         6
#define        C_GfpGN_FunctionNor3         7
#define        C_GfpGN_FunctionOr2          8
#define        C_GfpGN_FunctionOr3          9
#define        C_GfpGN_FunctionXnor2       10
#define        C_GfpGN_FunctionXor2        11
#define        C_GfpGN_FunctionNand2mask   12
#define        C_GfpGN_FunctionNor2mask    13
#define        C_GfpGN_FunctionXnor2mask   14
#define        C_GfpGN_FunctionConst       15
#define        C_GfpGN_FunctionNbuse       16
#define        C_GfpGN_FunctionBuse        17
#define        C_GfpGN_FunctionNmux2cs     18
#define        C_GfpGN_FunctionMux2cs      19
#define        C_GfpGN_FunctionMux3cd      20
#define        C_GfpGN_FunctionMux3cs      21
#define        C_GfpGN_FunctionMux4cs      22
#define        C_GfpGN_FunctionMux5cs      23
#define        C_GfpGN_FunctionMux6cs      24
#define        C_GfpGN_FunctionAdd2s       25
#define        C_GfpGN_FunctionNul         26
#define        C_GfpGN_FunctionNpl1        27
#define        C_GfpGN_FunctionPl1         28
#define        C_GfpGN_FunctionPmsnw       29
#define        C_GfpGN_FunctionPmsnwq      30
#define        C_GfpGN_FunctionPms         31
#define        C_GfpGN_FunctionPmsq        32
#define        C_GfpGN_FunctionPmst        33
#define        C_GfpGN_FunctionPmstq       34
#define        C_GfpGN_FunctionPdffnw      35
#define        C_GfpGN_FunctionPdffnwq     36
#define        C_GfpGN_FunctionPdff        37
#define        C_GfpGN_FunctionPdffr       38
#define        C_GfpGN_FunctionPdffq       39
#define        C_GfpGN_FunctionPdfft       40
#define        C_GfpGN_FunctionPdffrt      41
#define        C_GfpGN_FunctionPdfftq      42
#define        C_GfpGN_FunctionUnknow      43
#define        C_GfpGN_FunctionNumber      C_GfpGN_FunctionUnknow

#define        C_GfpGN_DriveInv             4
#define        C_GfpGN_DriveBuff            3
#define        C_GfpGN_DriveNand2           2
#define        C_GfpGN_DriveNand3           2
#define        C_GfpGN_DriveAnd2            2
#define        C_GfpGN_DriveAnd3            2
#define        C_GfpGN_DriveNor2            2
#define        C_GfpGN_DriveNor3            2
#define        C_GfpGN_DriveOr2             2
#define        C_GfpGN_DriveOr3             2
#define        C_GfpGN_DriveXnor2           1
#define        C_GfpGN_DriveXor2            1


/* Interface functions. */
#ifndef  ANSI_PROTO
	extern char *GfpGN_GenericDispatch();
#else
/* extern char *GfpGN_GenericDispatch(va_alist); */
/* Avalaible "GfpGN_GenericDipatch" calls :
 *
 *     - Boolean generators.
 * extern char *GfpGN_GenericDispatch(char *aModelName,
 *                                    long  aFunction ,
 *                                    long  aWidthDP  ,
 *                                    long  aWidthOp  ,
 *                                    long  aSlice    ,
 *                                    long  aDrive    ,
 *                                    long  aMSB0     ,
 *                                    long  aVHDL     ,
 *                                    long  aNetlist  ,
 *                                    long  aLayout   ,
 *                                    long  aIcon     ,
 *                                    long  aPower    );
 *
 *     - Controlable masks generators.
 *     - Constants generators.
 * extern char *GfpGN_GenericDispatch(char *aModelName,
 *                                    long  aFunction ,
 *                                    long  aWidthDP  ,
 *                                    long  aWidthOp  ,
 *                                    long  aSlice    ,
 *                                    long  aXlMask   ,
 *                                    long  aMSB0     ,
 *                                    long  aVHDL     ,
 *                                    long  aNetlist  ,
 *                                    long  aLayout   ,
 *                                    long  aIcon     ,
 *                                    long  aPower    );
 *
 *     - Buses (three-states) generators.
 *     - Multiplexer generators.
 *     - Adder generators.
 *     - Zero detect generators.
 *     - Registers generators.
 *     - Latchs generators.
 * extern char *GfpGN_GenericDispatch(char *aModelName,
 *                                    long  aFunction ,
 *                                    long  aWidthDP  ,
 *                                    long  aWidthOp  ,
 *                                    long  aSlice    ,
 *                                    long  aMSB0     ,
 *                                    long  aVHDL     ,
 *                                    long  aNetlist  ,
 *                                    long  aLayout   ,
 *                                    long  aIcon     ,
 *                                    long  aPower    );
 */
#endif


#endif
