

/*          Alliance CAD System 3.0                                         */
/*             FpGen Package 1.05                                           */
/*                                                                          */
/*  Copyright(c) 93-95, MASI, CAO-VLSI Team                                 */
/*                                                                          */
/*  Author      :          Jean-Paul CHAPUT                                 */
/*  E-mail      :      cao-vlsi@masi.ibp.fr                                 */
/* ************************************************************************ */
/*  Module      :      "UtEnv.c"                                            */


/* ******************************* Includes ******************************* */


#include  <stdio.h>
#include  <stdlib.h>

#include  "UtBase.h"
#include  "UtEnv.h"


/* ************************** Internal constants ************************** */


/* ********************* Internal Types And Structures ******************** */


/* Structure holding together all internal module global variables.
 */
static struct {
  long  ModuleId;          /* "UtEnv.c" module identifier. */
  } GlobVar;


/* ************************** Internal Variables ************************** */


/* ************************** External Variables ************************** */


UtEnv_Environ_t  UtEnv_Environ = {
  (char*)NULL,  /* Techno Path Name. */
  };


/* ************************* Interface Functions ************************** */


/* extern void  UtEnv_Init(void);
 */


/* ************************** Internal Functions ************************** */


/* ************************* Functions Definitions ************************ */


/*  Function  :  'UtEnv_Init()'.                                            */
/* ======================================================================== */
/*  Perform all initialisations neededs to use the functions of the utilies
 *  module :
 *       I - Load internal errors table.
 *      II - Load internal warnings table.
 */

extern void  UtEnv_Init()
{
  static long  FirstCall    = TRUE;

  if (FirstCall == FALSE) return;
    FirstCall  = FALSE;

  /* Attribution of a module identifier. */
  GlobVar.ModuleId = GfpUT_GetModuleId( "UtEnv", F_GfpUT_ModuleAdd );


  /* Reading environment variables. */
  UtEnv_Environ.RDS_TECHNO_NAME = getenv( "RDS_TECHNO_NAME" );
  UtEnv_Environ.FPGEN_LIB       = getenv( "FPGEN_LIB" );
}


