

/* ************* Interface of Module "UtPowerBar" *************** */


#define   C_GfpUT_PowBarTypeUnknow       2
#define   C_GfpUT_PowBarTypeVdd          3
#define   C_GfpUT_PowBarTypeVss          4


/* This structure is used to build an ordered list of power supply
 * coordinates.
 */
typedef struct uphfig_powbar {
					long  YPOW;  /* Y coordinate of the supply power bar. */
					char  TYPE;  /* Type of the supply power bar.         */
	struct uphfig_powbar *NEXT;  /* Pointer to the next element.          */
	} uphfig_powbar_list;


#ifndef  ANSI_PROTO

extern               void  UtPwB_Init();
extern uphfig_powbar_list *GfpUT_AddOPowBar();
extern uphfig_powbar_list *GfpUT_GetPowBar();
extern uphfig_powbar_list *GfpUT_GetPowBarBottom();
extern uphfig_powbar_list *GfpUT_GetPowBarTop();
extern               long  GfpUT_GetSliceByPowBar();
extern               void  GfpUT_FreePowBar();
extern               void  GfpUT_HrExtractPowBar();

#else

extern               void  UtPwB_Init(void);
#ifdef  MPH
extern uphfig_powbar_list *GfpUT_AddOPowBar(phfig_list *aPhFig,
												  long  aYPow,
												  char  aType);
extern uphfig_powbar_list *GfpUT_GetPowBar(phfig_list *aPhFig, long  aY);
extern uphfig_powbar_list *GfpUT_GetPowBarBottom(phfig_list *aPhFig);
extern uphfig_powbar_list *GfpUT_GetPowBarTop(phfig_list *aPhFig);
extern               long  GfpUT_GetSliceByPowBar(phfig_list *aPhFig,
													    long  aY);
extern               void  GfpUT_FreePowBar(phfig_list *aPhFig);
extern               void  GfpUT_HrExtractPowBar(phfig_list *aPhFig);
#endif

#endif
