

/* ******************* Interface of Module "UtTechno" ********************* */


#ifndef  __UtTec__
#define  __UtTec__


#define    C_UtTec_TypeUnknow   2
#define    C_UtTec_TypeCMOS2    3
#define    C_UtTec_TypeAsGa3    4
#define    C_UtTec_FamilyCMOS   2
#define    C_UtTec_FamilyAsGa   3


/* Structure holding all topologicals data associated to a techno.
 */
typedef struct {
  long  Type;          /* Type of technology.                   */
  long  PowerLayer;    /* Layer of the power supplies.          */
  long  PowerWideVDD;  /* Wide of the VDD power.                */
  long  PowerWideVSS;  /* Wide of the VDD power.                */
  long  SliceHeight;   /* Height of the slice.                  */
  long  ThruLayer;     /* Layer of horizontal feed through.     */
  long  ThruPitch;     /* Feed through vertical pitch.          */
  long  ThruWide;      /* Wide of horizontal feed through.      */
  long  ThruNB;        /* Number of feed through per slice.     */
  long  ThruTop;       /* Fist feed through from the top AB.    */
  long  ThruBot;       /* Fist feed through from the bottom AB. */
  char  LibrarySuffix; /* Suffix of the leaf cells.             */
  } UtTec_V_t;


UtTec_V_t  UtTec_V;


#  ifndef  ANSI_PROTO

extern void  UtTec_Init();
extern long  UtTec_Family();

#  else

extern void  UtTec_Init( char *aPath );
extern long  UtTec_Family( void );

#  endif
#endif
