
## /*          Alliance CAD System 3.0                                   */
## /*             FpGen Package 1.05                                     */
## /*                                                                    */
## /*  Copyright(c) 93-95, MASI, CAO-VLSI Team                           */
## /*                                                                    */
## /*  Author      :          Jean-Paul CHAPUT                           */
## /*  E-mail      :      cao-vlsi@masi.ibp.fr                           */
## /* ------------------------------------------------------------------ */
## /*  fitpath.mk  :      Common macros for all FitPath tools.           */
## /* ****************************************************************** */
## /*  29/04/94:0.00:Jean-Paul CHAPUT:Initial design.                    */


# Access to binaries forgotten in $(MACHINE).mk
CP           =          cp
LN           =          ln
CAT          =          cat
ECHO         =          echo
CHMOD        =          chmod


## ******************* Generators  Specifics Variables ********************


# RFG, BSG and RSA includes and paths.
#FITMK_GRFINC = \
#	-I/users/outil1/rfg/labo/$(MACHINE)/include -DGRF_H='<grf603.h>'
#FITMK_GRFLIB = \
#	-L/users/outil1/rfg/labo/$(MACHINE)/lib             -lGrf603
#FITMK_GRFINC = -I/users/outil1/rfg/dev/include -DGRF_H='<grf603.h>'
#FITMK_GRFLIB = -L/users/outil1/rfg/dev/lib             -lGrf603
#FITMK_GBSINC = -I/users/outil1/bsg/dev/include -DGBS_H='<gbs200.h>'
#FITMK_GBSLIB = -L/users/outil1/bsg/dev/lib             -lGbs200

## The following headers been forgotted in the "libraries.mk".
GRF_H = grf604.h
GBS_H = gbs201.h
#GGA_H = gga300.h
GRF_L = -lGrf604
GBS_L = -lGbs201


FITMK_GRFINC = -DGRF_H='<$(GRF_H)>'
FITMK_GRFLIB =           $(GRF_L)
FITMK_GBSINC = -DGBS_H='<$(GBS_H)>'
FITMK_GBSLIB =           $(GBS_L)
FITMK_RSAINC = -DRSA_H='<$(GGA_H)>'
FITMK_RSALIB =           $(GGA_L)


## ********************* Alliance Specifics Variables *********************


# Current alliance(MBK) includes.
FITMK_ALCICP = -I$(ALLIANCE_INCLUDE)
FITMK_ALCILS = -DALLIANCE_VERSION=$(ALLIANCE_VERSION) \
			   -DMLO_H='<$(MLO_H)>' \
			   -DMPH_H='<$(MPH_H)>' \
			   -DMUT_H='<$(MUT_H)>' \
			   -DMGN_H='<$(MGN_H)>' \
			   -DAPR_H='<$(APR_H)>' \
			   -DBEH_H='<$(BEH_H)>' \
			   -DLOG_H='<$(LOG_H)>' \
			     $(FITMK_GRFINC)    \
			     $(FITMK_GBSINC)    \
			     $(FITMK_RSAINC)
FITMK_ALCINC =   $(FITMK_ALCICP) \
			     $(FITMK_ALCILS)


# Alliance(MBK) libraries to link with.
FITMK_ALCLBP = -L$(ALLIANCE_LIB)
FITMK_ALCGGN = $(FITMK_GRFLIB) \
			   $(FITMK_GBSLIB) \
			   $(FITMK_RSALIB)
FITMK_ALCVBE = $(BVL_L) \
			   $(BEH_L) \
			   $(LOG_L)
FITMK_ALCAPR = $(APR_L)
FITMK_ALCMGN = $(MGN_L)
FITMK_ALCMLO = $(MLU_L) \
			   $(MLO_L) \
			   $(MAL_L) \
			   $(MCL_L) \
			   $(MEL_L) \
			   $(MHL_L) \
			   $(MSL_L) \
			   $(MVL_L)
FITMK_ALCMPH = $(MPU_L) \
			   $(MPH_L) \
			   $(MAP_L) \
			   $(MCP_L) \
			   $(MMG_L) \
			   $(MUT_L)
FITMK_ALCICN = $(ICU_L) \
			   $(ICC_L) \
			   $(ICA_L) \
			   $(ICN_L) \
			   -lm


# Standart C compilation variables.
FITMK_CFLAGS = -O -c -D$(MACHINE)
FITMK_OFLAGS = -s -o


## ******************* FitPath Tool Specifics Variables *******************


# C-Shell to use whith the FpGen batch.
FITMK_FPGCSH = csh
# Versions of FitPath libraries.
FITMK_FGNVER = 105
FITMK_GFPVER = 105
# Versions of DPR binaries.
FITMK_DPRVER = 5.3
FITMK_DPPVER = VRR

# Standart settings for Fitpath includes.
FITMK_FITIDP = -I$(HOME)/dev/include
FITMK_FITIMP = -I$(HOME)/labo/$(MACHINE)/include
FITMK_FITILS = -DFGN_H='<fgn$(FITMK_FGNVER).h>' \
			   -DGFP_H='<gfp$(FITMK_GFPVER).h>'
FITMK_FITINC = -I../include $(FITMK_FITILS)

# Standarts settings for Fitpath libraries.
FITMK_FITLDP = -L$(HOME)/dev/lib
FITMK_FITLMP = -L$(HOME)/labo/$(MACHINE)/lib
FITMK_FITLLS =     -lFgn$(FITMK_FGNVER) \
				   -lGfp$(FITMK_GFPVER)
FITMK_FITLIB = -L../lib $(FITMK_FITLLS)
