

/* ************** Interface of Module "UtFileDPR" *************** */


#define   C_UtFDP_SideTypeUnknow           32L
#define   C_UtFDP_SideTypeDefault          16L
#define   C_UtFDP_SideTypeNorth             1L
#define   C_UtFDP_SideTypeSouth             2L
#define   C_UtFDP_SideTypeEast              4L
#define   C_UtFDP_SideTypeWest              8L
#define   C_UtFDP_SliceTypeUnknow          -2
#define   C_UtFDP_SliceTypeDefault         -1  
#define   C_UtFDP_TrackTypeUnknow       -1024
#define   C_UtFDP_TrackTypeDefault      -1025
#define   C_UtFDP_TrackTypeNumber       -1026
#define   F_UtFDP_FlagLoFigKeep             1


/* This structure append to a logical connector some informations
 * about his associated physical connector.
 *     More than one physical connector can correspond to a logical
 * one.
 */
typedef struct ulocon_place {
				   long  SIDE;   /* Side  of the physical connector. */
				   long  SLICE;  /* Slice of the physical connector. */
				   long  TRACK;  /* Track of the physical connector. */
	struct ulocon_place *NEXT;   /* Next physical connector.         */
	} ulocon_place_list;


/* The two next structures append to a logical figure some informations
 * about his associated physical figure.
 */
typedef struct {
	long  DY1;  /* Number of lambda to add to the bottom of the AB. */
	long  DY2;  /* Number of lambda to add to the top    of the AB. */
	} lofig_ab;

typedef struct {
	long  NUMB;  /* Number of vertical power refreshment. */
	long  WIDE;  /* wide of the power refresment.         */
	} ulofig_power;

typedef struct {
	long  CPC;    /* Number of Cells per column.   */
	long  ITER;   /* Number of iterations.         */
	long  WIDE;   /* Number of slices of the bloc. */
	} ulofig_glue;

typedef struct {
	long  FLAGS; /* Flags associated to the instance. */
	} ulofig_flags;

typedef struct {
	long  SIDE;  /* Side of the instance where the power will be set. */
	long  WIDE;  /* wide of the power refresment.                     */
	} uloins_power;


#ifndef  ANSI_PROTO

extern         void  UtFDP_Init();
extern         void  UtFDP_AddLoConPlace();
extern         void  UtFDP_FreeLoConPlace();
extern         void  UtFDP_AddLoFigAB();
extern         void  UtFDP_DelLoFigAB();
extern         void  UtFDP_AddLoFigPower();
extern         void  UtFDP_DelLoFigPower();
extern         void  UtFDP_AddLoFigGlue();
extern  ulofig_glue *UtFDP_GetLoFigGlue();
extern         void  UtFDP_DelLoFigGlue();
extern         void  UtFDP_SetLoFigFlags();
extern ulofig_flags *UtFDP_GetLoFigFlags();
extern         void  UtFDP_DelLoFigFlags();
extern         void  UtFDP_AddLoInsPower();
extern         void  UtFDP_DelLoInsPower();
extern         void  UtFDP_LoadPlacement();

#else

extern         void  UtFDP_Init(void);
extern         void  UtFDP_AddLoConPlace(locon_list *aLoCon,
											   char  aSide ,
											   long  aSlice,
											   long  aTrack);
extern         void  UtFDP_DefLoConPlace(locon_list *aLoCon,
											   char  aSide ,
											   long  aSlice,
											   long  aTrack);
extern         void  UtFDP_FreeLoConPlace(locon_list *aLoCon);
extern         void  UtFDP_AddLoFigAB(lofig_list *aLoFig,
										    long  aDY1,
										    long  aDY2);
extern         void  UtFDP_DelLoFigAB(lofig_list *aLoFig);
extern         void  UtFDP_AddLoFigGlue(lofig_list *aLoFig,
											  long  aIter,
											  long  aWide,
											  long  aCPC);
extern  ulofig_glue *UtFDP_GetLoFigGlue(lofig_list *aLoFig);
extern         void  UtFDP_DelLoFigGlue(lofig_list *aLoFig);
extern         void  UtFDP_SetLoFigFlags(lofig_list *aLoFig, long  aFlags);
extern ulofig_flags *UtFDP_GetLoFigFlags(lofig_list *aLoFig);
extern         void  UtFDP_DelLoFigFlags(lofig_list *aLoFig);
extern         void  UtFDP_AddLoFigPower(lofig_list *aLoFig,
											   long  aPower,
											   long  aWide);
extern         void  UtFDP_DelLoFigPower(lofig_list *aLoFig);
extern         void  UtFDP_AddLoInsPower(lofig_list *aLoIns,
											   long  aSide,
											   long  aWide);
extern         void  UtFDP_DelLoInsPower(lofig_list *aLoIns);
extern         void  UtFDP_LoadPlacement(char *aFigName);

#endif
