/* ###-----------------------------------------------------------### */
/*    file  : abl.y                                                  */
/*    description : analyse syntaxicale d'une fonction booleen       */
/*    date  : 17.01.95                                               */
/*    AUtor : Behzad SAFARI                                          */
/* ###-----------------------------------------------------------### */

%{
#include <stdio.h>
#include MUT_H
#include "lex.h"

#define abl(DATA,NEXT) chain_list(NEXT,DATA) 
#define addabl(DATA, NEXT) addchain(NEXT, DATA)

%}

%union { 
	char *s;
       chain_list  *ch;
       }

%token <s> ID


%right _OR _AND _XOR 
%right _NOT _STABLE

%type <ch> exp
%type <s> _AND
%type <s> _OR
%type <s> _NOT
%type <s> _XOR
%type <s> _STABLE

%%


line : exp
     ;


exp   : ID           {$$ = ablatom($1,NULL);}
      | exp _OR exp   {$$ = ablor($1,$3);} 
      | exp _AND exp  {$$ = abland($1,$3);} 
      | exp _XOR exp  {$$ = ablxor($1,$3);} 
      | _NOT     exp  {$$ = ablnot(NULL,$2);} 
      | _STABLE  exp  {$$ = ablstable(NULL,$2);} 
      | '(' exp ')'  {$$ = $2;} 
      ;

%%
