/*************************************************************************/
/*                                                                       */
/*                   Chaine de CAO & VLSI   Alliance                     */
/*                                                                       */
/* Produit : lca (Logic Cells Array) to vbe (VHDL behavioral desciption) */
/*           parser			       			         */
/*    Fichier :  parser.c					         */
/*    (c) copyright 1994 Laboratoire MASI equipe CAO & VLSI              */
/*    Tous droits reserves                                               */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                              */
/*                                                                       */
/*    Auteur(s)   :  Eudes Prado Lopes                  le : 25/11/94    */
/*    Modifie par :  Eudes Prado Lopes                  le : 09/12/1994  */
/*    Modifie par :  Safari Astaraie Behzad             le : 18/01/1995  */
/*                                                                       */
/*************************************************************************/

#include <stdio.h>

#include MUT_H
#include LOG_H
#include MLO_H
#include BEH_H
#include BVL_H
#include BHL_H

#include "lca2vbe.h"
#include "fp_type.h"
#include "lex.h"


/*---------------------------------------------------------------------------
myAlloc     : Alloue de la mmoire.
-------------------------------------------
parametres  : taille du bloc mmoire demand.
-------------------------------------------
return      : pointeur sur le bloc demand .
---------------------------------------------------------------------------*/
void *myAlloc(size)
int size ;
{
void *pt ;

pt = (void *)malloc(size) ;
if(pt == NULL)
	{
	printf("EREUR SYSTEME : Place mmoire insuffisante\n") ;
	printf("\tQuiter les autres applications et relancer le programme\n") ;
	exit(-1) ;
	}
return(pt) ;
}

/* ------------------------------------------------------------------------
getligne :recharge une ligne	
-------------------------------------------------------
parametres :	rien.
-------------------------------------------------------
return :  une chaine de caractere.
------------------------------------------------------------------------------*/
char *
getligne ()
{
  int i = 0;
  char *st = (char *) malloc (400);
  fgets (st, 400, finput);
  if (trace > 1)
    printf ("LEU >%s<\n", st);
  i = (int) strlen (st);
  if (i > 1)
    st[i - 1] = '\0';
  if (trace > 1)
    printf ("VIROU >%s<\n", st);
  if (feof (finput))
    {
      return(NULL);
    }
  return st;
}



/*------------------------------------------------------------------------------
printAux	:	Print a String	/*------------------------------------------------------------------------------
parametres	: 	string
--------------------------------------------------------------------------------
return		:	nothing 
------------------------------------------------------------------------------*/
void printAux(aux)
char *aux;
{
printf("aux = >%s<\n",aux);
ch = getchar();
}



/*------------------------------------------------------------------------------
model		:	Read the model	/*------------------------------------------------------------------------------
parametres	: 	string
--------------------------------------------------------------------------------
return		:	nothing 
------------------------------------------------------------------------------*/

/*;:misex1.lca, MAP2LCA 3.30, Wed Nov  2 16:06:41 1994*/

void model(stri)
char *stri;
{
  char *pv, *filename, *extension, *tool, *version, *weekday, *month, *day, *hour, *year;
  char *aux;
  char *st = NULL;
  char *pbegin = NULL, *pend = NULL;
  int charac;

  
  pbegin = mbkalloc (100);
  pend = mbkalloc (100);

  if (trace > 1)
    {
      printf ("Entrou na funcao de tratamento do modelo com a string %s\n", stri);
      ch = getchar();
    }

  aux = namealloc ((char *) strtok (stri, ":"));
  if (trace > 1) printAux(aux);
  pv =  namealloc (aux);
  

  aux = namealloc ((char *) strtok (NULL, "."));
  if (trace > 1) printAux(aux);

  filename =  namealloc (aux);

  aux = namealloc ((char *) strtok (NULL, " "));
  if (trace > 1) printAux(aux);

  extension =  namealloc (aux);

  aux = namealloc ((char *) strtok (NULL, " "));
  if (trace > 1) printAux(aux);

  tool =  namealloc (aux);

  aux = namealloc ((char *) strtok (NULL, " "));
  if (trace > 1) printAux(aux);

  version =  namealloc (aux);

  aux = namealloc ((char *) strtok (NULL, " "));
  if (trace > 1) printAux(aux);

  weekday =  namealloc (aux);

  aux = namealloc ((char *) strtok (NULL, " "));
  if (trace > 1) printAux(aux);

  month =  namealloc (aux);

  aux = namealloc ((char *) strtok (NULL, " "));
  if (trace > 1) printAux(aux);

  day =  namealloc (aux);

  aux = namealloc ((char *) strtok (NULL, " "));
  if (trace > 1) printAux(aux);

  hour =  namealloc (aux);

  aux = namealloc ((char *) strtok (NULL, " "));
  if (trace > 1) printAux(aux);

  year =  namealloc (aux);

  if (trace)
    {
      printf ("monta->%s:%s%s %s %s %s %s %s %s %s\n", pv, filename, extension, tool, version, weekday, month, day, hour, year);
    }
}



 /*st =(char *)mbkstrdup(stri);
st =(char *)strtok(stri," ");
pend = (char *)strstr(st,".lca");
pbegin = (char *)strstr(st,":");
pbegin++;
if (pbegin[0] == ' ') pbegin++;
charac = (int)(pend - pbegin);
aux = (char *)strncpy(filename,pbegin, charac);

if (trace > 1)
  {
  printf("filename is>%s<\n",aux );
  ch = getchar();
  }


if (trace)
  {
  printf ("monta->%s %s %s\n",);
  }

_beh = beh_addbefig(NULL,filename);
*/  

/*------------------------------------------------------------------------------
design		:	Read the design	--------------------------------------------------------------------------------
parametres	: 	string
--------------------------------------------------------------------------------
return		:	nothing ------------------------------------------------------------------------------*/

void design(stri)
char *stri;
{
  char *Design, *aux;
  if (trace > 1)
    {
      printf ("Entrou na funcao de tratamento do design com a string %s\n", stri);
      ch = getchar();
    }
  aux = (char *)strtok (stri, " ");
  Design = (char *) strtok (NULL, " ");
  if (trace)
    printf ("monta->%s %s\n", aux, Design);
}



/*------------------------------------------------------------------------------
speed		:	Read the speed	--------------------------------------------------------------------------------
parametres	: 	string
--------------------------------------------------------------------------------
return		:	nothing ------------------------------------------------------------------------------*/

void speed(stri)
char *stri;
{
  char *Speed, *aux;
  if (trace > 1)
    {
      printf ("Entrou na funcao de tratamento da speed com a string %s\n", stri);
      ch = getchar();
    }
  aux =  (char *)strtok (stri, " ");
  Speed = (char *) strtok (NULL, " ");
  if (trace)
    printf ("monta->%s %s\n", aux, Speed);
}


/*----------------------------------------------------------------------------
displaymyTH	: vertical display of HT ------------------------------------------------------------------------------
retour		: nothing
------------------------------------------------------------------------------*/

 
/* affichage des elements de la table */

void displaymyTH(pTable)
pTH pTable;
{
int i;
pElemTH pEl;
pEl=pTable->pElem; 
printf("======================== DISPLAYTH ======================\n");
printf("length = %d\t		count = %d\n",pTable->length,pTable->count);
printf("=========================================================\n");
for (i=0;i<pTable->length;i++)
    {
    if (pEl->value != EMPTYTH && pEl->value !=DELETETH)
       {
       printf("index  %d\t",i);
       printf("key  >%s<\t",pEl->key);
       printf("value >%s<\n", pEl->value);
       }
    pEl++;
    }
}

/*------------------------------------------------------------------------------
addnet		:	Read the addnet	--------------------------------------------------------------------------------
parametres	: 	string
--------------------------------------------------------------------------------
return		:	nothing ------------------------------------------------------------------------------*/

void addnet (stri)
     char *stri;
{

  char *pin, *aux;
  char *signal;


  pin = mbkalloc (20);
  signal = mbkalloc (20);


  if (trace > 1)
    {
      printf ("Entrou na funcao de tratamento do addnet com a string %s\n", stri);
      printf ("discard first token -> Addnet\n");
    }
  aux =  (char *)strtok (stri, " ");
  if (trace > 1)
    {
      printf ("primeiro token = %s\n", aux);
      printf ("Second Token is the name of the signal\n");
    }
  signal = (char *) strtok (NULL, " ");
  if (trace)
    printf ("monta->%s %s", aux, signal);
  if (trace > 1)
    {
      printf ("carregou o segundo token = %s\n", signal);
      printf ("From the third Token to the end of line the names of the pins:\n");
    }
  pin = (char *) strtok (NULL, " ");
      if (trace)
	printf (" %s", pin);
  if (trace > 1)
    printf ("terceiro e %s\n", pin);


  addTH (pin_sigTH, namealloc (pin), namealloc (signal));

  if (trace > 1)
    printf ("Acrescentou o prim. pino  value  %s a pin_sigTH com chave %s\n", signal, pin);

  while (pin = (char *) strtok (NULL, " "))
    {
      addTH (pin_sigTH, namealloc (pin), namealloc (signal));
      if (trace)
	printf (" %s", pin);
    }
  if (trace)
    printf ("\n");
}





/*------------------------------------------------------------------------------
typeLex : return the type of the character
-------------------------------------------------------
parametres :	string
-------------------------------------------------------
return : m D S A N B C d Q n E
------------------------------------------------------------------------------*/
char *typeLex(stri)
char *stri;
{ 
char c;
int   countletter = 0;
if (trace > 1) 
  {
   printf("Entrou na Typelex com  %s\n",stri);
   printf("%c",stri[countletter]);
   printf("strncmp deu  %d\n",strncmp(stri,stri,2));
   printf("strncmp deu  %d\n",strncmp(stri,"--",2));
   ch = getchar();
  }
c = (char)stri[countletter];
switch (c)
{
case ';' : if (!strncmp(stri,";:",2)) return namealloc("m");
           else return  namealloc("E");
	break;
case 'D' : if (!strncmp(stri,"Design",6)) return namealloc("D");
           else return  namealloc("E");
	break;
case 'S' : if (!strncmp(stri,"Speed",5)) return namealloc("S");
           else return  namealloc("E");
	break;
case 'A' : if (!strncmp(stri,"Addnet",6)) return namealloc("A");
           else return  namealloc("E");
	break;
case 'N' : if (!strncmp(stri,"Nameblk",7)) return namealloc("N");
           else return  namealloc("E");
	break;
case 'B' : if (!strncmp(stri,"BASE",4)) return namealloc("B");
           else return  namealloc("E");
	break;
case 'C' : if (!strncmp(stri,"CONFIG",6)) return namealloc("C");
           else return  namealloc("E");
	break;
case 'E' : switch (stri[countletter+1])
	{
	case 'd' :if (!strncmp(stri,"Editblk",7)) return namealloc("d");
           else return  namealloc("E");
		break;
	case 'Q' : if (!strncmp(stri,"EQUATE F",8)) return namealloc("F");
                   else if (!strncmp(stri,"EQUATE G",8)) return namealloc("G");
                               else return  namealloc("E");
		                    break;
	case 'n' : if (!strncmp(stri,"Endblk",6)) return namealloc("e");
           else return  namealloc("E");
		break;
	}
default : return namealloc("E");
}

}



/*------------------------------------------------------------------------------
_token :		reading  tokens.
--------------------------------------------------------------------------------
parametres :	nothing.
--------------------------------------------------------------------------------
return :	char *
------------------------------------------------------------------------------*/
char *_token()
{
static int cptCar=0;
char *tok;
int i;
char *typeline;
int compteur;

tok = mbkalloc(100);

/* get the line */

linha = NULL;
if (linha == NULL)
   {
   cptCar = 0;
   compteur = cptCar;
   linha = getligne();
   if (linha == NULL)
      {
      printf("EOF : empty file ..");
      return(NULL);
      }
   }
else
   compteur = cptCar;

	/* suppression des blancs */

for (; isspace(linha[compteur]) ; compteur++);

while (linha[compteur] == '\0')	
   {
   cptCar = 0;
   compteur = cptCar;
   linha = getligne();
   if (linha == NULL)
      {
      printf("EOF : empty file ..");
      printf("token retorna NULL pois linha = >%s<\n", linha);
      return(NULL);
      }
   for (; isspace(linha[compteur]) ; compteur++);
   }

i = compteur;

typeline = typeLex(linha);

if (trace > 1) 
  {
  printf("linha = >%s< e token retorna = >%s<\n", linha, typeline);
  ch = getchar();
  }

return(typeline);
}

/*------------------------------------------------------------------------------
treatblk	:	Read the nameblk	--------------------------------------------------------------------------------
parametres	: 	nothing
--------------------------------------------------------------------------------
return		: 	nothing ------------------------------------------------------------------------------*/

void treatblk()
{
  char *INBLK;
  char *OUTBLK;
  char  *TRI;
  char *Placeblk;
  char *Nameblk;
  char *Editblk;
  char *BASE;
  char *CONFIG, *X, *Y, *RSTDIR, *ENCLK, *DX, *DY, *CLK, *F, *G;
  char *EQUATEF, *EQUATEG;
  char *Endblk;
  char *PIN;
  char *PINX;
  char *PINY;
  char *EQUATION;
  char *auxblk;
  char *aux, *aux1, *bloco, *dado;
  char c, c1;
  int emptydata, fim;

if (trace > 1) 
  {
  printf ("****************************************************** \n");
  printf (" TRATA UM BLOCO \n");
  ch = getchar();
  }


/*------------------------------------------------------------------------------
nameblk		:	Read the Nameblk	--------------------------------------------------------------------------------*/

if (trace > 1)
    printf ("Tratamento do nameblk com a string >%s<\n", linha);
tok = (char *)strtok (linha, " ");
Placeblk = namealloc ((char *) strtok (NULL, " "));
Nameblk = namealloc ((char *) strtok (NULL, " "));


if (trace)
  {
  printf ("monta->%s %s %s\n",tok, Placeblk, Nameblk);
  }
  /*------------------------------------------------------------------------------
editblk		:	Read the editblk	--------------------------------------------------------------------------------*/

  tok = _token ();
if (trace > 1)
    printf ("Tratamento do editblk com a string >%s<\n", linha);
  tok = (char *)strtok (linha, " ");
  Editblk = namealloc ((char *) strtok (NULL, " "));
  auxblk = namealloc(Editblk);

if (trace)
  {
  printf ("monta->%s %s \n",tok, Editblk);
  }

  /*------------------------------------------------------------------------------
base		:	Read the base	--------------------------------------------------------------------------------*/

  tok = _token ();
if (trace > 1)
  { 
  printf ("Tratamento de BASE com a string >%s<\n", linha);
  ch = getchar();
  printf ("discard first token -> BASE\n");
  }

  tok = (char*) strtok (linha, " ");
  BASE = namealloc ((char *) strtok (NULL, " "));

if (trace)
  { 
  printf ("monta->%s %s \n",tok, BASE);
  }

/*------------------------------------------------------------------------------
config		:	Read the config if exists	--------------------------------------------------------------------------------*/
  /* CONFIG X:F Y:G RSTDIR: ENCLK: DX: DY: CLK: F:A:B:C:D G:A:B:C:E ou
     CONFIG IN: OUT:O TRI: */

tok = _token ();
if (tok == namealloc ("C"))
  {
    X = NULL;
    Y = NULL;
    RSTDIR = NULL;
    ENCLK = NULL;
    DX = NULL;
    DY = NULL;
    CLK = NULL;
    F = NULL;
    G = NULL;
    INBLK = NULL;
    OUTBLK = NULL;
    TRI = NULL;

    if (trace > 1)
      printf ("Tratamento de CONFIG  com a string >%s<\n", linha);

    tok = (char *) strtok (linha, " ");

    emptydata = TRUE;
    dado = (char *) TRUE;
    fim = FALSE;
    while (!fim)
      {
	while (emptydata && dado)	/* Discard Empty data fields */
	  {
	    dado = namealloc ((char *) strtok (NULL, " "));
	    if (trace > 1)
	      printf ("Tratanovo bloco  >%s<\n", dado);
	    if (dado)
	      if (trace > 1)
		printf ("dado[strlen(dado)-1]>%c<\n", dado[strlen (dado) - 1]);
	    if (dado && dado[strlen (dado) - 1] != ':')
	      {
		if (trace > 1)
		  printf ("achou um nao vazio>%s<\n", dado);
		if (trace > 1)
		  printf ("dado>%s<\n", dado);
		emptydata = !emptydata;
	      }
	  }
	if (!dado)
	  break;
	if (trace > 1)
	  printf ("Achou um nao vazio >%s< \n ", dado);
	c = (char) dado[0];
	c1 = (char) dado[1];

	dado = (char *) (strstr (dado, ":") + 1);
	if (trace > 1)
	  printf ("cortou dado = >%s<\n", dado);
	if (trace > 1)
	  ch = getchar();
	emptydata = TRUE;
	switch (c)
	  {
	  case 'x':
	    if (trace > 1)
	      printf ("Trata X >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    X = namealloc (dado);
	    break;

	  case 'y':
	    if (trace > 1)
	      printf ("Trata Y >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    Y = namealloc (dado);
	    break;

	  case 'r':
	    if (trace > 1)
	      printf ("Trata RSTDIR >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    RSTDIR = namealloc (dado);
	    break;

	  case 'e':
	    if (trace > 1)
	      printf ("Trata ENCLK >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    ENCLK = namealloc (dado);
	    break;

	  case 'd':
	    if (c1 == 'x')
	      {
		if (trace > 1)
		  printf ("Trata DX >%s<\n", dado);
		DX = namealloc (dado);
	      }
	    else if (c1 == 'y')
	      {
		if (trace > 1)
		  printf ("Trata DY >%s<\n", dado);
		DY = namealloc (dado);
	      }
	    else
	      {
	       printf ("ERROR: >%s< UNKNOWN\n", dado);
	       fim = TRUE;
	      }
	    break;

	  case 'c':
	    if (trace > 1)
	      printf ("Trata CLK >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    CLK = namealloc (dado);
	    break;

	  case 'f':
	    if (trace > 1)
	      printf ("Trata F >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    F = namealloc (dado);
	    break;

	  case 'g':
	    if (trace > 1)
	      printf ("Trata G >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    G = namealloc (dado);
	    fim = TRUE;
	    break;

	  case 'i':
	    if (trace > 1)
	      printf ("Trata I >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    INBLK = namealloc (dado);
	    fim = TRUE;
	    break;

	  case 'o':
	    if (trace > 1)
	      printf ("Trata O >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    OUTBLK = namealloc (dado);
	    fim = TRUE;
	    break;

	  case 't':
	    if (trace > 1)
	      printf ("Trata T >%s<\n", dado);
	    if (trace > 1)
	      printf ("dado >%s<\n", dado);
	    TRI = namealloc (dado);
	    fim = TRUE;
	    break;

	  default:
	    printf ("ERROR: >%s< UNKNOWN\n", dado);
	    fim = TRUE;
	  }
      }

    if (BASE == namealloc ("IO") && trace)
      printf ("monta->CONFIG INBLK:%s OUTBLK:%s TRI:%s\n", INBLK, OUTBLK, TRI);
    else if ((BASE == namealloc ("F") ||
	      BASE == namealloc ("G") ||
	      BASE == namealloc ("FG") |
	      BASE == namealloc ("FGM")) && trace)
      printf ("monta->CONFIG X:%s Y:%s RSTDIR:%s ENCLK:%s DX:%s DY:%s CLK:%s F:%s G:%s\n",
	      X, Y, RSTDIR, ENCLK, DX, DY, CLK, F, G);
    if (trace > 1)
      ch = getchar();
  }




/*------------------------------------------------------------------------------
equate		:	Read the equate if exists	--------------------------------------------------------------------------------*/

 

if (trace > 1)
  {
    printf ("BASE =  >%s< \n", BASE);
    ch = getchar();
  }
if (BASE != namealloc ("IO"))
  {
    if (trace > 1)
      printf ("Vai ler EQUATE \n");
    if (trace > 1)
      printf ("BASE =  >%s< \n", BASE);
    if (BASE == namealloc ("FG"))
      {
        if (trace > 1)
      	  printf ("BASE =  >%s< \n", BASE);
	tok = _token ();
	if (trace > 1)
	  printf ("Tratamento de EQUATE  com a string >%s<\n", linha);
	if (trace > 1)
	  printf ("discard first token -> EQUATE F=\n");
	aux = namealloc (strtok (linha, "="));
	if (trace > 1)
	  printf ("token = >%s<\n", aux);
	if (aux == namealloc ("EQUATE F"))
	  {
	    EQUATEF = namealloc ((char *) strtok (NULL, " "));
	    if (trace > 1)
	      printf ("EQUATEF = >%s< \n", EQUATEF);
	    tok = _token ();
	    if (trace > 1)
	      printf ("discard first token -> EQUATE G=\n");
            aux = namealloc (strtok (linha, "="));
	    if (trace > 1)
	      printf ("token = >%s<\n", aux);
	    EQUATEG = namealloc ((char *) strtok (NULL, " "));
	    if (trace > 1)
	      printf ("EQUATEG = >%s< \n", EQUATEG);
	  }
	else if (aux == namealloc ("EQUATE G"))
	  {
	    EQUATEG = namealloc ((char *) strtok (NULL, " "));
	    if (trace > 1)
	      printf ("EQUATEG = >%s< \n", EQUATEG);
	    tok = _token ();
	    if (trace > 1)
	      printf ("discard first token -> EQUATE F=\n");
	    aux = namealloc (strtok (linha, "="));
	    if (trace > 1)
	      printf ("token = >%s<\n", aux);
	    EQUATEF = namealloc ((char *) strtok (NULL, " "));
	    if (trace > 1)
	      printf ("EQUATEF = >%s< \n", EQUATEF);
	  }
      }
    else if (BASE == namealloc ("F"))
      {
	if (trace > 1)
	  printf ("BASE =  >%s< \n", BASE);
	tok = _token ();
	if (trace > 1)
	  printf ("Tratamento de EQUATE  com a string >%s<\n", linha);
	if (trace > 1)
	  printf ("discard first token -> EQUATE F=\n");
	aux = namealloc (strtok (linha, "="));
	if (trace > 1)
	  printf ("token = >%s<\n", aux);
	EQUATEF = namealloc ((char *) strtok (NULL, " "));
	EQUATEG = NULL;
	if (trace > 1)
	  printf ("EQUATEF = >%s< \n", EQUATEF);
      }
    else if (BASE == "G")
      {
	if (trace > 1)
	  printf ("BASE =  >%s< \n", BASE);
	tok = _token ();
	if (trace > 1)
	  printf ("Tratamento de EQUATE  com a string >%s<\n", linha);
	if (trace > 1)
	  printf ("discard first token -> EQUATE G=\n");
	aux = namealloc (strtok (linha, "="));
	if (trace > 1)
	  printf ("token = >%s<\n", aux);
	EQUATEG = namealloc ((char *) strtok (NULL, " "));
	EQUATEF = NULL;
	if (trace > 1)
	  printf ("EQUATEG = >%s< \n", EQUATEG);
      }
    if (trace > 1)
      printf ("FIM do Tratamento de EQUATE\n");
    if (trace)
      {
	printf ("monta EQUATE F=>%s<\n", EQUATEF);
	printf ("monta EQUATE G=>%s<\n", EQUATEG);
      }
  }

else
  /* BASE ="IO" */
  {
    if (trace > 1)
      {
      printf ("Trata-se de block IO \n");
      ch = getchar();
      }
  }

    


/*------------------------------------------------------------------------------
endblk		:	Read the endblk	--------------------------------------------------------------------------------*/
 


if (trace > 1)
  {
    printf ("Vai ler a linha : Endblk\n");
    printf ("discard first token -> Endblk\n");
  }

tok = _token ();
Endblk = (char *) linha;
if (trace)
  {
    printf ("monta->%s< \n", Endblk);
  }

/*------------------------------------------------------------------------------
Load pin_equTH 
------------------------------------------------------------------------------*/
/*
char *Placeblk;
char *Nameblk;
char *Editblk;
char *BASE;
char *CONFIG, *X, *Y, *RSTDIR, *ENCLK, *DX, *DY, *CLK, *F, *G;
char *EQUATEF, *EQUATEG;
char *Endblk;
char *PIN;
char *EQUATION;
*/


if (trace >1)
  printf ("Vai carregar pin_equTH \n");
if (trace > 1)
  {
    printf ("BASE = >%s<\n", BASE);
    printf ("X = >%s<\n", X);
  }

PIN = (char *) namealloc (NULL);
if (BASE == namealloc ("FG"))
  {
      if (X == namealloc ("QX"))
      {
	PIN = (char *) (mbkstrdup (Placeblk));
	PIN = namealloc (strcat (PIN, namealloc(".X")));
	addTH (pin_regTH, namealloc(PIN), namealloc(EQUATEF));

	/* ###--------------------------------------### */
	/*    FAL_ED : front descendant                 */
	/*    RIS_ED : front montant                    */
	/* ###--------------------------------------### */
            if (strcasecmp(CLK,"K:NOT") == 0)
              {
	      PIN = (char *) (mbkstrdup (Placeblk));
	      PIN = namealloc (strcat (PIN, ".K"));
              addTH (pin_ckTH,namealloc(PIN),(char *)"FAL_ED");
              }
            else
              {
	      PIN = (char *) (mbkstrdup (Placeblk));
	      PIN = namealloc (strcat (PIN, ".K"));
              addTH (pin_ckTH,namealloc(PIN),(char *)"RIS_ED");
              }
      }
     if ((X == namealloc ("F")) || (X == namealloc ("Qx")))
      {
	PIN = (char *) (mbkstrdup (Placeblk));
	PIN = namealloc (strcat (PIN, ".X"));
	addTH (pin_equTH, namealloc(PIN), namealloc(EQUATEF));
      }
      if (Y == namealloc ("QY"))
      {
	PIN = (char *) (mbkstrdup (Placeblk));
	PIN = namealloc (strcat (PIN, namealloc(".Y")));
	addTH (pin_regTH, namealloc(PIN), namealloc(EQUATEG));
            if (strcasecmp(CLK,"K:NOT") == 0)
              {
	      PIN = (char *) (mbkstrdup (Placeblk));
	      PIN = namealloc (strcat (PIN, ".K"));
              addTH (pin_ckTH,namealloc(PIN),(char *)"FAL_ED");
              }
            else
              {
	      PIN = (char *) (mbkstrdup (Placeblk));
	      PIN = namealloc (strcat (PIN, ".K"));
              addTH (pin_ckTH,namealloc(PIN),(char *)"RIS_ED");
              }

      }

        if ((Y == namealloc ("G")) || (Y == namealloc ("QY")))
      {
	PIN = (char *) (mbkstrdup (Placeblk));
	PIN = namealloc (strcat (PIN, ".Y"));
	addTH (pin_equTH, namealloc(PIN), namealloc(EQUATEG));
      }
  }

if (BASE == namealloc ("F"))
  {
      if (X == namealloc ("QX"))
      {
	PIN = (char *) (mbkstrdup (Placeblk));
	PIN = namealloc (strcat (PIN, namealloc(".X")));
	addTH (pin_regTH, namealloc(PIN), namealloc(EQUATEF));
            if (strcasecmp(CLK,"K:NOT") == 0)
              {
	      PIN = (char *) (mbkstrdup (Placeblk));
	      PIN = namealloc (strcat (PIN, ".K"));
              addTH (pin_ckTH,namealloc(PIN),(char *)"FAL_ED");
              }
            else
              {
	      PIN = (char *) (mbkstrdup (Placeblk));
	      PIN = namealloc (strcat (PIN, ".K"));
              addTH (pin_ckTH,namealloc(PIN),(char *)"RIS_ED");
              }
      }
        if ((X == namealloc ("F")) || (X == namealloc ("QX")))
      {
	PIN = namealloc (strcat (Placeblk, ".X"));
	addTH (pin_equTH, namealloc(PIN), namealloc(EQUATEF));
      }
  }

if (BASE == namealloc ("G"))
  {
      if (Y == namealloc ("QY"))  
      {
	PIN = (char *) (mbkstrdup (Placeblk));
	PIN = namealloc (strcat (PIN, namealloc(".Y")));
	addTH (pin_regTH, namealloc(PIN), namealloc(EQUATEG));
            if (strcasecmp(CLK,"K:NOT") == 0)
              {
	      PIN = (char *) (mbkstrdup (Placeblk));
	      PIN = namealloc (strcat (PIN, ".K"));
              addTH (pin_ckTH,namealloc(PIN),(char *)"FAL_ED");
              }
            else
              {
	      PIN = (char *) (mbkstrdup (Placeblk));
	      PIN = namealloc (strcat (PIN, ".K"));
              addTH (pin_ckTH,namealloc(PIN),(char *)"RIS_ED");
              }
      }

        if ((Y == namealloc ("G")) || (Y == namealloc("QY")))
      {
	PIN = namealloc (strcat (Placeblk, ".Y"));
	EQUATEG = namealloc (strtok (NULL, "\0"));
	addTH (pin_equTH, namealloc(PIN), namealloc(EQUATEG));
      }
  }

if (BASE == namealloc ("IO"))
  {
    if (INBLK == namealloc ("I"))
      PIN = namealloc (strcat (Placeblk, ".I"));
    if (OUTBLK == namealloc ("O") )
      PIN = namealloc (strcat (Placeblk, ".O"));
    if (OUTBLK == namealloc("O:NOT"))
      {
      PIN = namealloc(strcat (Placeblk, ".NO"));
      addTH (pin_sigTH, namealloc(PIN), namealloc (Nameblk));
      }
    if (TRI == namealloc ("T"))
      PIN = namealloc (strcat (Placeblk, ".T"));

    if (trace > 1)
      printf ("BASE = >%s<   IO PIN = >%s< \n", BASE, PIN);
    addTH (pin_equTH, namealloc(PIN), namealloc (Nameblk));
    if (trace > 1)
      printf (" carregou PIN = >%s<  Nameblk = >%s< \n ", PIN, namealloc (Nameblk));
  }

if (trace > 1)
  printf ("ACABOU DE CARREGAR UM BLOCK\n");
if (trace > 1)
  {
  printf("\n");
  printf("\n");
  displaymyTH (pin_equTH);
  ch = getchar();
  }
}



/*------------------------------------------------------------------------------
litteral	:	Read the outputs	--------------------------------------------------------------------------------
parametres	: 	a token
--------------------------------------------------------------------------------
return		:	nothing ------------------------------------------------------------------------------*/


chain_list *litteral(tok)
char *tok;
{
int l = strlen(tok) - 1;

if (!strcmp(tok,"1"))
   return createAtom("'1'");
if (!strcmp(tok,"1'"))
   return createAtom("'0'");
if (!strcmp(tok,"0"))
   return createAtom("'0'");
if (!strcmp(tok,"0'"))
   return createAtom("'1'");
if (tok[l] == '\'')
   {
   tok[l]='\0' ;
   return(notExpr(createAtom(tok)));
   }
else
   return(createAtom(tok));
}




/*------------------------------------------------------------------------------
displayBeh :Traitement des connecteurs de sortie apparaissant dans les ABL
--------------------------------------------------------------------------------
parametres :	befig,nb
--------------------------------------------------------------------------------
return :	void
------------------------------------------------------------------------------*/

void displayBeh(befig,nb)
befig_list *befig;
short nb;
{
berin_list *i;
beout_list *o;
bereg_list *r;
bebus_list *b;
beaux_list *a;
bepor_list *p;

fprintf(stderr,"----- display Befig (%s) -----\n",nb ? "comportementale" : "structurelle");
printf("  *********** BEFIG : %s *********\n",befig->NAME);
printf(" POR :\n");
for(p = befig->BEPOR;p;p = p->NEXT)
	{
	printf("   => %s = %c\n",p->NAME,p->DIRECTION);
	}
printf(" OUT :\n");
for(o = befig->BEOUT;o;o = o->NEXT)
	{
	printf("   => %s =",o->NAME);
	displayExpr(o->ABL);
	}
printf(" aux :\n");
for(a = befig->BEAUX;a;a = a->NEXT)
	{
	printf("   => %s =",a->NAME);
	displayExpr(a->ABL);
	}
printf(" BUS :\n");
for(b = befig->BEBUS;b;b = b->NEXT)
	{
	biabl_list *bi;

	printf("   => %s  ",b->NAME);
	for(bi = b->BIABL;bi;bi = bi->NEXT)
	    {
	    printf("VAL :",b->NAME);
	    displayExpr(bi->VALABL);
	    if (nb)
               {
	       printf("           CND :");
	       displayExpr(bi->CNDABL);
 	       }
	    }
	}
printf(" REG :\n");
for(r = befig->BEREG;r;r = r->NEXT)
	{
	biabl_list *bi;

	printf("   => %s  ",r->NAME);
	if (!nb)
	    displayExpr(r->BIABL->VALABL);
	else
	  for(bi = r->BIABL;bi;bi = bi->NEXT)
	    {
            printf("VAL = ");
	    displayExpr(bi->VALABL);
            printf("          CND = ");
	    displayExpr(bi->CNDABL);
	    }
	}
fprintf(stderr,"----- Fin displayBeh -----\n");
}



/*------------------------------------------------------------------------------
net		: Read a netlist and put it in a hash table ( netTH )	--------------------------------------------------------------------------------
parametres	: none
--------------------------------------------------------------------------------
return		: nothing ------------------------------------------------------------------------------*/

void net()
{
char *var;
chain_list *resul, *sortie;
beout_list *out;
int val;


strncpy(tok, _token(), 5);
if (trace > 1)
  printf("leu a string %s \n",tok);


if (!strcmp(tok,"auxil"))exit(1);


/*

void net()
{
char *var;
chain_list *resul, *sortie;
beout_list *out;
int val;

*/

		/* var1 */
if (!strcmp(tok,"1"))
   resul = createAtom("'1'");
else if (!strcmp(tok,"0"))
        resul = createAtom("'0'");
     else
        resul = (chain_list *)litteral(tok);

			/* var2 a varn */
tok = _token();
while(strcmp(tok,";"))
     {
     sortie = (chain_list *)litteral(tok);

     if (ATOM(sortie))
        var = VALUE_ATOM(sortie);
     else
        var = VALUE_ATOM(CADR(sortie));

     printf(".net : %s = ",var);
     if ((val = searchTH(outTH,var)) == EMPTYTH)
         {
         printf("net : pas une sortie !!!\n");
         exit(-1);
         }
     else
        {
        out = (beout_list *) val;

        if (ATOM(sortie))
           out->ABL = copyExpr(resul);
        else
           if (ATOM(resul) && !strcmp(VALUE_ATOM(resul),"'1'"))
              out->ABL = createAtom("'0'");
           else if (ATOM(resul) && !strcmp(VALUE_ATOM(resul),"'0'"))
                   out->ABL = createAtom("'1'");
                else
                   out->ABL = notExpr(copyExpr(resul));
        displayExpr(out->ABL);
        }
     tok = _token();
     }
freeExpr(resul);
tok = _token();		/* 1er token pour la suite */
}


/*------------------------------------------------------------------------------
input		:	Read the inputs	--------------------------------------------------------------------------------
parametres	: 	none
--------------------------------------------------------------------------------
return		:	nothing ------------------------------------------------------------------------------*/
void input()
{
tok = _token();
while (strcmp(tok,".outputs"))
   {
   while (strcmp(tok,";"))
     {
     _beh->BERIN = beh_addberin(_beh->BERIN,tok);
     _beh->BEPOR = beh_addbepor(_beh->BEPOR,tok,'I','B');
     tok = _token();
     }
   tok = _token();
   }
}

/*------------------------------------------------------------------------------
output		:	Read the outputs	--------------------------------------------------------------------------------
parametres	: 	none
--------------------------------------------------------------------------------
return		:	nothing 
------------------------------------------------------------------------------*/

void output()
{
tok = _token();
while (strcmp(tok,";"))
   {
   _beh->BEOUT = beh_addbeout(_beh->BEOUT,tok,NULL,NULL);
   _beh->BEPOR = beh_addbepor(_beh->BEPOR,tok,'O','B');
   addTH(outTH,(_beh->BEOUT)->NAME,_beh->BEOUT);
   tok = _token();
   }
tok = _token();
}




/*------------------------------------------------------------------------------
remplitTH :     met a 1 les OUT apparaissant dans les ABL de la befig.
-------------------------------------------------------
parametres :	ABL + Table de hash.
-------------------------------------------------------
return :	rien
------------------------------------------------------------------------------*/
void remplitTH(expr,auxTH)
chain_list *expr;
pTH auxTH;
{
if (expr)
   if (ATOM(expr) && searchTH(auxTH,VALUE_ATOM(expr)) != EMPTYTH)
	/* c'est une sortie */
      addTH(auxTH,VALUE_ATOM(expr),1);
   else
      while (expr = CDR(expr))
           remplitTH(CAR(expr),auxTH);
}

/*------------------------------------------------------------------------------
substOut :      la sortie "name" est renommee, son ABL devient name,
                un AUX de nom "name" est cree avec pour ABL, celui de la sortie
-------------------------------------------------------
parametres :	ABL + nom de la sortie a changer.
-------------------------------------------------------
return :	rien
------------------------------------------------------------------------------*/
void substOut(abl, name)
chain_list *abl;
char *name;
{
beout_list *out = _beh->BEOUT;

while (out && name != out->NAME)
    out = out->NEXT;
if (out)
   {
   char *chaine = (char *)malloc(strlen(name) + 10);
   char *chaux;
   bepor_list *por = _beh->BEPOR;

	/* creation du nouveau nom pour la sortie */
   sprintf(chaine,"%s_slifvbe",name);
   chaux = namealloc(chaine);
   free(chaine);

	/* nouveaux nom et ABL pour la sortie */
   out->NAME = chaux;
   out->ABL = createAtom(name);

	/* nouvel AUX */
   _beh->BEAUX = beh_addbeaux(_beh->BEAUX,name,abl,(struct node*)NULL);

	/* nouveau nom pour le port */
   while(por && name != por->NAME)
        por = por->NEXT;
   if (por)
      por->NAME = chaux;
   }
}

/*------------------------------------------------------------------------------
connectBeh :    Traitement des sorties apparaissanr dans les ABL
-------------------------------------------------------
parametres :	befig
-------------------------------------------------------
return :	rien (changement de la befig).
------------------------------------------------------------------------------*/
void connectBeh(befig)
befig_list *befig;
{
beout_list *out;
beaux_list *aux;
bereg_list *reg;
bebus_list *bus;
biabl_list *biabl;
bepor_list *por;
pTH auxTH = createTH(50);

printf("Recherche des sorties apparaissant dans les ABL ...\n");

	/* initialisation de TH avec les OUT a 0 */

out = befig->BEOUT;
while (out)
    {
    addTH(auxTH,out->NAME,0);
    out = out->NEXT;
    }

	/* parcours des OUT, AUX, BEREG et BEBUS pour remplissage de TH */
out = befig->BEOUT;
while (out)
   {
   remplitTH(out->ABL,auxTH);
   out = out->NEXT;
   }

aux = befig->BEAUX;
while (aux)
   {
   remplitTH(aux->ABL,auxTH);
   aux = aux->NEXT;
   }

reg = befig->BEREG;
while (reg)
   {
   biabl = reg->BIABL;
   while (biabl)
      {
      if (biabl->CNDABL && biabl->VALABL)
         {
         remplitTH(biabl->CNDABL,auxTH);
         remplitTH(biabl->VALABL,auxTH);
         }
      biabl = biabl->NEXT;
      }
   reg = reg->NEXT;
   }

bus = befig->BEBUS;
while (bus)
   {
   biabl = bus->BIABL;
   while (biabl)
      {
      if (biabl->CNDABL && biabl->VALABL)
         {
         remplitTH(biabl->CNDABL,auxTH);
         remplitTH(biabl->VALABL,auxTH);
         }
      biabl = biabl->NEXT;
      }
   bus = bus->NEXT;
   }

	/* parcours des OUT et traitement de ceux posant problemme */
out = befig->BEOUT;
while (out)
   {
   if (searchTH(auxTH,out->NAME) == 1)
      {
      printf("connectBeh : %s a changer\n",out->NAME);
      substOut(out->ABL,out->NAME);

/*  --- Methode changeant le type de la sortie en INOUT et ajoutant une entree

      por = befig->BEPOR;
      while(por && por->NAME != out->NAME)
           por = por->NEXT;
      if (por)
         {
         por->DIRECTION = 'B';
         befig->BERIN = beh_addberin(befig->BERIN,out->NAME);
         }
*/

      }
   out = out->NEXT;
   }
destroyTH(auxTH);

}



/*------------------------------------------------------------------------------
caseLine :     Segundo o tipo de linha trata de forma diferente
-------------------------------------------------------
parametres :	linha (char *)
-------------------------------------------------------
return :	nothing
------------------------------------------------------------------------------*/
void caseLine(t)
char *t;
{
 if (trace > 1)
    printf("entrou na caseline com o t=>%s<\n",t);
switch (t[0])
	{
	case 'm' : if (trace > 1) printf("leu o modelo\n"); model(linha); break;
	case 'd' : if (trace > 1) printf("leu o Design\n"); design(linha);break;
 	case 's' : if (trace > 1) printf("leu Speed\n"); speed(linha);break;
	case 'a' : if (trace > 1) printf("leu Addnet\n"); addnet(linha);break;	
	case 'n' : if (trace > 1) printf("leu Nameblk\n");treatblk(); break;	
    	}
}




/*------------------------------------------------------------------------------
displayAuxil() :   displays the list of auxiliary variables   
-------------------------------------------------------
parametres :	nothing
-------------------------------------------------------
return :	nothing
------------------------------------------------------------------------------*/

void displayAuxil(pTable)
pTH pTable;
{
int i;
char *auxil;
pElemTH pEl;
pEl=pTable->pElem;

auxil = namealloc("auxil");
printf("================== displayAuxil ================\n");
printf("length = %d\t		count = %d\n",pTable->length,pTable->count);
printf("=============================================\n");
for (i=0;i<pTable->length;i++)
    {
    if (pEl->value != EMPTYTH && 
        pEl->value !=DELETETH &&
        strncmp(pEl->value,"auxil",5) == 0 &&
        (pEl->key[3]=='x' || pEl->key[3]=='y' ) )
       {
       printf("index  %d\t",i);
       printf("key  >%s<\t",pEl->key);
       printf("value >%s<\n", pEl->value);
       }
    pEl++;
    }
}


/*------------------------------------------------------------------------------
char *equation(pin) :   substitute the name of a CLB pin by its signal name  
-------------------------------------------------------
parametres : pEl->key	
-------------------------------------------------------
return : equation (char *)
------------------------------------------------------------------------------*/
char *equation(pin)
char *pin;
{
int i;
char *eq, *neweq, *lblock, *sblock, *inputpin, *newpin;

chain_list *pt_abl	 ;

/*ch = getchar();*/
newpin = mbkalloc(50); 
newpin = (char *)mbkstrdup(pin);
neweq = mbkalloc(500);
/*printf("\n%s\n",(char *)searchTH(pin_equTH,pin));*/
eq = namealloc((char *)searchTH(pin_equTH,pin));

lblock = namealloc((char *)strtok(pin,"."));
sblock =  namealloc(lblock);
/*printf("lblock = >%s<\n",lblock);*/

/*ch = getchar();*/
neweq = NULL;
i = 0;
while (eq[i])
   {
   /*printf("eq[%d] = >%c<\n",i,eq[i]);*/
   switch (eq[i])
	{
	case '(' :  strcat(neweq,"("); break;
	case ')' :  strcat(neweq,")"); break;
 	case '+' :  strcat(neweq,"+"); break;
	case '*' :  strcat(neweq,"*"); break;
	case '@' :  strcat(neweq,"@"); break;
	case '~' :  strcat(neweq,"~");break;
	case ' ' :  strcat(neweq," "); break;
	case 'a' : inputpin = namealloc(strcat(lblock, ".a"));
                   strcat(neweq,(char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(lblock,".")); 
                   break;

	case 'b' : inputpin = namealloc(strcat(lblock, ".b")); 
                   strcat(neweq, (char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(lblock,"."));
                   break;
 
	case 'c' : inputpin = namealloc(strcat(lblock, ".c"));  
                   strcat(neweq, (char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(lblock,"."));
                   break;

	case 'd' : inputpin = namealloc(strcat(lblock, ".d")); 
                   strcat(neweq,(char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(lblock,"."));
                   break;	

	case 'e' : inputpin = namealloc(strcat(lblock, ".e"));  
                   strcat(neweq,(char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(lblock,"."));
                   break;
	}
   i++;
   }

neweq = namealloc(neweq);


return(neweq);
}

/* ###----------------------------------------------------### */
/*    fonction  : helpeq                                      */
/*    description : renvoie une chain de caractere contenant  */
/*    l'equation en fonction des entree(a,b,c,d,e).           */
/*    date  : 18.1.95                                         */
/* ###----------------------------------------------------### */

char *helpeq(pin)
char *pin;
{

char *eq;

eq = namealloc((char *)searchTH(pin_equTH,pin));

return eq;
}

/* ###----------------------------------------------------### */
/*    fonction  : helpeqreg                                   */
/*    description : renvoie une chain de caractere contenant  */
/*    l'equation en fonction des entree(a,b,c,d,e).           */
/*    date  : 18.1.95                                         */
/* ###----------------------------------------------------### */
char *helpeqreg(pin)
char *pin;
{

char *eq;

eq = namealloc((char *)searchTH(pin_regTH,pin));

return eq;
}

/* ###----------------------------------------------------### */
/*    fonction  : changenomSig                                */
/*    description : trouve le signal attache aux pin d'entree */
/*    d'une cellule, et met son nom dans le champs DATA de    */
/*    abl deja cree .                                         */
/*    date  : 20.1.95                                         */
/* ###----------------------------------------------------### */

void changenomSig(pt_abl,pin)
chain_list *pt_abl;
char *pin;

  {
  chain_list *p     ;
  char *lblock, *sblock, *inputpin;
  char *c;
  char chain[4];
 
  strcpy(chain,pin);
  lblock = (char *)strtok(chain,".");
 

  if(pt_abl -> NEXT == NULL)
    {

    c = pt_abl -> DATA;
    switch(c[0])
      {
      case 'a' : inputpin = namealloc(strcat(lblock, ".a"));
                 pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                 lblock = namealloc((char *)strtok(pin,"."));
                 break;

      case 'b' : inputpin = namealloc(strcat(lblock, ".b"));
                 pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                 lblock = namealloc((char *)strtok(pin,"."));
                 break;

      case 'c' : inputpin = namealloc(strcat(lblock, ".c"));
                 pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                 lblock = namealloc((char *)strtok(pin,"."));
                 break;

      case 'd' : inputpin = namealloc(strcat(lblock, ".d"));
                 pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                 lblock = namealloc((char *)strtok(pin,"."));
                 break;

      case 'e' : inputpin = namealloc(strcat(lblock, ".e"));
                 pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                 lblock = namealloc((char *)strtok(pin,"."));
                 break;

      case 'q' :if (c[1] == 'x') 
                 {
                   {
                   inputpin = namealloc(strcat(lblock, ".x"));
                   pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(pin,"."));
                   }
                break;
                 }
               if (c[1] == 'y') 
                 {
                   {
                   inputpin = namealloc((char *)strcat(lblock, ".y"));
                   pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(pin,"."));
                   }
               break;
                 }
      }
    } 
      else 
       {
       c = ((char *)((chain_list *)pt_abl -> NEXT) -> DATA);
       switch(c[0])
         {
         case 'a' : inputpin = namealloc(strcat(lblock, ".a"));
                    pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                    lblock = namealloc((char *)strtok(pin,"."));
                    break;

         case 'b' : inputpin = namealloc(strcat(lblock, ".b"));
                    pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                    lblock = namealloc((char *)strtok(pin,"."));
                    break;

         case 'c' : inputpin = namealloc(strcat(lblock, ".c"));
                    pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                    lblock = namealloc((char *)strtok(pin,"."));
                    break;

         case 'd' : inputpin = namealloc(strcat(lblock, ".d"));
                    pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                    lblock = namealloc((char *)strtok(pin,"."));
                    break;

         case 'e' : inputpin = namealloc(strcat(lblock, ".e"));
                    pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                    lblock = namealloc((char *)strtok(pin,"."));
                    break;

      case 'q' :if (c[1] == 'x') 
                 {
                   {
                   inputpin = namealloc(strcat(lblock, ".x"));
                   pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(pin,"."));
                   }
                break;
                 }
               if (c[1] == 'y') 
                 {
                   {
                   inputpin = namealloc((char *)strcat(lblock, ".y"));
                   pt_abl -> DATA = delete((char*)searchTH(pin_sigTH,inputpin));
                   lblock = namealloc((char *)strtok(pin,"."));
                   }
               break;
                 }
         } 

 for (p = pt_abl -> NEXT; p; p = p -> NEXT)
  
 changenomSig((chain_list *)p -> DATA,pin); 
      }
 
}
  
/* ###----------------------------------------------------### */
/*    fonction  : delete                                      */
/*    description : fpga met des lettre en plus sur les noms  */
/*    de'entrees (v_in_nom d'entree), la fonction enleve ces 5*/
/*    lettres pour etre coherant avec le .vbe                 */
/*    date  : 27.1.95                                         */
/* ###----------------------------------------------------### */

char *delete(str)
char *str;

  {
  char *pt_str = str;
   
    if (strncmp(str,"_in_",4) == 0)
      {
      pt_str += 4;
      }
   
    return pt_str;
 } 


/*------------------------------------------------------------------------------
displayAuxilEqu() :   displays the list o auxiliary variables and its equations  
-------------------------------------------------------
parametres :	nothing
-------------------------------------------------------
return :	nothing
------------------------------------------------------------------------------*/

void displayAuxilEqu(pTable)
pTH pTable;
{
int i;
char *auxil;
pElemTH pEl;

pEl=pTable->pElem;

auxil = namealloc("auxil");
printf("================== displayAuxilEqu ================\n");
printf("length = %d\t		count = %d\n",pTable->length,pTable->count);
printf("=============================================\n");
for (i=0;i<pTable->length;i++)
    {
    if (pEl->value != EMPTYTH && 
        pEl->value !=DELETETH &&
        strncmp(pEl->value,"auxil",5) == 0 &&
        (pEl->key[3]=='x' || pEl->key[3]=='y' ) ) 

       {
       printf("index  %d\t",i);
       printf("key  >%s<\t",pEl->key);
       printf("value = >%s<\n",equation(pEl->key));
       }
    pEl++;
    }
}

/*---------------------------------------------------------------------------
readUntil   : Lit un buffer jusqu'un caractere cl. Met a jour la variable
			  pos en lui donnant la position courant de la lecture du buffer.
			  retourne la chaine de caractre lue.
-------------------------------------------
parametres  : buffer, &pos .
-------------------------------------------
return      : chaine de caractere lue .
---------------------------------------------------------------------------*/
char *readUntil(buffer,pos)
char buffer[MAXSIZE];
int *pos;
{
int pos1, pos2, len;
char *str;

pos1 = *pos;
while(buffer[pos1] == ' ' || buffer[pos1] == '\t')
	pos1++;

pos2 = pos1;
for(;buffer[pos1] != BRANCO && buffer[pos1] != TAB &&
	 buffer[pos1] != E && buffer[pos1] != OU &&
	 buffer[pos1] != OUEXCLUSIVO; pos1++);

len = pos1 - pos2;

if(len == 0)
	{
	*pos = pos1;
	return(NULL);
	}

while(buffer[pos1] == ' ' || buffer[pos1] == '\t')
	pos1++;
/*printf("pos : %d, pos1 : %d, pos2 : %d, len : %d\n",*pos,pos1,pos2,len);*/
str = myAlloc(len + 1);
strncpy(str,buffer+pos2,len);
str = NULL;

/*str = strupr(str);*/
/*printf("STR : %s\n",str);*/

*pos = pos1;
return(str);
}


/*------------------------------------------------------------------------------
createAuxil() :   create the auxiliary variables  
-------------------------------------------------------
parametres :	nothing
-------------------------------------------------------
return :	nothing
------------------------------------------------------------------------------*/

void createAuxil()
{
chain_list *abl;
char *name, *auxexp;
int i;
pElemTH pEl;

pEl=pin_sigTH->pElem;

printf("\n================== display createAuxil ================\n");
printf("length = %d\t		count = %d\n",pin_sigTH->length,pin_sigTH->count);
printf("=============================================\n");
for (i=0;i<pin_sigTH->length;i++)
    {
    if (pEl->value != EMPTYTH && 
        pEl->value !=DELETETH &&
        strncmp(pEl->value,"auxil",5) == 0 &&
        (pEl->key[3]=='x' || pEl->key[3]=='y' ) )
       {
       printf("index  %d\t",i);
       printf("key  >%s<\t \n",pEl->key);
/*
       printf("value = >%s<\n",infix2prefix(equation(pEl->key)));
*/
       }
    pEl++;
    }
}


/*------------------------------------------------------------------------------
displayIO();
-------------------------------------------------------
parametres :	nothing
-------------------------------------------------------
return :	nothing
------------------------------------------------------------------------------*/
void displayIO()
{
int i;
pElemTH pEl;
pEl=pin_equTH->pElem;

printf("================== displayIO ================\n");
printf("length = %d\t		count = %d\n",pin_equTH->length,pin_equTH->count);
printf("=============================================\n");
for (i=0;i<pin_equTH->length;i++)
    {
    if (pEl->value != EMPTYTH && 
        pEl->value !=DELETETH &&        
        pEl->key[0]=='p'      && 
        pEl->key[1] >= '0'    &&
        pEl->key[1] <= '9')
       {
       printf("index  %d\t",i);
       printf("key  >%s<\t",pEl->key);
       printf("value = >%s<\n", pEl->value);
       }
    pEl++;
    }
}


/* ###----------------------------------------------------### */
/*    fonction  : crashvbe                                    */
/*    description : crashe un fichier .vbe                    */
/*    date  : 25.1.95                                         */
/* ###----------------------------------------------------### */

void crashvbe(nomfiche)
char *nomfiche;
{
struct befig *pt_befig = NULL;
struct bepor *pt_bepor = NULL;
struct beout *pt_beout = NULL;
struct beaux *pt_beaux = NULL;
struct bereg *pt_bereg = NULL;
struct berin *pt_berin = NULL;
struct begen *pt_begen;
struct bebus *pt_bebus;
struct bemsg *pt_bemsg;
chain_list *pt_abl      = NULL;
chain_list *pt_abl_help = NULL;
chain_list *pt_cond     = NULL;
struct biabl *pt_biabl  = NULL;

int i;
char *chain;
char invplot[50];
char str[4];
char ck_tab[8];
char *auxil;
char *sig_int;
char key_ck[8];
char *ck_name = NULL;
char ck_block[50];
pElemTH pEl;




pt_befig  = beh_addbefig(NULL,strcat(nomfiche,"e"));

pEl=pin_equTH->pElem;
for (i=0;i<pin_equTH->length;i++)
      {
      if (pEl->value != EMPTYTH &&
          pEl->value !=DELETETH &&
          pEl->key[0]=='p'      &&
          pEl->key[strlen(pEl->key)-1]=='i')
            { 
            /*printf("port_in  %s\t",pEl->key);
            printf("sig_in = %s\n", pEl->value);*/

            pt_bepor = beh_addbepor(pt_bepor,delete(pEl->value),'I','B');
           }
    pEl++;
       }

pt_bepor = beh_addbepor(pt_bepor,"vdd",'I','B');
pt_bepor = beh_addbepor(pt_bepor,"vss",'I','B');

pEl=pin_equTH->pElem;
for (i=0;i<pin_equTH->length;i++)
    {
      if (pEl->value != EMPTYTH &&
          pEl->value !=DELETETH &&
	  pEl->key[0]=='p'      &&
          pEl->key[strlen(pEl->key)-1]=='o')
            { 
            /*printf("port_out  %s\t",pEl->key);
            printf("sig_out = %s\n", pEl->value);
            printf("equation : %s \n",helpeq(pEl->key));*/

           
	    pt_bepor = beh_addbepor(pt_bepor,pEl->value,'O','B');
         
           }
    pEl++;
    }



pEl=pin_sigTH->pElem;
for (i=0;i<pin_sigTH->length;i++)
    {
      if (pEl->value != EMPTYTH &&
          pEl->value !=DELETETH &&
          pEl->key[0]=='p'      &&
          pEl->key[strlen(pEl->key)-1]=='o')

            {
            /*printf("port_out  %s\t",pEl->key);
            printf("sig_out = %s\n", pEl->value);*/

            if (searchTH(pin_equTH,pEl->key) == -1)
              {
              chain = namealloc(strcat(strtok(pEl->key,"."),".no"));
              sprintf(invplot,"~(%s)",(char *)delete(pEl->value));
              pt_beout = beh_addbeout(pt_beout,helpeq(chain),booltoabl(invplot),NULL);
              }

            else 
               if (pEl->key[strlen(pEl->key)-2]!='n')
              {
              /*printf("sig_out = %s\n", pEl->value);
              printf("equ = %s\n", helpeq(pEl->key));*/
              pt_beout = beh_addbeout(pt_beout,helpeq(pEl->key),ablatom((char *)delete(pEl->value),NULL),NULL);
              } 
           }
    pEl++;
    }

/*beh_debug (pt_beout, "beout");*/

    /* ###----------------------------------------------------### */
    /*    Declaration et affectation des signaux intermediaires   */
    /*    dans le cas du combinatoire pur.                        */
    /*    Dans le cas des registres if faut voir si X:QX ou Y:QY  */
    /*    alors, il faut les declarer dans l'architecture et dans */
    /*    les blocs register.                                     */
    /* ###----------------------------------------------------### */

pEl=pin_sigTH->pElem;
for (i=0;i<pin_sigTH->length;i++)
    {
    if (pEl->value != EMPTYTH &&
        pEl->value !=DELETETH &&
        (pEl->key[3]=='x' || pEl->key[3]=='y' ) )
       {
       if (searchTH(pin_regTH,pEl->key) == -1 && strcmp(helpeq(pEl->key),"0") != 0)
         {
         pt_abl = booltoabl(helpeq(pEl->key));
         pt_abl_help = pt_abl;
         strcpy(str,pEl->key);
         changenomSig(pt_abl,strtok(str,"."));
         pt_beaux = beh_addbeaux(pt_beaux,pEl->value,pt_abl_help,NULL);
         }
       }
    pEl++;
    }
         

pEl=pin_regTH->pElem;
for (i=0;i<pin_regTH->length;i++)
    {
     if (pEl->value != EMPTYTH &&
         pEl->value !=DELETETH &&
         (pEl->key[3]=='x' || pEl->key[3]=='y' ))

         { 
         sig_int  = namealloc((char *)searchTH(pin_sigTH,pEl->key));    
         pt_abl   = booltoabl(helpeqreg(pEl->key));
         pt_abl_help = pt_abl;
         strcpy(str,pEl->key);
         changenomSig(pt_abl,strtok(str,"."));

    /* ###----------------------------------------------------### */
    /*    pour la condition de BLOCK on cherche dans le tableau   */
    /*    pin_ckTH si c'est un front montant ou descendant et     */
    /*    apres on cherche le signal attache a ce pin dans le     */
    /*    tableau de pin_sigTH                                    */
    /* ###----------------------------------------------------### */

         strcpy(key_ck,pEl->key);
         strcat(strtok(key_ck,"."),".k");
         strcpy(ck_tab,(char *)searchTH(pin_ckTH,namealloc(key_ck)));

         if (strcasecmp(ck_tab,"RIS_ED") == 0)
           {
           ck_name = namealloc(delete((char *)searchTH(pin_sigTH,namealloc(key_ck))));
           sprintf(ck_block,"%s*~(!%s)",ck_name,ck_name); 
           pt_cond = booltoabl(ck_block);
           } 
         else 
           {
           ck_name = namealloc(delete((char *)searchTH(pin_sigTH,namealloc(key_ck))));
           sprintf(ck_block,"~%s*~(!%s)",ck_name,ck_name); 
           pt_cond = booltoabl(ck_block);
           } 
  

         pt_biabl = beh_addbiabl(pt_biabl,pEl->key,pt_cond,pt_abl_help);
         pt_bereg = beh_addbereg(pt_bereg,sig_int,pt_biabl,NULL);
         pt_biabl = NULL;

           }
    pEl++;
    }
            

/*beh_debug (pt_bepor, "bepor");*/
  
pt_befig -> BEPOR = (struct bepor *) reverse (pt_bepor);
pt_befig -> BEAUX = (struct beaux *) reverse (pt_beaux);
pt_befig -> BEREG = (struct bereg *) reverse (pt_bereg);
pt_befig -> BEOUT = (struct beout *) reverse (pt_beout);

            
pt_befig->ERRFLG = 0 ;
vhdlsavebefig(pt_befig);

}


/*======================================================================/
/		                MAIN					/
/======================================================================*/


main(argc,argv)
int argc;
char *argv[];
{
char *sw;
char str[20];
char *procurado;
FILE *fopen();
linha= mbkalloc(5000);


alliancebanner("lca2vbe", "0" , "parse lca", "95", "0");  

if (argc < 2)
   {
   printf("lca2vbe : USAGE        lca2vbe  <file>\n");
   exit(-1);
   }


/* ------------ Seting of tracing variable trace --------------------- */


sw = mbkalloc(100);
sw = (char *)getenv("FP_TRACE");
printf("TRACE MODE= %s\n",sw);
trace = 10;
if (sw)
switch (sw[0])
	{
	case '1' : trace = 1; printf("TRACE MODE= %d\n",trace); break;
	case '2' : trace = 2; printf("TRACE MODE= %d\n",trace); break;
 	case '3' : trace = 3; printf("TRACE MODE= %d\n",trace); break;
	case '4' : trace = 4; printf("TRACE MODE= %d\n",trace); break;	
	case '5' : trace = 5; printf("TRACE MODE= %d\n",trace); break;
        default: trace = 0;	
    	}
else trace = 0;
printf("trace = %d\n",trace);
/*ch = getchar();*/

if (trace) 
  {
  printf(" Opening for reading a LCA File  (%s.lca)\n",argv[1]);
  printf("\n");
  }


/* ------------ Opening for reading a LCA File (.lca) --------------------- */


sprintf(argv[1],"%s.lca",argv[1]);



finput = fopen(argv[1],"r");
if (finput == NULL)
   {
   printf("slif : I can't open the file %s\n",argv[1]); 
   exit(-1);
   }

/* ------------------- Creating a hash table ( netTH ) ---------------------- */

if (trace) 
  {
  printf(" Creating a hash table ( outTH, pin_sigTH, pin_equTH )\n");
  printf("\n");
  }

outTH     = createTH(1000);
pin_sigTH = createTH(1000);
pin_equTH = createTH(1000);
pin_regTH = createTH(1000);
pin_ckTH  = createTH(1000);



/* ------------------- Reading the first line  ------------------------------ */
if (trace > 1) 
  printf("Reading the First Line\n");
tok = _token();
if (trace > 1) 
  printf("First Line:  _token retornou tok=>%s< e linha=>%s< \n",tok,linha);
caseLine(tok);

/* ------------------- Reading Design   ------------------------------------- */
if (trace > 1) 
  printf("Reading Design\n");
tok = _token();
if (trace > 1) 
  printf("Reading Design:  _token retornou tok=>%s< e linha=>%s< \n",tok,linha);
caseLine(tok);

/* ------------------- Reading Speed  --------------------------------------- */
if (trace > 1) 
  printf("Reading Speed\n");
tok = _token();
if (trace > 1) 
  printf("Reading Speed:  _token retornou tok=>%s< e linha=>%s< \n",tok,linha);
caseLine(tok);

/* ------------------- Reading Addnet ----------------------------------------*/
if (trace > 1) 
  printf("Reading Addnet\n");
tok = _token();
while ((char)tok[0] == 'a')
   {
   caseLine(tok);
   tok = _token();
   }

/* -------------------- Display of The Pin-Signal Hash Table -----------------*/
if (trace) 
  {
  printf("\n");
  printf("\n");
  displaymyTH(pin_sigTH);
  ch = getchar();
  }


/* ------------------- Reading blocks ----------------------------------------*/

if (trace > 1)
  printf ("Reading blocks\n");
while (tok != NULL)
  {
    caseLine (tok);
    if (trace > 1)
      printf ("While Reading blocks \n");
    tok = namealloc(_token ());
    if (trace > 1)
      {
      printf ("_token retornou %s\n", tok);
      ch = getchar();
      }
  }

/* ------------------- Trace of pin_equ  -------------------------------------*/


if (trace)
  {
  printf("\n");
  printf("\n");
  displaymyTH (pin_equTH);
  /*ch = getchar();*/
  }

/* ------------------- Trace of pin_sig of auxiliary variables  --------------*/

/*displayAuxil(pin_sigTH);*/


/* ---- Trace of pin_sig and pin_equ for auxiliary variable equations --------*/

/*displayAuxilEqu(pin_sigTH);*/
/*displayAuxil(pin_sigTH);*/


/* ----- Create (from pin_sigTH and pin_equTH) the auxiliary variables  ------*/

/*createAuxil();*/

/* ---- Trace of pin_sig and pin_equ for auxiliary variable equations --------*/

/*displayIO();*/


  strcpy(str,argv[1]);
  crashvbe(strtok(str,"."));
  /*displaymyTH(pin_sigTH);*/
  /*displaymyTH(pin_equTH);*/
  /*displaymyTH(pin_regTH);*/
  /*displaymyTH(pin_ckTH);*/

  printf ("END OF lca2vbe \n");
  if (trace > 1)
     ch = getchar();

destroyTH(outTH);
destroyTH(pin_sigTH);
destroyTH(pin_equTH);
destroyTH(pin_regTH);
destroyTH(pin_ckTH);
}

/* 

Na pin_equTH pxx.o => sinal de saida   primaria
Na pin_equTH pxx.i => sinal de entrada primaria 

Na pin_sigTH pxx.o =>  sinal conectado na entrada do pino de SAIDA   pxx
Na pin_sigTH pxx.i =>  sinal conectado na entrada do pino de ENTRADA pxx

*/


