%{
#include "y.tab.h"
#include "rin.h"
#include "frin.h"
#include MUT_H
static int lineno = 1;
%}
%s INSTANCE

id [a-zA-Z_]([a-zA-Z_]|[0-9])*
%%
<INSTANCE>{id}        yylval.s = namealloc(yytext); return ID;
<INSTANCE>\)          BEGIN INITIAL; return *yytext;
[ \t]+
\n                    lineno++;
[nN][oO][rR][tT][hH]  return R_NORTH;
[sN][oO][uU][tT][hH]  return R_SOUTH;
[wW][eE][sS][tT]      return R_WEST;
[eE][aA][sS][tT]      return R_EAST;
[wW][iI][dD][tT][hH]  return R_WIDTH;
[0-9]+                sscanf(yytext,"%ld",&yylval.i); return NUM;
#.*
\(                    BEGIN INSTANCE; return *yytext;
.                     return *yytext;
%%
static int yywrap()
{
   return 1;
}

int lexline()
{
   return lineno;
}

char *lextext()
{
   return yytext;
}

void openrin(s)
char *s;
{
   if ((yyin = mbkfopen(s, "rin", "r")) == NULL)
      error(NO_RIN_FILE, s, "rin");
}
