%{
#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include MUT_H
#include "rin.h"
#include "frin.h"
static int row; /* index of the row of pads */
static void yyerror(/* char * */);
static int preload; /* read the pad list only to type the pads as pads */
static void catch(); /* signal handling for nice rin file reading */
%}
%token R_NORTH R_SOUTH R_WEST R_EAST R_WIDTH
%token NUM ID
%union {
   long i;
   char *s;
}
%type <i> NUM
%type <s> ID
%%

line      : ldirective {return yynerrs;}

ldirective: directive
          | ldirective directive
          ;

directive : R_NORTH {row = LNORTH;} list
          | R_SOUTH {row = LSOUTH;} list
          | R_WEST  {row = LWEST;}  list
          | R_EAST  {row = LEAST;}  list
          | R_WIDTH clist
          ;

list      : '(' ')'
          | '(' namelist ')'
          ;

namelist  : instance
          | namelist instance
          | error {yyerrok;}
          ;

instance  : ID {preload ? getpadmodel($1) : addpad(row, $1);}
          ;

clist     : '(' ')'
          | '(' couplelist ')'
          | '(' error ')' {yyerrok;}
          ;

couplelist: couple
          | couplelist couple
          ;

couple    : ID NUM { /* avoid the type clash default action warning */ }
          ;

%%
static void yyerror(s)
char *s;
{
   fprintf(stderr, "%s line %d on '%s'\n", s, lexline(), lextext());
}

static void catch()
{
   yyerror("mbk error");
   signal(SIGTERM, catch);
   exit(2);
}

void preloadpads(s)
char *s;
{
   openrin(s);
   preload = 1;   
   signal(SIGTERM, catch);
   if (yyparse() != 0) {
      fprintf(stderr, "Rin file parser detected %d error in file %s.rin!\n",
                       yynerrs, s);
      exit(1);
   }
   signal(SIGTERM, SIG_DFL);
   preload = 0;
}

void loadpads(s)
char *s;
{
   openrin(s);
   if (yyparse() != 0) {
      fprintf(stderr,
              "Impossible error! You've destroyed the file or what ?\n");
      exit(1);
   }
}
