/*------------------------------------------------------------\
|                                                             |
| Tool    :                   GRAAL                           |
|                                                             |
| File    :                  GMV101.h                         |
|                                                             |
| Authors :      Venot Frederic and Jacomme Ludovic           |
|                                                             |
| Date    :                  01.08.93                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# ifndef GRAAL_GMV
# define GRAAL_GMV 

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  extern char GraalFirstViewLayer;

/*------------------------------------------------------------\
|                                                             |
|                        Panel And Menu                       |
|                                                             |
\------------------------------------------------------------*/

  extern GraalMenuItem  GraalViewMenu[];
  extern GraalPanelItem GraalViewArrowsPanel;
  extern GraalPanelItem GraalViewZoomPanel;
  extern GraalPanelItem GraalViewGridPanel;
  extern GraalPanelItem GraalViewLayerPanel;
  extern GraalPanelItem GraalViewMapPanel;
 
  extern int  GraalPercentZoom;
  extern int  GraalPercentMoveX;
  extern int  GraalPercentMoveY;

  extern int  GraalViewArrowsDefaultValues[5];
  extern int  GraalViewZoomDefaultValues[5];
  extern int  GraalViewLayerDefaultValues[5];
  extern int  GraalViewGridDefaultValues[5];
  extern int  GraalViewMapDefaultValues[5];
  
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                           Values                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Callback                           |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Zoom                             |
|                                                             |
\------------------------------------------------------------*/

  extern void GraalComputeAndDisplayMap();
  extern void GraalInitializeZoom();
  extern void GraalBuildViewDialog();
  extern void GraalBuildPanelMap();
  extern void GraalInitializeMapEvent();

  extern void GraalZoomCenter();
  extern void GraalZoomRefresh();
  extern void GraalZoomIn();
  extern void GraalZoomPan();

# endif
