
/*  A Bison parser, made from parser.yac with Bison version GNU Bison version 1.22
  */

#define EDIFLBISON 1  /* Identify Bison output.  */

#define	T_EDIF	258
#define	T_EDIFVERSION	259
#define	T_EDIFLEVEL	260
#define	T_TECHNOLOGY	261
#define	T_CELLTYPE	262
#define	T_CELLTYPE_GENERIC	263
#define	T_CELLTYPE_TIE	264
#define	T_CELLTYPE_RIPPER	265
#define	T_PROPERTY	266
#define	T_VIEWTYPE	267
#define	T_INTERFACE	268
#define	T_CONTENTS	269
#define	T_JOINED	270
#define	T_INSTANCE	271
#define	T_VIEWREF	272
#define	T_PORT	273
#define	T_DIRECTION	274
#define	T_INOUT	275
#define	T_PORTREF	276
#define	T_NETLIST	277
#define	T_KEYWORDMAP	278
#define	T_KEYWORDLEVEL	279
#define	T_EXTERNAL	280
#define	T_LIBRARYREF	281
#define	T_OUTPUT	282
#define	T_INSTANCEREF	283
#define	T_MEMBER	284
#define	T_RENAME	285
#define	T_NAME	286
#define	T_STRING	287
#define	T_PORTINSTANCE	288
#define	T_LIBRARY	289
#define	T_CELL	290
#define	T_VIEW	291
#define	T_NET	292
#define	T_CELLREF	293
#define	T_INPUT	294
#define	T_STATUS	295
#define	T_IDENT	296
#define	T_ARRAY	297
#define	T_RENAME_STRING	298
#define	T_PORTLIST	299
#define	T_INTEGER	300

#line 1 "parser.yac"


/*----------------------------------------------------------------------*/
/*                      @(#) Edif Parser For MBK.                       */
/*----------------------------------------------------------------------*/
/*                      version 1.00:   by Fred Petrot.                 */
/*                      version 4.02:   by Mokhtar Hirech (Jan. 92)     */
/*                      version 4.03:   by Olivier BEAURIN (Aou. 93)    */
/*                      version 4.04:   by Olivier BEAURIN (Sep. 93)    */
/*                      version 4.06:   by Olivier BEAURIN (Nov. 93)    */
/*----------------------------------------------------------------------*/

#include MUT_H
#include MLO_H
#include <string.h>

/*---------------------------------------------------------\
                     Les defines
\---------------------------------------------------------*/
#define MAXSTRLEN       100
#define NULL            0

/*---------------------------------------------------------\
                     Globals variables
\---------------------------------------------------------*/
static lofig_list     *EDIFL_LOFIG                = (lofig_list *) NULL;
static lofig_list     *EDIFL_PTFIG                = (lofig_list *) NULL;
static losig_list     *EDIFL_PTSIG                = (losig_list *) NULL;
static chain_list     *EDIFL_PORTLIST_SIG         = (chain_list *) NULL;
static chain_list     *EDIFL_PORTLIST_SIG_TMP     = (chain_list *) NULL;
static loins_list     *EDIFL_PTINS                = (loins_list *) NULL;
static chain_list     *EDIFL_V_PORTINSTANCE       = (chain_list *) NULL;

static char            EDIFL_BLACKBOX             = 'N';  
static int             EDIFL_BUS_WIDTH            = 0;
static char            EDIFL_DIRECTION            = UNKNOWN;
static int             EDIFL_INDEX                = 0;
static char            EDIFL_SIGTYPE              = 'Z'; /* Z=not alr. defined, I=interne, E=externe */
static int             EDIFL_NOLOAD_LOCON         = 0;
static int             EDIFL_NOLOAD_FIG           = 0;

static int             EDIFL_BASE_CELL;
static char           *EDIFL_FIGNAME;
static char           *EDIFL_INS_MODELNAME;
static char            EDIFL_ARRAYPORTNAME[MAXSTRLEN];
static char            EDIFL_PORTLIST_NUM;
static char            EDIFL_PORTLIST;
static char           *EDIFL_RIPPER_CELL = (char *) NULL;

/*---------------------------------------------------------\
                     Functions
\---------------------------------------------------------*/
static  void        REnamealloc         ( );
static  void        del_patch           ( );
static  void        sig_merge           ( );

static  char        bus_nameref         ( );
static  char        CheckCadenceBusError( );
static  char       *CheckCadenceNetError( );
static  lofig_list *get_figure_pt       ( );
static  char        is_portinstance     ( );
extern  char       *edif_busname        ( );

extern  int         edifllineno;


#line 70 "parser.yac"
typedef union
	{
		long    lval;
		char    sval[100];
	} EDIFLSTYPE;

#ifndef EDIFLLTYPE
typedef
  struct ediflltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  ediflltype;

#define EDIFLLTYPE ediflltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	EDIFLFINAL		225
#define	EDIFLFLAG		-32768
#define	EDIFLNTBASE	47

#define EDIFLTRANSLATE(x) ((unsigned)(x) <= 300 ? edifltranslate[x] : 116)

static const char edifltranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    46,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45
};

#if EDIFLDEBUG != 0
static const short ediflprhs[] = {     0,
     0,     8,    14,    18,    19,    22,    28,    29,    32,    34,
    35,    42,    43,    46,    48,    50,    58,    62,    63,    66,
    68,    70,    71,    74,    80,    81,    84,    86,    87,    94,
    98,   102,   106,   107,   110,   112,   114,   118,   119,   121,
   130,   131,   134,   136,   138,   142,   143,   146,   148,   150,
   151,   160,   164,   169,   170,   173,   178,   182,   187,   191,
   192,   199,   200,   210,   211,   214,   216,   220,   221,   224,
   226,   228,   229,   234,   235,   238,   242,   249,   253,   254,
   257,   259,   263,   270,   277,   287,   291,   292,   295,   297,
   299,   301,   306,   314,   315,   318,   320,   322,   326,   330,
   334,   335,   338,   341,   343,   345,   347,   352,   357,   361,
   365,   366,   369,   371
};

static const short ediflrhs[] = {     3,
   110,    48,    49,    50,    62,    46,     0,     4,    45,    45,
    45,    46,     0,     5,    45,    46,     0,     0,    50,    51,
     0,    25,   110,    49,    52,    46,     0,     0,    52,    53,
     0,    54,     0,     0,    35,   110,    55,    68,    56,    46,
     0,     0,    56,    57,     0,    58,     0,    71,     0,    36,
   110,    12,    22,    46,    59,    46,     0,    13,    60,    46,
     0,     0,    60,    61,     0,   104,     0,    71,     0,     0,
    62,    63,     0,    34,   110,    49,    64,    46,     0,     0,
    64,    65,     0,    66,     0,     0,    35,   110,    67,    68,
    69,    46,     0,     7,     8,    46,     0,     7,     9,    46,
     0,     7,    10,    46,     0,     0,    69,    70,     0,    73,
     0,    71,     0,    11,   108,    46,     0,     0,    71,     0,
    36,   110,    12,    22,    46,   101,    74,    46,     0,     0,
    74,    75,     0,    76,     0,    71,     0,    14,    77,    46,
     0,     0,    77,    78,     0,    79,     0,    86,     0,     0,
    16,   110,    81,    72,    80,    82,   108,    46,     0,    17,
   110,    46,     0,    17,   110,    84,    46,     0,     0,    82,
    83,     0,    33,   110,   108,    46,     0,    38,   110,    46,
     0,    38,   110,    85,    46,     0,    26,   110,    46,     0,
     0,    37,   110,    87,    97,    89,    46,     0,     0,    37,
    42,   110,    45,    46,    88,    91,    89,    46,     0,     0,
    89,    90,     0,    71,     0,    15,    92,    46,     0,     0,
    92,    91,     0,    96,     0,    93,     0,     0,    44,    94,
    95,    46,     0,     0,    95,   100,     0,    21,   110,    46,
     0,    21,   110,    28,   110,    46,    46,     0,    15,    98,
    46,     0,     0,    98,    99,     0,   100,     0,    21,   110,
    46,     0,    21,   110,    28,   110,    46,    46,     0,    21,
    29,   110,    45,    46,    46,     0,    21,    29,   110,    45,
    46,    28,   110,    46,    46,     0,    13,   102,    46,     0,
     0,   102,   103,     0,   104,     0,   112,     0,    71,     0,
    18,   110,   105,    46,     0,    18,    42,   110,    45,    46,
   105,    46,     0,     0,   105,   106,     0,   107,     0,    71,
     0,    19,    20,    46,     0,    19,    39,    46,     0,    19,
    27,    46,     0,     0,   108,   109,     0,   108,    46,     0,
   110,     0,    41,     0,    45,     0,    30,    41,    43,    46,
     0,    30,   111,    43,    46,     0,    31,    41,    46,     0,
    15,   113,    46,     0,     0,   113,   114,     0,   115,     0,
    21,   110,    46,     0
};

#endif

#if EDIFLDEBUG != 0
static const short ediflrline[] = { 0,
   118,   122,   133,   147,   149,   152,   156,   158,   161,   165,
   199,   205,   207,   210,   212,   215,   223,   227,   229,   232,
   234,   240,   242,   245,   249,   251,   254,   258,   292,   319,
   321,   322,   328,   330,   333,   335,   338,   342,   343,   346,
   354,   356,   359,   361,   364,   437,   439,   442,   444,   447,
   469,   475,   477,   480,   482,   485,   492,   497,   503,   507,
   517,   524,   562,   582,   584,   587,   591,   595,   597,   600,
   602,   605,   612,   626,   628,   631,   668,   740,   744,   746,
   749,   753,   783,   828,   863,   919,   923,   925,   928,   930,
   931,   934,   942,   977,   979,   982,   984,   987,   992,   996,
  1002,  1004,  1007,  1009,  1012,  1017,  1024,  1028,  1034,  1041,
  1045,  1047,  1050,  1054
};

static const char * const edifltname[] = {   "$","error","$illegal.","T_EDIF","T_EDIFVERSION",
"T_EDIFLEVEL","T_TECHNOLOGY","T_CELLTYPE","T_CELLTYPE_GENERIC","T_CELLTYPE_TIE",
"T_CELLTYPE_RIPPER","T_PROPERTY","T_VIEWTYPE","T_INTERFACE","T_CONTENTS","T_JOINED",
"T_INSTANCE","T_VIEWREF","T_PORT","T_DIRECTION","T_INOUT","T_PORTREF","T_NETLIST",
"T_KEYWORDMAP","T_KEYWORDLEVEL","T_EXTERNAL","T_LIBRARYREF","T_OUTPUT","T_INSTANCEREF",
"T_MEMBER","T_RENAME","T_NAME","T_STRING","T_PORTINSTANCE","T_LIBRARY","T_CELL",
"T_VIEW","T_NET","T_CELLREF","T_INPUT","T_STATUS","T_IDENT","T_ARRAY","T_RENAME_STRING",
"T_PORTLIST","T_INTEGER","')'","r_edif","r_edifversion","r_ediflevel","l_externals",
"r_external","l_finexternal","r_finexternal","r_extcell","@1","l_finextcell",
"r_finextcell","r_extview","r_extinterface","l_finextinterf","r_finextinterf",
"l_finedif","r_library","l_finlibrary","r_finlibrary","r_cell","@2","r_celltype",
"l_fincell","r_fincell","r_property","r_opt_property","r_view","l_finview","r_finview",
"r_contents","l_fincontents","r_fincontents","r_instance","@3","r_viewref","l_portinstance",
"r_portinstance","r_cellref","r_libraryref","r_net","@4","@5","l_finnet","r_finnet",
"r_array_joined","l_array_joined","r_portlist","@6","l_list_portref","r_array_portref",
"r_joined","l_finjoined","r_finjoined","r_portref","r_interface","l_fininterface",
"r_fininterface","r_port","l_finport","r_finport","r_direction","l_anything",
"r_anything","r_namedef","r_name","r_port_joined","l_finport_joined","r_finport_joined",
"r_shorted_portref",""
};
#endif

static const short ediflr1[] = {     0,
    47,    48,    49,    50,    50,    51,    52,    52,    53,    55,
    54,    56,    56,    57,    57,    58,    59,    60,    60,    61,
    61,    62,    62,    63,    64,    64,    65,    67,    66,    68,
    68,    68,    69,    69,    70,    70,    71,    72,    72,    73,
    74,    74,    75,    75,    76,    77,    77,    78,    78,    80,
    79,    81,    81,    82,    82,    83,    84,    84,    85,    87,
    86,    88,    86,    89,    89,    90,    91,    92,    92,    91,
    91,    94,    93,    95,    95,    96,    96,    97,    98,    98,
    99,   100,   100,   100,   100,   101,   102,   102,   103,   103,
   103,   104,   104,   105,   105,   106,   106,   107,   107,   107,
   108,   108,   109,   109,   110,   110,   110,   110,   111,   112,
   113,   113,   114,   115
};

static const short ediflr2[] = {     0,
     7,     5,     3,     0,     2,     5,     0,     2,     1,     0,
     6,     0,     2,     1,     1,     7,     3,     0,     2,     1,
     1,     0,     2,     5,     0,     2,     1,     0,     6,     3,
     3,     3,     0,     2,     1,     1,     3,     0,     1,     8,
     0,     2,     1,     1,     3,     0,     2,     1,     1,     0,
     8,     3,     4,     0,     2,     4,     3,     4,     3,     0,
     6,     0,     9,     0,     2,     1,     3,     0,     2,     1,
     1,     0,     4,     0,     2,     3,     6,     3,     0,     2,
     1,     3,     6,     6,     9,     3,     0,     2,     1,     1,
     1,     4,     7,     0,     2,     1,     1,     3,     3,     3,
     0,     2,     2,     1,     1,     1,     4,     4,     3,     3,
     0,     2,     1,     3
};

static const short edifldefact[] = {     0,
     0,     0,   105,   106,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     4,   109,   107,   108,     0,
     0,    22,     0,     3,     0,     5,     0,     2,     0,     0,
     1,    23,     7,     0,     0,    25,     0,     6,     8,     9,
     0,    10,     0,    24,    26,    27,     0,    28,     0,    12,
     0,     0,     0,     0,     0,    33,    30,    31,    32,   101,
     0,    11,    13,    14,    15,     0,     0,     0,     0,    29,
    34,    36,    35,    37,     0,   102,   104,     0,     0,   103,
     0,     0,     0,     0,    18,     0,     0,     0,    16,    87,
    41,     0,    17,    19,    21,    20,     0,     0,     0,    94,
   111,    86,    91,    88,    89,    90,    46,    40,    44,    42,
    43,     0,     0,     0,     0,     0,     0,    92,    97,    95,
    96,     0,   110,   112,   113,     0,     0,    45,    47,    48,
    49,    94,     0,     0,     0,     0,     0,     0,    60,     0,
    98,   100,    99,   114,     0,    38,     0,     0,    93,     0,
    39,    50,     0,    79,    64,     0,    52,     0,    54,    62,
     0,     0,     0,    53,   101,     0,     0,    78,    80,    81,
    61,    66,    65,     0,    57,     0,     0,    55,     0,    68,
     0,    72,    64,    71,    70,     0,     0,     0,    58,   101,
    51,     0,     0,    74,     0,     0,     0,    82,    59,     0,
    67,    69,     0,    76,     0,    63,     0,     0,    56,     0,
    73,    75,     0,     0,     0,     0,    84,    83,    77,     0,
     0,    85,     0,     0,     0
};

static const short edifldefgoto[] = {   223,
    10,    16,    22,    26,    35,    39,    40,    47,    55,    63,
    64,    86,    88,    94,    27,    32,    41,    45,    46,    51,
    50,    66,    71,   119,   152,    73,    98,   110,   111,   115,
   129,   130,   159,   146,   165,   178,   158,   176,   131,   148,
   166,   162,   173,   183,   192,   184,   194,   205,   185,   155,
   161,   169,   170,    91,    97,   104,    96,   113,   120,   121,
    75,    76,    77,     8,   106,   114,   124,   125
};

static const short ediflpact[] = {    32,
    88,    42,-32768,-32768,    15,    34,    23,    47,    31,    91,
    54,    63,    68,    72,    75,-32768,-32768,-32768,-32768,    77,
    84,   103,    85,-32768,    88,-32768,    25,-32768,    91,    88,
-32768,-32768,-32768,    91,    21,-32768,    88,-32768,-32768,-32768,
    35,-32768,    88,-32768,-32768,-32768,   131,-32768,   126,-32768,
   131,    93,    94,    96,    -6,-32768,-32768,-32768,-32768,-32768,
    88,-32768,-32768,-32768,-32768,    -5,    39,   133,    88,-32768,
-32768,-32768,-32768,-32768,    48,-32768,-32768,   121,   134,-32768,
   101,   127,   135,   104,-32768,   105,   139,    -7,-32768,-32768,
-32768,    74,-32768,-32768,-32768,-32768,    -8,     2,    88,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   108,     3,     0,    17,   110,    38,-32768,-32768,-32768,
-32768,    88,-32768,-32768,-32768,    88,    82,-32768,-32768,-32768,
-32768,-32768,   111,   112,   113,   114,   137,    88,-32768,     4,
-32768,-32768,-32768,-32768,    88,   150,   117,   148,-32768,    67,
-32768,-32768,   118,-32768,-32768,    88,-32768,   119,-32768,-32768,
    16,     6,   -18,-32768,   136,    30,    58,-32768,-32768,-32768,
-32768,-32768,-32768,    88,-32768,   122,    88,-32768,    56,-32768,
    88,-32768,-32768,-32768,-32768,    88,   -19,   124,-32768,-32768,
-32768,    11,    33,-32768,     7,   129,    88,-32768,-32768,    65,
-32768,-32768,    88,-32768,    26,-32768,   125,   132,-32768,   138,
-32768,-32768,    36,   140,   141,    88,-32768,-32768,-32768,   142,
   143,-32768,   167,   172,-32768
};

static const short ediflpgoto[] = {-32768,
-32768,    -9,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   128,-32768,-32768,   -54,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    -2,-32768,   -17,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   -28,-32768,-32768,-32768,    86,    50,-32768,-32768,
   -58,-32768,    -1,-32768,-32768,-32768,-32768,-32768
};


#define	EDIFLLAST		215


static const short edifltable[] = {     5,
    65,    67,    60,    60,    60,    60,   101,   174,   197,    92,
    92,    72,    60,    60,    60,   107,    60,    60,     9,    33,
   122,   117,   117,    29,    36,   180,   198,   175,    34,    61,
    69,   181,   126,    95,     1,    42,   167,   102,    93,    62,
    70,    48,   103,   109,   180,   123,   167,   108,   118,   149,
   181,   171,   206,   127,   182,    37,   201,   133,    30,    68,
   203,   168,   128,   216,   134,    12,    38,    79,     2,    43,
    31,   211,     6,   182,    11,    14,   135,     2,   204,     3,
    44,   217,     7,     4,    74,     2,   186,     2,     3,    13,
   100,   151,     4,    80,     2,    15,     3,   112,     3,    17,
     4,   191,     4,     2,   156,     3,   179,   172,    18,     4,
   209,     2,   157,    19,     3,    99,    20,     2,     4,    21,
   136,    23,     3,   138,   137,   139,     4,    25,     3,    24,
    28,   200,     4,    52,    53,    54,   147,    49,    57,    58,
   172,    59,    81,   150,    78,    82,    83,    85,    84,    87,
    89,    90,   116,   145,   163,   132,   141,   142,   143,   144,
    60,   153,   154,   160,   164,   187,   224,   189,   177,   199,
   213,   225,   188,   207,   202,   190,   212,   214,    56,   193,
   195,   140,   105,   215,   196,   218,   219,   221,   222,     0,
     0,     0,     0,     0,     0,   208,     0,     0,     0,     0,
     0,   210,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   220
};

static const short ediflcheck[] = {     1,
    55,    60,    11,    11,    11,    11,    15,    26,    28,    18,
    18,    66,    11,    11,    11,    14,    11,    11,     4,    29,
    21,    19,    19,    25,    34,    15,    46,    46,    30,    36,
    36,    21,    16,    88,     3,    37,    21,    46,    46,    46,
    46,    43,    97,    98,    15,    46,    21,    46,    46,    46,
    21,    46,    46,    37,    44,    35,    46,    20,    34,    61,
    28,    46,    46,    28,    27,    43,    46,    69,    30,    35,
    46,    46,    31,    44,    41,    45,    39,    30,    46,    41,
    46,    46,    41,    45,    46,    30,    29,    30,    41,    43,
    92,   146,    45,    46,    30,     5,    41,    99,    41,    46,
    45,    46,    45,    30,    38,    41,   165,   162,    46,    45,
    46,    30,    46,    46,    41,    42,    45,    30,    45,    45,
   122,    45,    41,    42,   126,   127,    45,    25,    41,    46,
    46,   190,    45,     8,     9,    10,   138,     7,    46,    46,
   195,    46,    22,   145,    12,    12,    46,    13,    22,    46,
    46,    13,    45,    17,   156,    46,    46,    46,    46,    46,
    11,    45,    15,    46,    46,   167,     0,    46,    33,    46,
    46,     0,   174,    45,   192,   177,   205,    46,    51,   181,
   183,   132,    97,    46,   186,    46,    46,    46,    46,    -1,
    -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,
    -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   216
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define ediflerrok		(ediflerrstatus = 0)
#define ediflclearin	(ediflchar = EDIFLEMPTY)
#define EDIFLEMPTY		-2
#define EDIFLEOF		0
#define EDIFLACCEPT	return(0)
#define EDIFLABORT 	return(1)
#define EDIFLERROR		goto ediflerrlab1
/* Like EDIFLERROR except do call ediflerror.
   This remains here temporarily to ease the
   transition to the new meaning of EDIFLERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define EDIFLFAIL		goto ediflerrlab
#define EDIFLRECOVERING()  (!!ediflerrstatus)
#define EDIFLBACKUP(token, value) \
do								\
  if (ediflchar == EDIFLEMPTY && edifllen == 1)				\
    { ediflchar = (token), edifllval = (value);			\
      ediflchar1 = EDIFLTRANSLATE (ediflchar);				\
      EDIFLPOPSTACK;						\
      goto ediflbackup;						\
    }								\
  else								\
    { ediflerror ("syntax error: cannot back up"); EDIFLERROR; }	\
while (0)

#define EDIFLTERROR	1
#define EDIFLERRCODE	256

#ifndef EDIFLPURE
#define EDIFLLEX		edifllex()
#endif

#ifdef EDIFLPURE
#ifdef EDIFLLSP_NEEDED
#define EDIFLLEX		edifllex(&edifllval, &edifllloc)
#else
#define EDIFLLEX		edifllex(&edifllval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef EDIFLPURE

int	ediflchar;			/*  the lookahead symbol		*/
EDIFLSTYPE	edifllval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef EDIFLLSP_NEEDED
EDIFLLTYPE edifllloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int ediflnerrs;			/*  number of parse errors so far       */
#endif  /* not EDIFLPURE */

#if EDIFLDEBUG != 0
int edifldebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  EDIFLINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	EDIFLINITDEPTH
#define EDIFLINITDEPTH 200
#endif

/*  EDIFLMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if EDIFLMAXDEPTH == 0
#undef EDIFLMAXDEPTH
#endif

#ifndef EDIFLMAXDEPTH
#define EDIFLMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int ediflparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __edifl_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__edifl_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__edifl_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
ediflparse()
{
  register int ediflstate;
  register int edifln;
  register short *ediflssp;
  register EDIFLSTYPE *ediflvsp;
  int ediflerrstatus;	/*  number of tokens to shift before error messages enabled */
  int ediflchar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	ediflssa[EDIFLINITDEPTH];	/*  the state stack			*/
  EDIFLSTYPE ediflvsa[EDIFLINITDEPTH];	/*  the semantic value stack		*/

  short *ediflss = ediflssa;		/*  refer to the stacks thru separate pointers */
  EDIFLSTYPE *ediflvs = ediflvsa;	/*  to allow edifloverflow to reallocate them elsewhere */

#ifdef EDIFLLSP_NEEDED
  EDIFLLTYPE edifllsa[EDIFLINITDEPTH];	/*  the location stack			*/
  EDIFLLTYPE *ediflls = edifllsa;
  EDIFLLTYPE *edifllsp;

#define EDIFLPOPSTACK   (ediflvsp--, ediflssp--, edifllsp--)
#else
#define EDIFLPOPSTACK   (ediflvsp--, ediflssp--)
#endif

  int ediflstacksize = EDIFLINITDEPTH;

#ifdef EDIFLPURE
  int ediflchar;
  EDIFLSTYPE edifllval;
  int ediflnerrs;
#ifdef EDIFLLSP_NEEDED
  EDIFLLTYPE edifllloc;
#endif
#endif

  EDIFLSTYPE ediflval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int edifllen;

#if EDIFLDEBUG != 0
  if (edifldebug)
    fprintf(stderr, "Starting parse\n");
#endif

  ediflstate = 0;
  ediflerrstatus = 0;
  ediflnerrs = 0;
  ediflchar = EDIFLEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  ediflssp = ediflss - 1;
  ediflvsp = ediflvs;
#ifdef EDIFLLSP_NEEDED
  edifllsp = ediflls;
#endif

/* Push a new state, which is found in  ediflstate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
ediflnewstate:

  *++ediflssp = ediflstate;

  if (ediflssp >= ediflss + ediflstacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      EDIFLSTYPE *ediflvs1 = ediflvs;
      short *ediflss1 = ediflss;
#ifdef EDIFLLSP_NEEDED
      EDIFLLTYPE *ediflls1 = ediflls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = ediflssp - ediflss + 1;

#ifdef edifloverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef EDIFLLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if edifloverflow is a macro.  */
      edifloverflow("parser stack overflow",
		 &ediflss1, size * sizeof (*ediflssp),
		 &ediflvs1, size * sizeof (*ediflvsp),
		 &ediflls1, size * sizeof (*edifllsp),
		 &ediflstacksize);
#else
      edifloverflow("parser stack overflow",
		 &ediflss1, size * sizeof (*ediflssp),
		 &ediflvs1, size * sizeof (*ediflvsp),
		 &ediflstacksize);
#endif

      ediflss = ediflss1; ediflvs = ediflvs1;
#ifdef EDIFLLSP_NEEDED
      ediflls = ediflls1;
#endif
#else /* no edifloverflow */
      /* Extend the stack our own way.  */
      if (ediflstacksize >= EDIFLMAXDEPTH)
	{
	  ediflerror("parser stack overflow");
	  return 2;
	}
      ediflstacksize *= 2;
      if (ediflstacksize > EDIFLMAXDEPTH)
	ediflstacksize = EDIFLMAXDEPTH;
      ediflss = (short *) alloca (ediflstacksize * sizeof (*ediflssp));
      __edifl_bcopy ((char *)ediflss1, (char *)ediflss, size * sizeof (*ediflssp));
      ediflvs = (EDIFLSTYPE *) alloca (ediflstacksize * sizeof (*ediflvsp));
      __edifl_bcopy ((char *)ediflvs1, (char *)ediflvs, size * sizeof (*ediflvsp));
#ifdef EDIFLLSP_NEEDED
      ediflls = (EDIFLLTYPE *) alloca (ediflstacksize * sizeof (*edifllsp));
      __edifl_bcopy ((char *)ediflls1, (char *)ediflls, size * sizeof (*edifllsp));
#endif
#endif /* no edifloverflow */

      ediflssp = ediflss + size - 1;
      ediflvsp = ediflvs + size - 1;
#ifdef EDIFLLSP_NEEDED
      edifllsp = ediflls + size - 1;
#endif

#if EDIFLDEBUG != 0
      if (edifldebug)
	fprintf(stderr, "Stack size increased to %d\n", ediflstacksize);
#endif

      if (ediflssp >= ediflss + ediflstacksize - 1)
	EDIFLABORT;
    }

#if EDIFLDEBUG != 0
  if (edifldebug)
    fprintf(stderr, "Entering state %d\n", ediflstate);
#endif

  goto ediflbackup;
 ediflbackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* ediflresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  edifln = ediflpact[ediflstate];
  if (edifln == EDIFLFLAG)
    goto edifldefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* ediflchar is either EDIFLEMPTY or EDIFLEOF
     or a valid token in external form.  */

  if (ediflchar == EDIFLEMPTY)
    {
#if EDIFLDEBUG != 0
      if (edifldebug)
	fprintf(stderr, "Reading a token: ");
#endif
      ediflchar = EDIFLLEX;
    }

  /* Convert token to internal form (in ediflchar1) for indexing tables with */

  if (ediflchar <= 0)		/* This means end of input. */
    {
      ediflchar1 = 0;
      ediflchar = EDIFLEOF;		/* Don't call EDIFLLEX any more */

#if EDIFLDEBUG != 0
      if (edifldebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      ediflchar1 = EDIFLTRANSLATE(ediflchar);

#if EDIFLDEBUG != 0
      if (edifldebug)
	{
	  fprintf (stderr, "Next token is %d (%s", ediflchar, edifltname[ediflchar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef EDIFLPRINT
	  EDIFLPRINT (stderr, ediflchar, edifllval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  edifln += ediflchar1;
  if (edifln < 0 || edifln > EDIFLLAST || ediflcheck[edifln] != ediflchar1)
    goto edifldefault;

  edifln = edifltable[edifln];

  /* edifln is what to do for this token type in this state.
     Negative => reduce, -edifln is rule number.
     Positive => shift, edifln is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (edifln < 0)
    {
      if (edifln == EDIFLFLAG)
	goto ediflerrlab;
      edifln = -edifln;
      goto ediflreduce;
    }
  else if (edifln == 0)
    goto ediflerrlab;

  if (edifln == EDIFLFINAL)
    EDIFLACCEPT;

  /* Shift the lookahead token.  */

#if EDIFLDEBUG != 0
  if (edifldebug)
    fprintf(stderr, "Shifting token %d (%s), ", ediflchar, edifltname[ediflchar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (ediflchar != EDIFLEOF)
    ediflchar = EDIFLEMPTY;

  *++ediflvsp = edifllval;
#ifdef EDIFLLSP_NEEDED
  *++edifllsp = edifllloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (ediflerrstatus) ediflerrstatus--;

  ediflstate = edifln;
  goto ediflnewstate;

/* Do the default action for the current state.  */
edifldefault:

  edifln = edifldefact[ediflstate];
  if (edifln == 0)
    goto ediflerrlab;

/* Do a reduction.  edifln is the number of a rule to reduce with.  */
ediflreduce:
  edifllen = ediflr2[edifln];
  if (edifllen > 0)
    ediflval = ediflvsp[1-edifllen]; /* implement default value of the action */

#if EDIFLDEBUG != 0
  if (edifldebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       edifln, ediflrline[edifln]);

      /* Print the symbols being reduced, and their result.  */
      for (i = ediflprhs[edifln]; ediflrhs[i] > 0; i++)
	fprintf (stderr, "%s ", edifltname[ediflrhs[i]]);
      fprintf (stderr, " -> %s\n", edifltname[ediflr1[edifln]]);
    }
#endif


  switch (edifln) {

case 2:
#line 124 "parser.yac"
{ 
			if ((ediflvsp[-3].lval != 2) || (ediflvsp[-2].lval != 0) || (ediflvsp[-1].lval != 0))
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : unable to read this version of edif.\n");
				exit (1);
			}
		;
    break;}
case 3:
#line 135 "parser.yac"
{ 
			if (ediflvsp[-1].lval != 0)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : EdifLevel incorrect ( must be 0 ).\n");
				exit (1);
			}
		;
    break;}
case 10:
#line 167 "parser.yac"
{
			lofig_list *ptf;
			char       *cell_name;
                        
        
			cell_name = namealloc(ediflvsp[0].sval);
                        
			if( !( ptf = get_figure_pt( cell_name ) ) )  
			{
				EDIFL_PTFIG = addlofig( cell_name );
				EDIFL_NOLOAD_FIG = 0; 
				EDIFL_NOLOAD_LOCON = 0;
			}
			else
			{
				if( cell_name == EDIFL_FIGNAME )
					EDIFL_PTFIG = EDIFL_LOFIG;
				else
					EDIFL_PTFIG = ptf;

				EDIFL_BASE_CELL = incatalog( cell_name );

				if( ptf->LOCON && EDIFL_BASE_CELL || ptf->LOSIG )
					EDIFL_NOLOAD_FIG = 1; 
				else
					EDIFL_NOLOAD_FIG = 0; 

				EDIFL_NOLOAD_LOCON = ( ptf->LOCON ) ? 1 : 0;

			}
			EDIFL_INDEX = 0;
		;
    break;}
case 11:
#line 200 "parser.yac"
{
			EDIFL_PTFIG->MODE = 'A';
		;
    break;}
case 16:
#line 217 "parser.yac"
{
			if( EDIFL_BASE_CELL && EDIFL_PTFIG == EDIFL_LOFIG )
				EDIFL_BLACKBOX = 'Y';
		;
    break;}
case 28:
#line 260 "parser.yac"
{ 
			lofig_list      *ptf;
			char            *cell_name;
                        
			cell_name = namealloc(ediflvsp[0].sval);

			EDIFL_BASE_CELL = 0;

			if (!(ptf = get_figure_pt(cell_name)))
			{
				EDIFL_PTFIG = addlofig (ediflvsp[0].sval);
				EDIFL_NOLOAD_FIG = 0;
				EDIFL_NOLOAD_LOCON = 0;
			}
			else
			{
				if( cell_name == EDIFL_FIGNAME )
					EDIFL_PTFIG = EDIFL_LOFIG;
				else
					EDIFL_PTFIG = ptf;

				EDIFL_BASE_CELL = incatalog( cell_name );

				if( ptf->LOCON && EDIFL_BASE_CELL || ptf->LOSIG )
					EDIFL_NOLOAD_FIG = 1; 
				else
					EDIFL_NOLOAD_FIG = 0; 

				EDIFL_NOLOAD_LOCON = (ptf->LOCON) ? 1 : 0;
			}
			EDIFL_INDEX = 0;
		;
    break;}
case 29:
#line 293 "parser.yac"
{
			loins_list *inst_pt;
/*          chain_list *ptchain; */

			EDIFL_PTFIG->MODE = 'A';

			/* free all instance->USER that are filled with chain_list data */
			for( inst_pt = EDIFL_PTFIG->LOINS; inst_pt; inst_pt=inst_pt->NEXT )
			{
				if( inst_pt->USER != (struct ptype *)NULL )
				{
/*					ptchain = (chain_list *)inst_pt->USER;
					while (ptchain)
					{
						fprintf(stderr, "elem = %s\n",(char *)ptchain->DATA);
						ptchain = ptchain->NEXT;
					}
*/
					freechain( (chain_list *)inst_pt->USER );

					inst_pt->USER = (struct ptype *)NULL;
				}
			}
		;
    break;}
case 32:
#line 323 "parser.yac"
{
			EDIFL_RIPPER_CELL = EDIFL_PTFIG->NAME;
		;
    break;}
case 40:
#line 348 "parser.yac"
{
			if( EDIFL_BASE_CELL && EDIFL_PTFIG == EDIFL_LOFIG )
				EDIFL_BLACKBOX = 'Y';
		;
    break;}
case 45:
#line 366 "parser.yac"
{ 
			if (EDIFL_NOLOAD_FIG == 0)
			{
				char       *array_cname;
				char       *array_sname;
				locon_list *ptcon;
				char        new_sig_name[MAXSTRLEN];
				char        end;
				losig_list *vdd_sig       = (losig_list *) NULL;
				losig_list *vss_sig       = (losig_list *) NULL;
				locon_list *EDIFL_INS_PTCON  = (locon_list *) NULL;
				locon_list *EDIFL_PTCON      = (locon_list *) NULL;

				/* scan all instances */
				for( EDIFL_PTINS = EDIFL_PTFIG->LOINS; EDIFL_PTINS; EDIFL_PTINS=EDIFL_PTINS->NEXT ) 
				{
					if( EDIFL_PTINS->FIGNAME != EDIFL_RIPPER_CELL )
					{
						for (EDIFL_INS_PTCON  = EDIFL_PTINS->LOCON; 
						     EDIFL_INS_PTCON != (locon_list *) NULL;
						     EDIFL_INS_PTCON  = EDIFL_INS_PTCON->NEXT)
						{
							if (EDIFL_INS_PTCON->SIG == NULL)
							{
								sprintf(new_sig_name,"unused_%d",++EDIFL_INDEX);
								if ( EDIFL_PTINS->USER == (struct ptype *) NULL ||
								    !is_portinstance( EDIFL_PTINS, EDIFL_INS_PTCON->NAME ) )
								{
									fprintf (stderr, "*** mbk warning *** edifloadlofig :\n");
									fprintf (stderr, "Connector '%s' ",EDIFL_INS_PTCON->NAME);
									fprintf (stderr, "of instance '%s' ",EDIFL_PTINS->INSNAME);
									fprintf (stderr, "has no signal in figure ");
									fprintf (stderr, "'%s'.\n",EDIFL_PTFIG->NAME);
									fprintf(stderr, "==> Creation of signal '%s'\n", new_sig_name); 
								}
	
								EDIFL_INS_PTCON->SIG = addlosig (EDIFL_PTFIG, EDIFL_INDEX,
								                              addchain( NULL, namealloc( new_sig_name ) ),
									                              INTERNAL, NULL );
							}
						}
					}


					/* scan all figure's connectors */
					for  (EDIFL_PTCON  = EDIFL_PTFIG->LOCON; 
					      EDIFL_PTCON != (locon_list *) NULL;
					      EDIFL_PTCON  = EDIFL_PTCON->NEXT)
					{
						if (EDIFL_PTCON->SIG == NULL) 
						{
							sprintf(new_sig_name,"unused_%d",++EDIFL_INDEX);

							fprintf (stderr, "*** mbk warning *** ");
							fprintf (stderr, "edifloadlofig : \n");
							fprintf (stderr, "connector '%s' ",EDIFL_PTCON->NAME);
							fprintf (stderr, "of figure '%s' ",EDIFL_PTFIG->NAME);
							fprintf (stderr, "has no signal\n");
							fprintf(stderr, "==> Creation of signal '%s'\n", new_sig_name); 

							EDIFL_PTCON->SIG = addlosig (EDIFL_PTFIG, EDIFL_INDEX,
							                          addchain( NULL, namealloc( new_sig_name ) ),
							                          EXTERNAL, NULL );

						}
					}
				}
			}
		;
    break;}
case 50:
#line 449 "parser.yac"
{
			if( EDIFL_NOLOAD_FIG == 0 )
			{
				lofig_list *EDIFL_INS_PTMODEL  = (lofig_list *) NULL;
				chain_list *EDIFL_INS_SIGCHAIN = (chain_list *) NULL;
				locon_list *EDIFL_INS_PTCON    = (locon_list *) NULL;

				EDIFL_INS_PTMODEL = getlofig( EDIFL_INS_MODELNAME, 'P' );
				EDIFL_INS_SIGCHAIN = NULL;

				for( EDIFL_INS_PTCON = EDIFL_INS_PTMODEL->LOCON;
				     EDIFL_INS_PTCON != NULL; 
				     EDIFL_INS_PTCON = EDIFL_INS_PTCON->NEXT) 
					EDIFL_INS_SIGCHAIN = addchain( EDIFL_INS_SIGCHAIN, NULL );

				EDIFL_PTINS = addloins( EDIFL_PTFIG, ediflvsp[-2].sval, EDIFL_INS_PTMODEL, EDIFL_INS_SIGCHAIN );

				EDIFL_V_PORTINSTANCE = addchain(EDIFL_V_PORTINSTANCE, NULL);
			}
		;
    break;}
case 51:
#line 470 "parser.yac"
{
			EDIFL_PTINS->USER = (struct ptype *)EDIFL_V_PORTINSTANCE->DATA; 
		;
    break;}
case 56:
#line 487 "parser.yac"
{
			EDIFL_V_PORTINSTANCE->DATA = addchain( EDIFL_V_PORTINSTANCE->DATA, (void *)namealloc( ediflvsp[-2].sval ) );
		;
    break;}
case 57:
#line 494 "parser.yac"
{ 
			EDIFL_INS_MODELNAME = namealloc( ediflvsp[-1].sval ); 
		;
    break;}
case 58:
#line 498 "parser.yac"
{ 
			EDIFL_INS_MODELNAME = namealloc( ediflvsp[-2].sval ); 
		;
    break;}
case 60:
#line 509 "parser.yac"
{
			if (EDIFL_NOLOAD_FIG == 0)
			{
				EDIFL_PTSIG = addlosig (EDIFL_PTFIG, ++EDIFL_INDEX, addchain (NULL, CheckCadenceNetError( ediflvsp[0].sval ) ), 'Z', NULL);
				EDIFL_SIGTYPE = INTERNAL;
			}
			EDIFL_BUS_WIDTH = 1;
		;
    break;}
case 61:
#line 518 "parser.yac"
{ 
			if (EDIFL_NOLOAD_FIG == 0)
			{
				EDIFL_PTSIG->TYPE = EDIFL_SIGTYPE; 
			}
		;
    break;}
case 62:
#line 525 "parser.yac"
{
			if (EDIFL_NOLOAD_FIG == 0)
			{
				int         i;
				int         begin;
				int         end;
				char        net_name[MAXSTRLEN];
				losig_list *EDIFL_SIG_TMP = (losig_list *) NULL;

				if( ediflvsp[-1].lval <= 0 )
				{ 
					fprintf(stderr, "*** mbk error *** edifloadlofig : Array width must be > 0\n");
					exit( 1 ); 
				}

				for (i=0; i < ediflvsp[-1].lval; i++)
				{
					if( (CheckCadenceBusError (ediflvsp[-2].sval, &begin, &end)) && (i <= abs( end - begin) ) )
						sprintf(&net_name[0], "%s %d", EDIFL_ARRAYPORTNAME, ( begin <= end ) ? begin + i : begin - i); 
					else
						sprintf(&net_name[0], "%s %d", ediflvsp[-2].sval, i); 

					EDIFL_PTSIG = addlosig (EDIFL_PTFIG, ++EDIFL_INDEX, addchain (NULL, namealloc (net_name)), 'Z', NULL);
					EDIFL_SIGTYPE = INTERNAL;
					EDIFL_BUS_WIDTH = ediflvsp[-1].lval;
				}

				EDIFL_SIG_TMP = EDIFL_PTSIG;
				for (i=0; i<EDIFL_BUS_WIDTH; i++)
				{
        			EDIFL_PORTLIST_SIG = addchain(EDIFL_PORTLIST_SIG, (void *)EDIFL_PTSIG);
        			EDIFL_PTSIG = EDIFL_PTSIG->NEXT;
				}
				EDIFL_PTSIG = EDIFL_SIG_TMP;
				EDIFL_PORTLIST_SIG_TMP = EDIFL_PORTLIST_SIG;
			}
		;
    break;}
case 63:
#line 563 "parser.yac"
{
			if (EDIFL_NOLOAD_FIG == 0)
			{
				int         i;
				losig_list *ptsig;

				freechain( (chain_list *)EDIFL_PORTLIST_SIG );
				EDIFL_PORTLIST_SIG = (chain_list *)NULL;

				ptsig = EDIFL_PTSIG;
				for (i = EDIFL_BUS_WIDTH - 1; i >= 0; i--)
				{
					ptsig->TYPE = EDIFL_SIGTYPE;
					ptsig = ptsig->NEXT;
				}
			}
		;
    break;}
case 72:
#line 607 "parser.yac"
{
			EDIFL_PORTLIST = 1;
			EDIFL_PORTLIST_NUM = 0;
			EDIFL_PORTLIST_SIG = EDIFL_PORTLIST_SIG_TMP;
		;
    break;}
case 73:
#line 613 "parser.yac"
{
			EDIFL_PORTLIST = 0;

			if (EDIFL_PORTLIST_NUM < EDIFL_BUS_WIDTH)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : ");
				fprintf (stderr, "PortList width < signal bus '%s' width ( line %d ).\n", 
				                  edif_busname( getsigname(EDIFL_PTSIG)), edifllineno );
				exit (1);
			}
		;
    break;}
case 76:
#line 633 "parser.yac"
{ 
			if (EDIFL_NOLOAD_FIG == 0)
			{
				int         i;
				losig_list  *ptsig;
				char         port_name[MAXSTRLEN];
				int          begin, end;
				locon_list  *EDIFL_PTCON = (locon_list *) NULL;

				ptsig = EDIFL_PTSIG;
				if (bus_nameref(EDIFL_PTFIG->LOCON, ediflvsp[-1].sval, EDIFL_BUS_WIDTH))
				{
					for (i = EDIFL_BUS_WIDTH - 1; i >= 0; i--)
					{
						if ( (CheckCadenceBusError (ediflvsp[-1].sval, &begin, &end)) && (i <= abs( end - begin) ) )
							sprintf(&port_name[0], "%s %d", EDIFL_ARRAYPORTNAME, (begin <= end) ? begin + i : begin - i); 
						else
							sprintf(&port_name[0], "%s %d", ediflvsp[-1].sval, i); 

						EDIFL_PTCON = getlocon (EDIFL_PTFIG, &port_name[0]);
						EDIFL_PTCON->SIG = ptsig;
						ptsig = ptsig->NEXT;
					}
					EDIFL_SIGTYPE = EXTERNAL;
				}
				else
				{
					fprintf (stderr, "*** mbk error *** edifloadlofig :\n"); 
					fprintf (stderr, "Connector '%s' in figure '%s' do not refer to an ARRAY construct",
					                 ediflvsp[-1].sval, EDIFL_PTFIG->NAME); 
					fprintf (stderr, "\n    or it is a bus with incompatible width than Signal Bus\n");
					exit (1);
				}
			}
		;
    break;}
case 77:
#line 669 "parser.yac"
{ 
			if (EDIFL_NOLOAD_FIG == 0)
			{
				int         i;
				char        port_name[MAXSTRLEN];
				char       *port_name_alloc;
				losig_list *ptsig; 
				int         begin, end;
				locon_list *EDIFL_PTCON = (locon_list *) NULL;

				ptsig = EDIFL_PTSIG;
				EDIFL_PTINS = getloins (EDIFL_PTFIG, ediflvsp[-2].sval);

				if( bus_nameref(EDIFL_PTINS->LOCON, ediflvsp[-4].sval, EDIFL_BUS_WIDTH))
				{
					if(  ( CheckCadenceBusError (ediflvsp[-4].sval, &begin, &end))
					   &&( (EDIFL_BUS_WIDTH - 1) == abs(end - begin) ) )
						sprintf(&port_name[0], "%s %d", EDIFL_ARRAYPORTNAME, ( begin <= end ) ? end : begin ); 
					else
						sprintf(&port_name[0], "%s %d", ediflvsp[-4].sval, EDIFL_BUS_WIDTH - 1); 

					port_name_alloc = namealloc( port_name );

					for (EDIFL_PTCON = EDIFL_PTINS->LOCON; EDIFL_PTCON; EDIFL_PTCON = EDIFL_PTCON->NEXT)
						if( port_name_alloc == EDIFL_PTCON->NAME)
							break;

					if (EDIFL_PTCON == (locon_list *) NULL)
					{
						fprintf (stderr, "*** mbk error *** edifloadlofig :");
						fprintf (stderr, " bus connector %s not found", ediflvsp[-4].sval);
						fprintf (stderr, " in instance %s", ediflvsp[-2].sval);
						fprintf (stderr, " of figure %s\n", EDIFL_PTINS->FIGNAME);
						exit( 1 );
					}
					else
					{
						for (i = EDIFL_BUS_WIDTH - 1; (i >= 0) && EDIFL_PTCON; i--)
						{
							EDIFL_PTCON->SIG = ptsig;
							ptsig         = ptsig->NEXT;
							EDIFL_PTCON      = EDIFL_PTCON->NEXT;
						}
					}
				}
				else
				{
					port_name_alloc = namealloc( CheckCadenceNetError( ediflvsp[-4].sval ) );

					for (EDIFL_PTCON = EDIFL_PTINS->LOCON; EDIFL_PTCON; EDIFL_PTCON = EDIFL_PTCON->NEXT)
						if( EDIFL_PTCON->NAME == port_name_alloc )
							break;
					fprintf (stderr, "*** mbk error *** edifloadlofig : ");  
					if (EDIFL_PTCON)
					{
						fprintf (stderr, "Connector '%s' in instance '%s' of figure '%s' do not refer", 
						                  port_name_alloc, ediflvsp[-2].sval, EDIFL_PTFIG->NAME); 
						fprintf (stderr, "\n    to an ARRAY construct or it is a bus with" );
						fprintf (stderr, "incompatible width than Signal Bus/n");
						exit( 1 );
					}
					else
					{
						fprintf (stderr, "Connector '%s' not found on instance '%s'\n", port_name_alloc, ediflvsp[-2].sval);   
						exit( 1 );
					} 
				}
			}
		;
    break;}
case 82:
#line 755 "parser.yac"
{ 
			if (EDIFL_NOLOAD_FIG == 0)
			{
				locon_list *EDIFL_PTCON = (locon_list *) NULL;

				EDIFL_PTCON = getlocon( EDIFL_PTFIG, CheckCadenceNetError( ediflvsp[-1].sval ) );

				if (!EDIFL_PORTLIST)
					EDIFL_PTCON->SIG = EDIFL_PTSIG;
				else
					EDIFL_PTCON->SIG = (losig_list *)EDIFL_PORTLIST_SIG->DATA;

				EDIFL_SIGTYPE = EXTERNAL;
				if (EDIFL_PORTLIST) 
				{
					if (++EDIFL_PORTLIST_NUM < EDIFL_BUS_WIDTH) 
						EDIFL_PORTLIST_SIG = EDIFL_PORTLIST_SIG->NEXT;
					else
						if (EDIFL_PORTLIST_NUM > EDIFL_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							         edif_busname(getsigname(EDIFL_PTCON->SIG)), edifllineno );
							exit( 1 );
						}
				}
			}
		;
    break;}
case 83:
#line 784 "parser.yac"
{ 
			if (EDIFL_NOLOAD_FIG == 0)
			{
				char       *port_name_ref;
				locon_list *EDIFL_PTCON = (locon_list *) NULL;

				port_name_ref = namealloc( CheckCadenceNetError( ediflvsp[-4].sval ) );

				EDIFL_PTINS = getloins (EDIFL_PTFIG, ediflvsp[-2].sval);
				for (EDIFL_PTCON = EDIFL_PTINS->LOCON; EDIFL_PTCON; EDIFL_PTCON = EDIFL_PTCON->NEXT)
				{
					if ( port_name_ref == EDIFL_PTCON->NAME)
					{
						if( !EDIFL_PORTLIST )
							EDIFL_PTCON->SIG = EDIFL_PTSIG;
						else 
							EDIFL_PTCON->SIG = (losig_list *)EDIFL_PORTLIST_SIG->DATA;
						break;
					}
				}

			if (EDIFL_PTCON == NULL)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig :");
				fprintf (stderr, " connector %s not found", ediflvsp[-4].sval);
				fprintf (stderr, " in instance %s", ediflvsp[-2].sval);
				fprintf (stderr, " of figure %s\n", EDIFL_PTINS->FIGNAME);
				exit( 1 );
			}

			if (EDIFL_PORTLIST) 
				if (++EDIFL_PORTLIST_NUM < EDIFL_BUS_WIDTH) 
				EDIFL_PORTLIST_SIG = EDIFL_PORTLIST_SIG->NEXT;
				else
					if (EDIFL_PORTLIST_NUM > EDIFL_BUS_WIDTH)
					{
						fprintf (stderr, "*** mbk error *** edifloadlofig : ");
						fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
						                  edif_busname(getsigname(EDIFL_PTCON->SIG)),
						                  edifllineno );
						exit (1);
					}
			}
		;
    break;}
case 84:
#line 829 "parser.yac"
{
			if (EDIFL_NOLOAD_FIG == 0)
			{
				char        port_name[MAXSTRLEN];
				int         begin, end;
				locon_list *EDIFL_PTCON = (locon_list *) NULL;

				if ( (CheckCadenceBusError (ediflvsp[-3].sval, &begin, &end))
				  && (ediflvsp[-2].lval <= abs( begin - end ) ) )
					sprintf(&port_name[0], "%s %d", EDIFL_ARRAYPORTNAME, ( begin <= end ) ? begin + ediflvsp[-2].lval : begin - ediflvsp[-2].lval ); 
				else
					sprintf(&port_name[0], "%s %d", ediflvsp[-3].sval, ediflvsp[-2].lval); 

				EDIFL_PTCON = getlocon (EDIFL_PTFIG, port_name);
				if (!EDIFL_PORTLIST)
					EDIFL_PTCON->SIG = EDIFL_PTSIG;
				else
					EDIFL_PTCON->SIG = (losig_list *)EDIFL_PORTLIST_SIG->DATA;

				EDIFL_SIGTYPE = EXTERNAL;
				if (EDIFL_PORTLIST) 
					if (++EDIFL_PORTLIST_NUM < EDIFL_BUS_WIDTH) 
						EDIFL_PORTLIST_SIG = EDIFL_PORTLIST_SIG->NEXT;
					else
						if (EDIFL_PORTLIST_NUM > EDIFL_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							                  edif_busname(getsigname(EDIFL_PTCON->SIG)),
							                  edifllineno );
							exit (1);
						}
			}
		;
    break;}
case 85:
#line 864 "parser.yac"
{

			if (EDIFL_NOLOAD_FIG == 0)
			{
				char        port_name[MAXSTRLEN];
				int         begin, end;
				locon_list *EDIFL_PTCON    = (locon_list *) NULL;
				char       *EDIFL_PORTNAME = (char *) NULL;

				EDIFL_PTINS = getloins (EDIFL_PTFIG, ediflvsp[-2].sval);

				if ( (CheckCadenceBusError (ediflvsp[-6].sval, &begin, &end) )
				  && (ediflvsp[-5].lval <= abs( begin - end ) ) )
					sprintf(&port_name[0], "%s %d", EDIFL_ARRAYPORTNAME, ( begin <= end ) ? begin + ediflvsp[-5].lval : begin - ediflvsp[-5].lval ); 
				else
					sprintf(&port_name[0], "%s %d", ediflvsp[-6].sval, ediflvsp[-5].lval); 

				EDIFL_PORTNAME = namealloc (&port_name[0]);
				for (EDIFL_PTCON = EDIFL_PTINS->LOCON; EDIFL_PTCON; EDIFL_PTCON = EDIFL_PTCON->NEXT)
				{
					if (EDIFL_PORTNAME == EDIFL_PTCON->NAME)
					{
						if (!EDIFL_PORTLIST)
							EDIFL_PTCON->SIG = EDIFL_PTSIG;
						else 
							EDIFL_PTCON->SIG = (losig_list *)EDIFL_PORTLIST_SIG->DATA;
						break;
					}
				}

				if (EDIFL_PTCON == NULL)
				{
					fprintf (stderr, "*** mbk error *** edifloadlofig : ");
					fprintf (stderr, "connector %s not found ", port_name);
					fprintf (stderr, " in instance %s", ediflvsp[-2].sval);
					fprintf (stderr, " of figure %s\n", EDIFL_PTINS->FIGNAME);
					exit (1);
				}

				if (EDIFL_PORTLIST) 
					if (++EDIFL_PORTLIST_NUM < EDIFL_BUS_WIDTH) 
						EDIFL_PORTLIST_SIG = EDIFL_PORTLIST_SIG->NEXT;
					else
						if (EDIFL_PORTLIST_NUM > EDIFL_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							                 edif_busname(getsigname(EDIFL_PTCON->SIG)),
							                 edifllineno );
							exit (1);
						}
			}
		;
    break;}
case 92:
#line 936 "parser.yac"
{ 
			if (EDIFL_NOLOAD_LOCON == 0)
			{
				addlocon( EDIFL_PTFIG, CheckCadenceNetError( ediflvsp[-2].sval ), NULL ,EDIFL_DIRECTION );
			}
		;
    break;}
case 93:
#line 943 "parser.yac"
{
			if (EDIFL_NOLOAD_LOCON == 0)
			{
				char port_name    [MAXSTRLEN];
				int i;
				int begin;
				int end;

				if( ediflvsp[-3].lval <= 0 )
				{ 
					fprintf(stderr, "*** mbk error *** edifloadlofig : Array width must be > 0\n"); 
					exit( 1 ); 
				}

				if ( (CheckCadenceBusError (ediflvsp[-4].sval, &begin, &end)) && ( (abs (end - begin) + 1) == ediflvsp[-3].lval) )
				{
					for (i=0; i < ediflvsp[-3].lval; i++)
					{
						sprintf(&port_name[0], "%s %d", EDIFL_ARRAYPORTNAME, ( begin <= end ) ? begin + i : begin - i ); 
						addlocon (EDIFL_PTFIG, &port_name[0], NULL ,EDIFL_DIRECTION);
					}
				}
				else
				{
					for (i=0; i < ediflvsp[-3].lval; i++)
					{
						sprintf(&port_name[0], "%s %d", ediflvsp[-4].sval, i); 
						addlocon (EDIFL_PTFIG, &port_name[0], NULL ,EDIFL_DIRECTION);
					}
				}
			}
		;
    break;}
case 98:
#line 989 "parser.yac"
{ 
			EDIFL_DIRECTION = UNKNOWN; 
		;
    break;}
case 99:
#line 993 "parser.yac"
{ 
			EDIFL_DIRECTION = IN; 
		;
    break;}
case 100:
#line 997 "parser.yac"
{ 
			EDIFL_DIRECTION = OUT; 
		;
    break;}
case 105:
#line 1014 "parser.yac"
{ 
			strcpy(ediflval.sval, ediflvsp[0].sval); 
		;
    break;}
case 106:
#line 1018 "parser.yac"
{ 
			char EDIFL_TMP [MAXSTRLEN];

			sprintf(EDIFL_TMP, "%ld", ediflvsp[0].lval); 
			strcpy(ediflval.sval, EDIFL_TMP); 
		;
    break;}
case 107:
#line 1025 "parser.yac"
{
			strcpy(ediflval.sval, ediflvsp[-2].sval); 
		;
    break;}
case 108:
#line 1029 "parser.yac"
{
			strcpy(ediflval.sval, ediflvsp[-2].sval);
		;
    break;}
case 109:
#line 1036 "parser.yac"
{
			strcpy(ediflval.sval, ediflvsp[-1].sval); 
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  ediflvsp -= edifllen;
  ediflssp -= edifllen;
#ifdef EDIFLLSP_NEEDED
  edifllsp -= edifllen;
#endif

#if EDIFLDEBUG != 0
  if (edifldebug)
    {
      short *ssp1 = ediflss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != ediflssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++ediflvsp = ediflval;

#ifdef EDIFLLSP_NEEDED
  edifllsp++;
  if (edifllen == 0)
    {
      edifllsp->first_line = edifllloc.first_line;
      edifllsp->first_column = edifllloc.first_column;
      edifllsp->last_line = (edifllsp-1)->last_line;
      edifllsp->last_column = (edifllsp-1)->last_column;
      edifllsp->text = 0;
    }
  else
    {
      edifllsp->last_line = (edifllsp+edifllen-1)->last_line;
      edifllsp->last_column = (edifllsp+edifllen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  edifln = ediflr1[edifln];

  ediflstate = ediflpgoto[edifln - EDIFLNTBASE] + *ediflssp;
  if (ediflstate >= 0 && ediflstate <= EDIFLLAST && ediflcheck[ediflstate] == *ediflssp)
    ediflstate = edifltable[ediflstate];
  else
    ediflstate = edifldefgoto[edifln - EDIFLNTBASE];

  goto ediflnewstate;

ediflerrlab:   /* here on detecting error */

  if (! ediflerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++ediflnerrs;

#ifdef EDIFLERROR_VERBOSE
      edifln = ediflpact[ediflstate];

      if (edifln > EDIFLFLAG && edifln < EDIFLLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -edifln if nec to avoid negative indexes in ediflcheck.  */
	  for (x = (edifln < 0 ? -edifln : 0);
	       x < (sizeof(edifltname) / sizeof(char *)); x++)
	    if (ediflcheck[x + edifln] == x)
	      size += strlen(edifltname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (edifln < 0 ? -edifln : 0);
		       x < (sizeof(edifltname) / sizeof(char *)); x++)
		    if (ediflcheck[x + edifln] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, edifltname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      ediflerror(msg);
	      free(msg);
	    }
	  else
	    ediflerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* EDIFLERROR_VERBOSE */
	ediflerror("parse error");
    }

  goto ediflerrlab1;
ediflerrlab1:   /* here on error raised explicitly by an action */

  if (ediflerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (ediflchar == EDIFLEOF)
	EDIFLABORT;

#if EDIFLDEBUG != 0
      if (edifldebug)
	fprintf(stderr, "Discarding token %d (%s).\n", ediflchar, edifltname[ediflchar1]);
#endif

      ediflchar = EDIFLEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  ediflerrstatus = 3;		/* Each real token shifted decrements this */

  goto ediflerrhandle;

ediflerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  edifln = edifldefact[ediflstate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (edifln) goto edifldefault;
#endif

ediflerrpop:   /* pop the current state because it cannot handle the error token */

  if (ediflssp == ediflss) EDIFLABORT;
  ediflvsp--;
  ediflstate = *--ediflssp;
#ifdef EDIFLLSP_NEEDED
  edifllsp--;
#endif

#if EDIFLDEBUG != 0
  if (edifldebug)
    {
      short *ssp1 = ediflss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != ediflssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

ediflerrhandle:

  edifln = ediflpact[ediflstate];
  if (edifln == EDIFLFLAG)
    goto ediflerrdefault;

  edifln += EDIFLTERROR;
  if (edifln < 0 || edifln > EDIFLLAST || ediflcheck[edifln] != EDIFLTERROR)
    goto ediflerrdefault;

  edifln = edifltable[edifln];
  if (edifln < 0)
    {
      if (edifln == EDIFLFLAG)
	goto ediflerrpop;
      edifln = -edifln;
      goto ediflreduce;
    }
  else if (edifln == 0)
    goto ediflerrpop;

  if (edifln == EDIFLFINAL)
    EDIFLACCEPT;

#if EDIFLDEBUG != 0
  if (edifldebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++ediflvsp = edifllval;
#ifdef EDIFLLSP_NEEDED
  *++edifllsp = edifllloc;
#endif

  ediflstate = edifln;
  goto ediflnewstate;
}
#line 1058 "parser.yac"


extern  char            edifltext[];
extern  FILE            *ediflin;


/*----------------------------------------------------------------------*/
/*      bus_nameref: checks that name ref is bus name ref and with      */
/*      the same width. It returns 1 if ok.                             */
/*      Do not forget that locon list is in reverse order.              */
/*----------------------------------------------------------------------*/

/*---------------------------------------------------------\
                     bus_nameref
\---------------------------------------------------------*/
static char bus_nameref( ptlocon, bnameref, bus_width )
locon_list *ptlocon;
char       *bnameref;
int         bus_width;
{
	int         i, n;
	char        port_name[MAXSTRLEN];
	char       *pname;
	locon_list *loconp;
	int         begin, end;

	bus_width --;
	if ( (!CheckCadenceBusError( bnameref, &begin, &end ) ) || (bus_width != abs( end - begin ) ) )
	{
		strcpy( EDIFL_ARRAYPORTNAME, bnameref );
		end = bus_width;
	}

	sprintf(&port_name[0], "%s %d", EDIFL_ARRAYPORTNAME, end ); 

	pname = namealloc( &port_name[0] );

	for (loconp = ptlocon; loconp != (locon_list *) NULL; loconp = loconp->NEXT)
		if (loconp->NAME == pname)
			break;

	if (loconp == (locon_list *) NULL)
		return 0;

	for( loconp = loconp->NEXT; loconp != (locon_list *) NULL; loconp = loconp->NEXT )
	{
		sprintf( &port_name[0], "%s %d", EDIFL_ARRAYPORTNAME, ( begin <= end ) ? --end : ++end );
		if ( ( loconp->NAME == namealloc( port_name ) ) && bus_width >= 0)
			bus_width--;
		else
			break;
	}

	return( bus_width == 0 );

} /* end of bus_nameref */

/*---------------------------------------------------------\
                     edifloadlofig
\---------------------------------------------------------*/
void edifloadlofig( ptfig, figname, mode )
lofig_list *ptfig;
char       *figname;
char        mode;
{
	char        filename[120];
	lofig_list *pt;
	losig_list *ptsig;
	losig_list *ptsignext;
	loins_list *ptins;
	loins_list *ptinsnext;

	static char Vierge = 1; /* first time */

	edifllineno = 0;

	sprintf( filename, "%s/%s.%s", WORK_LIB, figname, IN_LO );
	if( ( ediflin = mbkfopen( figname, IN_LO, READ_TEXT ) ) == NULL )
	{
		fprintf( stderr, "*** mbk error *** edifloadlofig : can't open file %s\n", filename );
		exit( 1 );
	}

	if( Vierge == 0 )
		ediflrestart( ediflin );
	Vierge = 0;

	EDIFL_LOFIG = ptfig;
	EDIFL_FIGNAME = figname;
	EDIFL_V_PORTINSTANCE = (chain_list *) NULL;

	if( ediflparse() != 0 )
	{
		fprintf( stderr, "*** mbk error *** edifloadlofig : abnormal parsing for %s\n", filename );
		exit( 1 );
	}

	if( fclose( ediflin ) != 0 )
	{
		fprintf(stderr, "*** mbk error *** edifloadlofig : can't close file %s\n", filename);
		exit(1);
	}

	if (EDIFL_BLACKBOX == 'Y')
	{
		ptfig->MODE = 'A';
		for (pt = HEAD_LOFIG; pt != NULL; pt = pt->NEXT)
		{
			if (pt == ptfig)
				break;
			for (ptins = ptfig->LOINS; ptins != NULL; ptins = ptins->NEXT)
			{
				if( pt->NAME ==  ptins->FIGNAME )
					break;
			}
			if (ptins == NULL)
				dellofig( pt->NAME );
		}

		for( pt = HEAD_LOFIG; pt != (lofig_list *) NULL; pt = pt->NEXT )
		{
			if( pt != ptfig )
			{
				for( ptsig = pt->LOSIG; ptsig != (losig_list *) NULL; ptsig = ptsig->NEXT )
					free( ptsig );
				pt->LOSIG = (losig_list *) NULL;

				for( ptins = pt->LOINS; ptins != (loins_list *) NULL; ptins = ptins->NEXT )
					delloins( pt , ptins->INSNAME );
				pt->MODE = 'P';
			}
		}
	}

	for (pt = HEAD_LOFIG; pt != NULL; pt = pt->NEXT) 
		if( pt != ptfig ) 
			pt->MODE = (pt->LOSIG == NULL) ? 'P' : 'A';
        else
			pt->MODE = 'A';

	REnamealloc( );

	del_patch( ptfig, 1 );

} /* end of edifloadlofig */

/*---------------------------------------------------------\
                     ediflerror
\---------------------------------------------------------*/
int ediflerror( String )
char *String;
{
        fprintf( stderr,
                 "*** mbk error *** edifloadlofig : %s at ligne %d on '%s'\n",
                 String, edifllineno + 1, edifltext );
        exit( 1 );
} /* end of ediflerror */

/*---------------------------------------------------------\
                     get_figure_pt
\---------------------------------------------------------*/
static lofig_list *get_figure_pt( Name )
char *Name;
{
	lofig_list *pt;

	for( pt = HEAD_LOFIG; pt; pt = pt->NEXT )
		if( pt->NAME == Name )
			return pt;

	return (lofig_list *)NULL;

} /* end of get_figure_pt */

/*---------------------------------------------------------\
                     is_portinstance
\---------------------------------------------------------*/
static char is_portinstance(inst_pt, Name)
loins_list *inst_pt;
char       *Name;
{
	chain_list      *chain_pt;

	chain_pt = (chain_list *)EDIFL_PTINS->USER;

	while( chain_pt )
	{
		if( Name == (char *)chain_pt->DATA )
			return 1;
		chain_pt = chain_pt->NEXT;
	}

	return 0;
} /* end of is_portinstance */

/*---------------------------------------------------------\
                     CheckCadenceNetError
\---------------------------------------------------------*/
static char *CheckCadenceNetError( Name )
char *Name;
{
	char  net_name[MAXSTRLEN];
	char *first;
	char *second;

	strcpy (net_name, Name);

	first = net_name;

	while( first )
	{
		if ( ( first = strchr( first, '_' ) ) != NULL )
		{
			second = first + 1;
			while( isdigit( *second ) ) second ++;

			if( ( second > first + 1 ) && ( second[ 0 ] == '_' ) && ( second[ 1 ] == '\0' ) )
			{
				first[ 0 ] = ' ';
				second[ 0 ] = '\0';
				return namealloc( net_name );
			}
			first ++;
		}
		else
		{
			return namealloc( Name );
		}
	}

	return namealloc( Name );

} /* fin de CheckCadenceNetError */

/*---------------------------------------------------------\
                     CheckCadenceBusError
\---------------------------------------------------------*/
static char CheckCadenceBusError(PortName, Min, Max)
char *PortName;
int  *Min;
int  *Max;
{
	char *array;
	char *first;
	char *middle;
	char  save;

	strcpy (EDIFL_ARRAYPORTNAME, PortName);

	first = EDIFL_ARRAYPORTNAME;

	while (first)
	{
		if ( (first = strchr (first, '_') ) != NULL )
		{
			first[0] = '\0';
			array = first + 1;
			while ( isdigit (*array) ) array ++;

			if ( ( *array != 0 ) && ( strncasecmp (array, "TO", 2) == NULL ) )
			{
				middle = array;
				save = middle [0];
				middle [0] = '\0';
				array += 2;
				while ( isdigit (*array) ) array ++;

				if ( ( array ) && ( *array == '_' ) )
				{
					array [0] = '\0';
					sscanf (first  + 1, "%d", Min);
					sscanf (middle + 2, "%d", Max);
					return 1;
				}
				middle [0] = save;
			}
			first[0] = '_';
			first ++;
		}
	}
	*Min = 0;
	*Max = 0;
	return 0;

} /* end of CheckCadenceBusError */

/*---------------------------------------------------------\
                     sig_merge
\---------------------------------------------------------*/
static void sig_merge(pt_lofig, sig1, sig2)
lofig_list *pt_lofig;
long        sig1;
long        sig2;
{
	losig_list *ls1, *ls2;
	locon_list *c;
	loins_list *i;
	lotrs_list *t;

    for (ls1 = pt_lofig->LOSIG; ls1; ls1 = ls1->NEXT) {
        if (ls1->INDEX == sig1)
            break;
    }

    for (ls2 = pt_lofig->LOSIG; ls2; ls2 = ls2->NEXT) {
        if (ls2->INDEX == sig2)
            break;
    }

    if (ls1 == NULL || ls2 == NULL) /* one of them not exists ! */
	{
        return;
    }

    if (ls1 == ls2) /* already joined!, just return */
        return;

    for (c = pt_lofig->LOCON; c; c = c->NEXT)
        if (c->SIG == ls2)
            c->SIG = ls1;

    for (i = pt_lofig->LOINS; i; i = i->NEXT)
        for (c = i->LOCON; c; c = c->NEXT)
            if (c->SIG == ls2)
                c->SIG = ls1;

    for (t = pt_lofig->LOTRS; t; t = t->NEXT) {
        if (t->GRID->SIG == ls2)
            t->GRID->SIG = ls1;
        if (t->DRAIN->SIG == ls2)
            t->DRAIN->SIG = ls1;
        if (t->SOURCE->SIG == ls2)
            t->SOURCE->SIG = ls1;
    }

    (void)addcapa(ls1, ls2->CAPA);
    (void)dellosig(pt_lofig, ls2->INDEX);
}

/*---------------------------------------------------------\
                     del_patch
\---------------------------------------------------------*/
static void del_patch(pt_lofig, master)
lofig_list *pt_lofig;
char        master;
{
	loins_list *i;
	loins_list *k;
	locon_list *c1, *c2;
	chain_list *ptchain;
	char *b;
	long j;
	long i1, i2;
	char buf[MAXSTRLEN];

	if( EDIFL_RIPPER_CELL == (char *) NULL)
		return;

    for (ptchain = pt_lofig->MODELCHAIN; ptchain != NULL; ptchain = ptchain->NEXT)
    {
		if ( EDIFL_RIPPER_CELL != ptchain->DATA )
        	del_patch( getlofig( ptchain->DATA, 'P'), 0 );
    }

    for (i = pt_lofig->LOINS; i; )
	{
        if (EDIFL_RIPPER_CELL == i->FIGNAME)
		{
			j = 0;
            do
			{
				sprintf (buf, "src %d", j);
   				b = namealloc (buf);

        		for (c1 = i->LOCON; c1; c1 = c1->NEXT)
                {
					if ( (c1->NAME == b) && ( c1->SIG ) )
					{
						i1 = c1->SIG->INDEX;

						sprintf (buf, "dst %d", j);
   						b = namealloc (buf);

        				for (c2 = i->LOCON; c2; c2 = c2->NEXT)
						{
							if ( (c2->NAME == b) && ( c2->SIG ) )
							{
								i2 = c2->SIG->INDEX;
								sig_merge(pt_lofig, i1, i2);
  								break;
							}
						}

                     break;
					}
				}

                j++;
			} while ( c1 );

			k = i->NEXT;
			delloins (pt_lofig, i->INSNAME);
			i = k;
		}
		else
		{
			i = i->NEXT;
		}
	}

	if( master == 1 )
		dellofig( EDIFL_RIPPER_CELL );
}

/*---------------------------------------------------------\
                     REnamealloc
\---------------------------------------------------------*/
static void REnamealloc( )
{
	lofig_list *t;
	char       *te;

	for (t = EDIFL_LOFIG; t; t = t->NEXT)
	{
		te = namealloc (t->NAME);
		if( te != t->NAME )
		{
			printf( "*** mbk warning *** edifloadlofig : instance name not namealloced !!!\n" );
			t->NAME = te;
		}
	}
}
