/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: flex.skl,v 1.2 94/01/04 14:33:15 vern Exp $
 */

#define FLEX_SCANNER

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

/* Use prototypes in function declarations. */
#define MG_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define MG_USE_CONST

#else	/* ! __cplusplus */

#ifdef __STDC__

#define MG_USE_PROTOS
#define MG_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */


#ifdef __TURBOC__
#define MG_USE_CONST
#endif


#ifndef MG_USE_CONST
#ifndef const
#define const
#endif
#endif


#ifdef MG_USE_PROTOS
#define MG_PROTO(proto) proto
#else
#define MG_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define MG_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define MG_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN mg_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.
 */
#define MG_START ((mg_start - 1) / 2)

/* Action number for EOF rule of a given start state. */
#define MG_STATE_EOF(state) (MG_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file".  Now included
 * only for backward compatibility with previous versions of flex.
 */
#define MG_NEW_FILE mgrestart( mgin )

#define MG_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define MG_BUF_SIZE 16384

typedef struct mg_buffer_state *MG_BUFFER_STATE;

extern int mgleng;
extern FILE *mgin, *mgout;

#ifdef __cplusplus
extern "C" {
#endif
	extern int mgwrap MG_PROTO(( void ));
#ifdef __cplusplus
	}
#endif

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		mgless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the mgless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define mgless(n) \
	do \
		{ \
		/* Undo effects of setting up mgtext. */ \
		*mg_cp = mg_hold_char; \
		mg_c_buf_p = mg_cp = mg_bp + n - MG_MORE_ADJ; \
		MG_DO_BEFORE_ACTION; /* set up mgtext again */ \
		} \
	while ( 0 )

#define unput(c) mgunput( c, mgtext_ptr )


struct mg_buffer_state
	{
	FILE *mg_input_file;

	char *mg_ch_buf;		/* input buffer */
	char *mg_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int mg_buf_size;

	/* Number of characters read into mg_ch_buf, not including EOB
	 * characters.
	 */
	int mg_n_chars;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int mg_is_interactive;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int mg_fill_buffer;

	/* Whether we've seen an EOF on this buffer. */
	int mg_eof_status;
#define EOF_NOT_SEEN 0
	/* "Pending" happens when the EOF has been seen but there's still
	 * some text to process.  Note that when we actually see the EOF,
	 * we switch the status back to "not seen" (via mgrestart()), so
	 * that the user can continue scanning by just pointing mgin at
	 * a new input file.
	 */
#define EOF_PENDING 1
	};

static MG_BUFFER_STATE mg_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define MG_CURRENT_BUFFER mg_current_buffer


/* mg_hold_char holds the character lost when mgtext is formed. */
static char mg_hold_char;

static int mg_n_chars;		/* number of characters read into mg_ch_buf */


int mgleng;

/* Points to current character in buffer. */
static char *mg_c_buf_p = (char *) 0;
static int mg_init = 1;		/* whether we need to initialize */
static int mg_start = 0;	/* start state number */

/* Flag which is used to allow mgwrap()'s to do buffer switches
 * instead of setting up a fresh mgin.  A bit of a hack ...
 */
static int mg_did_buffer_switch_on_eof;

static void mgunput MG_PROTO(( int c, char *buf_ptr ));
void mgrestart MG_PROTO(( FILE *input_file ));
void mg_switch_to_buffer MG_PROTO(( MG_BUFFER_STATE new_buffer ));
void mg_load_buffer_state MG_PROTO(( void ));
MG_BUFFER_STATE mg_create_buffer MG_PROTO(( FILE *file, int size ));
void mg_delete_buffer MG_PROTO(( MG_BUFFER_STATE b ));
void mg_init_buffer MG_PROTO(( MG_BUFFER_STATE b, FILE *file ));

static int mg_start_stack_ptr = 0;
static int mg_start_stack_depth = 0;
static int *mg_start_stack = 0;
static void mg_push_state MG_PROTO(( int new_state ));
static void mg_pop_state MG_PROTO(( void ));
static int mg_top_state MG_PROTO(( void ));

#ifndef mgtext_ptr
static void mg_flex_strcpy MG_PROTO(( char *, const char * ));
#endif

static void *mg_flex_alloc MG_PROTO(( unsigned int ));
static void *mg_flex_realloc MG_PROTO(( void *ptr, unsigned int ));
static void mg_flex_free MG_PROTO(( void * ));

#define mg_new_buffer mg_create_buffer

#define INITIAL 0
typedef unsigned char MG_CHAR;
typedef int mg_state_type;
FILE *mgin = (FILE *) 0, *mgout = (FILE *) 0;
extern char *mgtext;
#define mgtext_ptr mgtext

#ifdef __cplusplus
static int mginput MG_PROTO(( void ));
#else
static int input MG_PROTO(( void ));
#endif

static mg_state_type mg_get_previous_state MG_PROTO(( void ));
static mg_state_type mg_try_NUL_trans MG_PROTO(( mg_state_type current_state ));
static int mg_get_next_buffer MG_PROTO(( void ));
static void mg_fatal_error MG_PROTO(( const char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up mgtext.
 */
#define MG_DO_BEFORE_ACTION \
	mgtext_ptr = mg_bp; \
	mgleng = mg_cp - mg_bp; \
	mg_hold_char = *mg_cp; \
	*mg_cp = '\0'; \
	mg_c_buf_p = mg_cp;

#define MG_END_OF_BUFFER 46
static const short int mg_accept[125] =
    {   0,
        1,    1,   46,   45,    1,    2,    4,   39,   40,   45,
       41,   45,   43,   44,   42,   36,   43,   43,   43,   43,
       43,   43,   43,   43,   43,   25,   43,   43,   43,   43,
       37,   38,    1,    0,   44,   44,   43,    3,    0,   22,
       43,   43,   43,   43,   43,   43,   23,   24,   43,   43,
       43,   43,   43,   43,   12,   43,   43,   43,   43,   43,
       43,    0,   43,   43,   29,   28,   34,   35,   16,   43,
       43,   26,   43,   43,   27,   43,   43,   43,   43,   43,
       20,   17,   43,   43,   43,    9,   43,   32,   30,   31,
       18,    6,   43,   43,   33,   43,   43,   43,    7,   43,

       14,   43,   43,   10,   43,   19,   43,   43,   15,   21,
       43,   43,   43,   43,   43,   43,   13,   43,   43,    5,
       11,   43,    8,    0
    } ;

static const int mg_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    1,    1,    4,    5,    1,    1,    1,    6,
        7,    8,    9,   10,    9,   11,   12,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,    1,   14,    1,
       15,    1,    1,    1,   16,   16,   16,   16,   16,   16,
       16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
       16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
       17,    1,   18,    1,   16,    1,   19,   20,   21,   22,

       23,   24,   25,   26,   27,   16,   16,   28,   29,   30,
       31,   32,   16,   33,   34,   35,   16,   36,   37,   38,
       39,   16,   40,    1,   41,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const int mg_meta[42] =
    {   0,
        1,    1,    1,    1,    2,    1,    1,    2,    1,    1,
        2,    2,    2,    1,    1,    2,    2,    1,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    1,
        1
    } ;

static const short int mg_base[126] =
    {   0,
        0,    0,  121,  381,  118,  381,  381,  381,  381,   31,
      381,   84,   35,   34,  381,  381,   38,   40,   41,   42,
       43,   45,   46,   59,   53,   74,   61,   75,   87,   91,
      381,  381,   85,   66,   53,   64,   92,  381,   58,   94,
       95,   97,   99,  105,  107,  109,  111,  115,  119,  126,
      130,  131,  134,  136,  137,  144,  138,  148,  156,  149,
      162,  159,  166,  168,  170,  172,  182,  183,  185,  186,
      197,  200,  202,  205,  207,  208,  218,  222,  221,  223,
      224,  225,  226,  239,  238,  240,  243,  246,  251,  256,
      257,  258,  259,  262,  263,  264,  269,  275,  276,  279,

      280,  281,  283,  286,  298,  300,  301,  303,  304,  306,
      311,  317,  318,  319,  324,  329,  331,  332,  337,  339,
      342,  345,  347,  381,   54
    } ;

static const short int mg_def[126] =
    {   0,
      124,    1,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124,  125,  124,  124,  124,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      124,  124,  124,  124,  124,  124,  125,  124,  124,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  124,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,

      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,  125,
      125,  125,  125,    0,  124
    } ;

static const short int mg_nxt[423] =
    {   0,
        4,    5,    6,    7,    4,    8,    9,    4,   10,   11,
       12,   13,   14,   15,   16,   17,    4,    4,   18,   19,
       20,   17,   17,   17,   17,   21,   17,   22,   23,   24,
       17,   25,   26,   27,   28,   29,   30,   17,   17,   31,
       32,   34,   38,   35,   34,  124,   35,  124,  124,  124,
      124,   39,  124,  124,   39,   37,   39,   39,   39,   39,
      124,   39,   39,   34,   42,   35,  124,   46,  124,   39,
       62,   41,   43,   45,   40,   39,   36,   39,   36,   44,
       51,  124,  124,   47,   48,   52,   33,   53,   54,   49,
       39,   39,   55,   50,  124,   57,   36,   58,  124,  124,

       56,  124,  124,   39,  124,   59,  124,   39,   39,   60,
       39,   39,  124,   39,  124,   39,  124,   61,  124,   33,
      124,   39,  124,   39,   64,   39,  124,   39,   65,   63,
       66,   39,   70,  124,   67,   39,   68,  124,  124,   69,
       71,  124,   39,  124,  124,  124,   39,   39,   73,  124,
       39,  124,   39,   39,   39,  124,  124,  124,   72,  124,
       39,   74,   76,  124,   39,   39,   75,  124,   77,  124,
       78,   62,   39,  124,  124,  124,   37,  124,   39,  124,
       79,   82,   39,   83,   39,   80,   39,   81,   39,  124,
      124,  124,  124,  124,   84,   86,  124,  124,   39,   39,

       85,   39,   39,   87,  124,   89,   88,  124,   90,  124,
      124,  124,  124,   39,  124,  124,   39,  124,   39,   92,
       91,   39,   93,   39,   39,  124,   95,  124,  124,  124,
      124,  124,  124,  124,   39,  124,   94,   39,   39,   39,
       39,   39,   39,   96,   97,  124,  124,  124,  124,   98,
      124,  124,  124,  124,   39,   39,   39,   99,  124,   39,
      100,  101,   39,  124,  124,  124,  124,   39,  102,  124,
      124,  124,   39,   39,   39,   39,  124,  103,   39,   39,
       39,  104,  124,  124,  105,   39,  124,  124,  124,  124,
      124,   39,   39,  124,  124,   39,   39,   39,  106,   39,

      124,  108,   39,  107,  109,  124,  124,  124,  124,  110,
      124,  124,  124,  124,   39,  111,   39,   39,  124,   39,
       39,  113,   39,  124,  124,  124,  124,   39,  124,  115,
      112,  124,  114,   39,   39,   39,  124,  118,  124,  124,
       39,  124,  124,  117,  124,   39,  124,   39,   39,  124,
      119,  116,  124,   39,  124,   39,  124,  124,   39,  121,
      124,   39,  124,   39,  124,  124,  122,  120,  124,  124,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  123,
        3,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,

      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124
    } ;

static const short int mg_chk[423] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,   10,   13,   10,   14,   17,   14,   18,   19,   20,
       21,   13,   22,   23,   17,  125,   18,   19,   20,   21,
       25,   22,   23,   35,   20,   35,   24,   22,   27,   25,
       39,   19,   20,   21,   18,   24,   36,   27,   34,   20,
       25,   26,   28,   23,   23,   25,   33,   25,   25,   24,
       26,   28,   26,   24,   29,   27,   12,   28,   30,   37,

       26,   40,   41,   29,   42,   28,   43,   30,   37,   29,
       40,   41,   44,   42,   45,   43,   46,   30,   47,    5,
        3,   44,   48,   45,   42,   46,   49,   47,   43,   41,
       43,   48,   46,   50,   44,   49,   44,   51,   52,   45,
       49,   53,   50,   54,   55,   57,   51,   52,   51,    0,
       53,   56,   54,   55,   57,   58,   60,    0,   50,    0,
       56,   52,   54,   59,   58,   60,   53,    0,   56,   61,
       57,   62,   59,   63,    0,   64,   62,   65,   61,   66,
       58,   60,   63,   61,   64,   58,   65,   59,   66,   67,
       68,    0,   69,   70,   61,   64,    0,    0,   67,   68,

       63,   69,   70,   65,   71,   66,   65,   72,   66,   73,
        0,    0,   74,   71,   75,   76,   72,    0,   73,   71,
       70,   74,   73,   75,   76,   77,   76,    0,   79,   78,
       80,   81,   82,   83,   77,    0,   74,   79,   78,   80,
       81,   82,   83,   77,   78,   85,   84,   86,    0,   79,
       87,    0,    0,   88,   85,   84,   86,   80,   89,   87,
       83,   84,   88,   90,   91,   92,   93,   89,   85,   94,
       95,   96,   90,   91,   92,   93,   97,   87,   94,   95,
       96,   93,   98,   99,   94,   97,  100,  101,  102,    0,
      103,   98,   99,  104,    0,  100,  101,  102,   96,  103,

        0,   98,  104,   97,  100,  105,    0,  106,  107,  102,
      108,  109,    0,  110,  105,  103,  106,  107,  111,  108,
      109,  107,  110,    0,  112,  113,  114,  111,    0,  111,
      105,  115,  108,  112,  113,  114,  116,  114,  117,  118,
      115,    0,    0,  113,  119,  116,  120,  117,  118,  121,
      115,  112,  122,  119,  123,  120,    0,    0,  121,  118,
        0,  122,    0,  123,    0,    0,  119,  116,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  122,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,

      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124
    } ;

static mg_state_type mg_last_accepting_state;
static char *mg_last_accepting_cpos;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define mgmore() mgmore_used_but_not_detected
#define MG_MORE_ADJ 0
char *mgtext;
# line 1 "mg2mbk.lex"
# line 2 "mg2mbk.lex"
#include <string.h>
#include <ctype.h>
#include MUT_H
#include "y.tab.h"
static void zweep();
extern char *filenameforlex();
/* change lex input routine to a non case sensitive one */
#ifdef FLEX_SCANNER
#ifdef MG_INPUT
#undef MG_INPUT
#endif
#define MG_INPUT(buf,result,max_size) \
	do { \
	int c = getc(mgin); \
		result = (c == EOF) ? MG_NULL \
									: (buf[0] = isupper(c) ? tolower(c) : c, 1); \
	} while(0)

int mglineno;
#else /* using lex, for sure */
#ifdef input
#undef input
#endif
#define input()	(((mgtchar = mgsptr > mgsbuf ? U(*--mgsptr)    \
							: getc(mgin)) == 10 ?(mglineno++,mgtchar)   \
								: mgtchar) == EOF ? 0                    \
									: isupper(mgtchar) ? tolower(mgtchar) \
										: mgtchar)
#endif

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifdef MG_MALLOC_DECL
MG_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef MG_READ_BUF_SIZE
#define MG_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( mgtext, mgleng, 1, mgout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or MG_NULL,
 * is returned in "result".
 */
#ifndef MG_INPUT
#define MG_INPUT(buf,result,max_size) \
	if ( mg_current_buffer->mg_is_interactive ) \
		{ \
		int c = getc( mgin ); \
		result = c == EOF ? 0 : 1; \
		buf[0] = (char) c; \
		} \
	else if ( ((result = fread( buf, 1, max_size, mgin )) == 0) \
		  && ferror( mgin ) ) \
		MG_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "mgterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef mgterminate
#define mgterminate() return MG_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef MG_START_STACK_INCR
#define MG_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef MG_FATAL_ERROR
#define MG_FATAL_ERROR(msg) mg_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef MG_DECL
#define MG_DECL int mglex MG_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after mgtext and mgleng
 * have been set up.
 */
#ifndef MG_USER_ACTION
#define MG_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef MG_BREAK
#define MG_BREAK break;
#endif

MG_DECL
	{
	register mg_state_type mg_current_state;
	register char *mg_cp, *mg_bp;
	register int mg_act;

# line 40 "mg2mbk.lex"


	if ( mg_init )
		{
#ifdef MG_USER_INIT
		MG_USER_INIT;
#endif

		if ( ! mg_start )
			mg_start = 1;	/* first start state */

		if ( ! mgin )
			mgin = stdin;

		if ( ! mgout )
			mgout = stdout;

		if ( mg_current_buffer )
			mg_init_buffer( mg_current_buffer, mgin );
		else
			mg_current_buffer =
				mg_create_buffer( mgin, MG_BUF_SIZE );

		mg_load_buffer_state();

		mg_init = 0;
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		mg_cp = mg_c_buf_p;

		/* Support of mgtext. */
		*mg_cp = mg_hold_char;

		/* mg_bp points to the position in mg_ch_buf of the start of
		 * the current run.
		 */
		mg_bp = mg_cp;

		mg_current_state = mg_start;
mg_match:
		do
			{
			register MG_CHAR mg_c = mg_ec[MG_SC_TO_UI(*mg_cp)];
			if ( mg_accept[mg_current_state] )
				{
				mg_last_accepting_state = mg_current_state;
				mg_last_accepting_cpos = mg_cp;
				}
			while ( mg_chk[mg_base[mg_current_state] + mg_c] != mg_current_state )
				{
				mg_current_state = (int) mg_def[mg_current_state];
				if ( mg_current_state >= 125 )
					mg_c = mg_meta[(unsigned int) mg_c];
				}
			mg_current_state = mg_nxt[mg_base[mg_current_state] + (unsigned int) mg_c];
			++mg_cp;
			}
		while ( mg_base[mg_current_state] != 381 );

mg_find_action:
		mg_act = mg_accept[mg_current_state];

		MG_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( mg_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of MG_DO_BEFORE_ACTION */
			*mg_cp = mg_hold_char;
			mg_cp = mg_last_accepting_cpos;
			mg_current_state = mg_last_accepting_state;
			goto mg_find_action;

case 1:
MG_USER_ACTION
# line 41 "mg2mbk.lex"
{}
	MG_BREAK
case 2:
MG_USER_ACTION
# line 42 "mg2mbk.lex"
{
#ifdef FLEX_SCANNER
								mglineno++;
#endif
							}
	MG_BREAK
case 3:
MG_USER_ACTION
# line 47 "mg2mbk.lex"
{zweep('/');}
	MG_BREAK
case 4:
MG_USER_ACTION
# line 48 "mg2mbk.lex"
{zweep('\n');}
	MG_BREAK
case 5:
MG_USER_ACTION
# line 49 "mg2mbk.lex"
{zweep('}');}
	MG_BREAK
case 6:
MG_USER_ACTION
# line 50 "mg2mbk.lex"
{zweep('}');}
	MG_BREAK
case 7:
MG_USER_ACTION
# line 51 "mg2mbk.lex"
{zweep(';');}
	MG_BREAK
case 8:
MG_USER_ACTION
# line 52 "mg2mbk.lex"
{zweep(';');}
	MG_BREAK
case 9:
MG_USER_ACTION
# line 53 "mg2mbk.lex"
{return CELL;}
	MG_BREAK
case 10:
MG_USER_ACTION
# line 54 "mg2mbk.lex"
{return PLACE;}
	MG_BREAK
case 11:
MG_USER_ACTION
# line 55 "mg2mbk.lex"
{return TERMINAL;}
	MG_BREAK
case 12:
MG_USER_ACTION
# line 56 "mg2mbk.lex"
{return RA;}
	MG_BREAK
case 13:
MG_USER_ACTION
# line 57 "mg2mbk.lex"
{return STRETCH;}
	MG_BREAK
case 14:
MG_USER_ACTION
# line 58 "mg2mbk.lex"
{return WIRE;}
	MG_BREAK
case 15:
MG_USER_ACTION
# line 59 "mg2mbk.lex"
{return MWIDTH;}
	MG_BREAK
case 16:
MG_USER_ACTION
# line 60 "mg2mbk.lex"
{return HORIZ;}
	MG_BREAK
case 17:
MG_USER_ACTION
# line 61 "mg2mbk.lex"
{return VERTI;}
	MG_BREAK
case 18:
MG_USER_ACTION
# line 62 "mg2mbk.lex"
{return MLEFT;}
	MG_BREAK
case 19:
MG_USER_ACTION
# line 63 "mg2mbk.lex"
{return MRIGHT;}
	MG_BREAK
case 20:
MG_USER_ACTION
# line 64 "mg2mbk.lex"
{return MTOP;}
	MG_BREAK
case 21:
MG_USER_ACTION
# line 65 "mg2mbk.lex"
{return MBOTTOM;}
	MG_BREAK
case 22:
MG_USER_ACTION
# line 66 "mg2mbk.lex"
{return AT;}
	MG_BREAK
case 23:
MG_USER_ACTION
# line 67 "mg2mbk.lex"
{return MX;}
	MG_BREAK
case 24:
MG_USER_ACTION
# line 68 "mg2mbk.lex"
{return MY;}
	MG_BREAK
case 25:
MG_USER_ACTION
# line 69 "mg2mbk.lex"
{return R;}
	MG_BREAK
case 26:
MG_USER_ACTION
# line 70 "mg2mbk.lex"
{return NTR;}
	MG_BREAK
case 27:
MG_USER_ACTION
# line 71 "mg2mbk.lex"
{return PTR;}
	MG_BREAK
case 28:
MG_USER_ACTION
# line 72 "mg2mbk.lex"
{return COP;}
	MG_BREAK
case 29:
MG_USER_ACTION
# line 73 "mg2mbk.lex"
{return CON;}
	MG_BREAK
case 30:
MG_USER_ACTION
# line 74 "mg2mbk.lex"
{return COPS;}
	MG_BREAK
case 31:
MG_USER_ACTION
# line 75 "mg2mbk.lex"
{return COPW;}
	MG_BREAK
case 32:
MG_USER_ACTION
# line 76 "mg2mbk.lex"
{return CONW;}
	MG_BREAK
case 33:
MG_USER_ACTION
# line 77 "mg2mbk.lex"
{return PVIA;}
	MG_BREAK
case 34:
MG_USER_ACTION
# line 78 "mg2mbk.lex"
{return CXN;}
	MG_BREAK
case 35:
MG_USER_ACTION
# line 79 "mg2mbk.lex"
{return CXP;}
	MG_BREAK
case 36:
MG_USER_ACTION
# line 80 "mg2mbk.lex"
{return '=';}
	MG_BREAK
case 37:
MG_USER_ACTION
# line 81 "mg2mbk.lex"
{return '{';}
	MG_BREAK
case 38:
MG_USER_ACTION
# line 82 "mg2mbk.lex"
{return '}';}
	MG_BREAK
case 39:
MG_USER_ACTION
# line 83 "mg2mbk.lex"
{return '(';}
	MG_BREAK
case 40:
MG_USER_ACTION
# line 84 "mg2mbk.lex"
{return ')';}
	MG_BREAK
case 41:
MG_USER_ACTION
# line 85 "mg2mbk.lex"
{return ',';}
	MG_BREAK
case 42:
MG_USER_ACTION
# line 86 "mg2mbk.lex"
{return ';';}
	MG_BREAK
case 43:
MG_USER_ACTION
# line 87 "mg2mbk.lex"
{	mglval.s = mbkstrdup(mgtext);
								return STRING;}
	MG_BREAK
case 44:
MG_USER_ACTION
# line 89 "mg2mbk.lex"
{float f;
								sscanf(mgtext, "%f", &f);
								mglval.n = (long)(f * SCALE_X);
#ifdef GRIDDED
								mglval.n *= 2;
#endif
								return NUM;}
	MG_BREAK
case 45:
MG_USER_ACTION
# line 96 "mg2mbk.lex"
ECHO;
	MG_BREAK
case MG_STATE_EOF(INITIAL):
	mgterminate();

	case MG_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int mg_amount_of_matched_text = mg_cp - mgtext_ptr - 1;

		/* Undo the effects of MG_DO_BEFORE_ACTION. */
		*mg_cp = mg_hold_char;

		if ( mg_current_buffer->mg_input_file != mgin )
			{
			/* This can happen if we scan a file, mgwrap() returns
			 * 1, and then later the user points mgin at a new
			 * file to resume scanning.  We have to assure
			 * consistency between mg_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input file.
			 */
			mg_current_buffer->mg_input_file = mgin;
			mg_n_chars = mg_current_buffer->mg_n_chars;
			}

		/* Note that here we test for mg_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since mg_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( mg_c_buf_p <= &mg_current_buffer->mg_ch_buf[mg_n_chars] )
			{ /* This was really a NUL. */
			mg_state_type mg_next_state;

			mg_c_buf_p = mgtext_ptr + mg_amount_of_matched_text;

			mg_current_state = mg_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * mg_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			mg_next_state = mg_try_NUL_trans( mg_current_state );

			mg_bp = mgtext_ptr + MG_MORE_ADJ;

			if ( mg_next_state )
				{
				/* Consume the NUL. */
				mg_cp = ++mg_c_buf_p;
				mg_current_state = mg_next_state;
				goto mg_match;
				}

			else
				{
				goto mg_find_action;
				}
			}

		else switch ( mg_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				mg_did_buffer_switch_on_eof = 0;

				if ( mgwrap() )
					{
					/* Note: because we've taken care in
					 * mg_get_next_buffer() to have set up
					 * mgtext, we can now set up
					 * mg_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * MG_NULL, it'll still work - another
					 * MG_NULL will get returned.
					 */
					mg_c_buf_p = mgtext_ptr + MG_MORE_ADJ;

					mg_act = MG_STATE_EOF(MG_START);
					goto do_action;
					}

				else
					{
					if ( ! mg_did_buffer_switch_on_eof )
						MG_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				mg_c_buf_p =
					mgtext_ptr + mg_amount_of_matched_text;

				mg_current_state = mg_get_previous_state();

				mg_cp = mg_c_buf_p;
				mg_bp = mgtext_ptr + MG_MORE_ADJ;
				goto mg_match;

			case EOB_ACT_LAST_MATCH:
				mg_c_buf_p =
				&mg_current_buffer->mg_ch_buf[mg_n_chars];

				mg_current_state = mg_get_previous_state();

				mg_cp = mg_c_buf_p;
				mg_bp = mgtext_ptr + MG_MORE_ADJ;
				goto mg_find_action;
			}
		break;
		}

	default:
		MG_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of mglex */


/* mg_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int mg_get_next_buffer()
	{
	register char *dest = mg_current_buffer->mg_ch_buf;
	register char *source = mgtext_ptr - 1; /* copy prev. char, too */
	register int number_to_move, i;
	int ret_val;

	if ( mg_c_buf_p > &mg_current_buffer->mg_ch_buf[mg_n_chars + 1] )
		MG_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( mg_current_buffer->mg_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( mg_c_buf_p - mgtext_ptr - MG_MORE_ADJ == 1 )
			{
			/* We matched a singled characater, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = mg_c_buf_p - mgtext_ptr;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( mg_current_buffer->mg_eof_status != EOF_NOT_SEEN )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		mg_n_chars = 0;

	else
		{
		int num_to_read =
			mg_current_buffer->mg_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef MG_USES_REJECT
			MG_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			MG_BUFFER_STATE b = mg_current_buffer;

			int mg_c_buf_p_offset = mg_c_buf_p - b->mg_ch_buf;

			b->mg_buf_size *= 2;
			b->mg_ch_buf = (char *)
				mg_flex_realloc( (void *) b->mg_ch_buf,
						 b->mg_buf_size );

			if ( ! b->mg_ch_buf )
				MG_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			mg_c_buf_p = &b->mg_ch_buf[mg_c_buf_p_offset];

			num_to_read = mg_current_buffer->mg_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > MG_READ_BUF_SIZE )
			num_to_read = MG_READ_BUF_SIZE;

		/* Read in more data. */
		MG_INPUT( (&mg_current_buffer->mg_ch_buf[number_to_move]),
			mg_n_chars, num_to_read );
		}

	if ( mg_n_chars == 0 )
		{
		if ( number_to_move - MG_MORE_ADJ == 1 )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			mgrestart( mgin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			mg_current_buffer->mg_eof_status = EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	mg_n_chars += number_to_move;
	mg_current_buffer->mg_ch_buf[mg_n_chars] = MG_END_OF_BUFFER_CHAR;
	mg_current_buffer->mg_ch_buf[mg_n_chars + 1] = MG_END_OF_BUFFER_CHAR;

	/* mgtext begins at the second character in mg_ch_buf; the first
	 * character is the one which preceded it before reading in the latest
	 * buffer; it needs to be kept around in case it's a newline, so
	 * mg_get_previous_state() will have with '^' rules active.
	 */

	mgtext_ptr = &mg_current_buffer->mg_ch_buf[1];

	return ret_val;
	}


/* mg_get_previous_state - get the state just before the EOB char was reached */

static mg_state_type mg_get_previous_state()
	{
	register mg_state_type mg_current_state;
	register char *mg_cp;

	mg_current_state = mg_start;

	for ( mg_cp = mgtext_ptr + MG_MORE_ADJ; mg_cp < mg_c_buf_p; ++mg_cp )
		{
		register MG_CHAR mg_c = (*mg_cp ? mg_ec[MG_SC_TO_UI(*mg_cp)] : 1);
		if ( mg_accept[mg_current_state] )
			{
			mg_last_accepting_state = mg_current_state;
			mg_last_accepting_cpos = mg_cp;
			}
		while ( mg_chk[mg_base[mg_current_state] + mg_c] != mg_current_state )
			{
			mg_current_state = (int) mg_def[mg_current_state];
			if ( mg_current_state >= 125 )
				mg_c = mg_meta[(unsigned int) mg_c];
			}
		mg_current_state = mg_nxt[mg_base[mg_current_state] + (unsigned int) mg_c];
		}

	return mg_current_state;
	}


/* mg_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = mg_try_NUL_trans( current_state );
 */

#ifdef MG_USE_PROTOS
static mg_state_type mg_try_NUL_trans( mg_state_type mg_current_state )
#else
static mg_state_type mg_try_NUL_trans( mg_current_state )
mg_state_type mg_current_state;
#endif
	{
	register int mg_is_jam;
	register char *mg_cp = mg_c_buf_p;

	register MG_CHAR mg_c = 1;
	if ( mg_accept[mg_current_state] )
		{
		mg_last_accepting_state = mg_current_state;
		mg_last_accepting_cpos = mg_cp;
		}
	while ( mg_chk[mg_base[mg_current_state] + mg_c] != mg_current_state )
		{
		mg_current_state = (int) mg_def[mg_current_state];
		if ( mg_current_state >= 125 )
			mg_c = mg_meta[(unsigned int) mg_c];
		}
	mg_current_state = mg_nxt[mg_base[mg_current_state] + (unsigned int) mg_c];
	mg_is_jam = (mg_current_state == 124);

	return mg_is_jam ? 0 : mg_current_state;
	}


#ifdef MG_USE_PROTOS
static void mgunput( int c, register char *mg_bp )
#else
static void mgunput( c, mg_bp )
int c;
register char *mg_bp;
#endif
	{
	register char *mg_cp = mg_c_buf_p;

	/* undo effects of setting up mgtext */
	*mg_cp = mg_hold_char;

	if ( mg_cp < mg_current_buffer->mg_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = mg_n_chars + 2;
		register char *dest = &mg_current_buffer->mg_ch_buf[
					mg_current_buffer->mg_buf_size + 2];
		register char *source =
				&mg_current_buffer->mg_ch_buf[number_to_move];

		while ( source > mg_current_buffer->mg_ch_buf )
			*--dest = *--source;

		mg_cp += dest - source;
		mg_bp += dest - source;
		mg_n_chars = mg_current_buffer->mg_buf_size;

		if ( mg_cp < mg_current_buffer->mg_ch_buf + 2 )
			MG_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	if ( mg_cp > mg_bp && mg_cp[-1] == '\n' )
		mg_cp[-2] = '\n';

	*--mg_cp = (char) c;


	/* Note: the formal parameter *must* be called "mg_bp" for this
	 * macro to now work correctly.
	 */
	MG_DO_BEFORE_ACTION; /* set up mgtext again */
	}


#ifdef __cplusplus
static int mginput()
#else
static int input()
#endif
	{
	int c;

	*mg_c_buf_p = mg_hold_char;

	if ( *mg_c_buf_p == MG_END_OF_BUFFER_CHAR )
		{
		/* mg_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( mg_c_buf_p < &mg_current_buffer->mg_ch_buf[mg_n_chars] )
			/* This was really a NUL. */
			*mg_c_buf_p = '\0';

		else
			{ /* need more input */
			mgtext_ptr = mg_c_buf_p;
			++mg_c_buf_p;

			switch ( mg_get_next_buffer() )
				{
				case EOB_ACT_END_OF_FILE:
					{
					if ( mgwrap() )
						{
						mg_c_buf_p =
						mgtext_ptr + MG_MORE_ADJ;
						return EOF;
						}

					MG_NEW_FILE;
#ifdef __cplusplus
					return mginput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					mg_c_buf_p = mgtext_ptr + MG_MORE_ADJ;
					break;

				case EOB_ACT_LAST_MATCH:
#ifdef __cplusplus
					MG_FATAL_ERROR(
					"unexpected last match in mginput()" );
#else
					MG_FATAL_ERROR(
					"unexpected last match in input()" );
#endif
				}
			}
		}

	c = *mg_c_buf_p;
	*mg_c_buf_p = '\0';	/* preserve mgtext */
	mg_hold_char = *++mg_c_buf_p;

	return c;
	}


#ifdef MG_USE_PROTOS
void mgrestart( FILE *input_file )
#else
void mgrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! mg_current_buffer )
		mg_current_buffer = mg_create_buffer( mgin, MG_BUF_SIZE );

	mg_init_buffer( mg_current_buffer, input_file );
	mg_load_buffer_state();
	}


#ifdef MG_USE_PROTOS
void mg_switch_to_buffer( MG_BUFFER_STATE new_buffer )
#else
void mg_switch_to_buffer( new_buffer )
MG_BUFFER_STATE new_buffer;
#endif
	{
	if ( mg_current_buffer == new_buffer )
		return;

	if ( mg_current_buffer )
		{
		/* Flush out information for old buffer. */
		*mg_c_buf_p = mg_hold_char;
		mg_current_buffer->mg_buf_pos = mg_c_buf_p;
		mg_current_buffer->mg_n_chars = mg_n_chars;
		}

	mg_current_buffer = new_buffer;
	mg_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (mgwrap()) processing, but the only time this flag
	 * is looked at is after mgwrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	mg_did_buffer_switch_on_eof = 1;
	}


#ifdef MG_USE_PROTOS
void mg_load_buffer_state( void )
#else
void mg_load_buffer_state()
#endif
	{
	mg_n_chars = mg_current_buffer->mg_n_chars;
	mgtext_ptr = mg_c_buf_p = mg_current_buffer->mg_buf_pos;
	mgin = mg_current_buffer->mg_input_file;
	mg_hold_char = *mg_c_buf_p;
	}


#ifdef MG_USE_PROTOS
MG_BUFFER_STATE mg_create_buffer( FILE *file, int size )
#else
MG_BUFFER_STATE mg_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	MG_BUFFER_STATE b;

	b = (MG_BUFFER_STATE) mg_flex_alloc( sizeof( struct mg_buffer_state ) );

	if ( ! b )
		MG_FATAL_ERROR( "out of dynamic memory in mg_create_buffer()" );

	b->mg_buf_size = size;

	/* mg_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->mg_ch_buf = (char *) mg_flex_alloc( b->mg_buf_size + 2 );

	if ( ! b->mg_ch_buf )
		MG_FATAL_ERROR( "out of dynamic memory in mg_create_buffer()" );

	mg_init_buffer( b, file );

	return b;
	}


#ifdef MG_USE_PROTOS
void mg_delete_buffer( MG_BUFFER_STATE b )
#else
void mg_delete_buffer( b )
MG_BUFFER_STATE b;
#endif
	{
	if ( b == mg_current_buffer )
		mg_current_buffer = (MG_BUFFER_STATE) 0;

	mg_flex_free( (void *) b->mg_ch_buf );
	mg_flex_free( (void *) b );
	}


#ifdef MG_USE_PROTOS
void mg_init_buffer( MG_BUFFER_STATE b, FILE *file )
#else
void mg_init_buffer( b, file )
MG_BUFFER_STATE b;
FILE *file;
#endif
	{
	b->mg_input_file = file;

	/* We put in the '\n' and start reading from [1] so that an
	 * initial match-at-newline will be true.
	 */

	b->mg_ch_buf[0] = '\n';
	b->mg_n_chars = 1;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->mg_ch_buf[1] = MG_END_OF_BUFFER_CHAR;
	b->mg_ch_buf[2] = MG_END_OF_BUFFER_CHAR;

	b->mg_buf_pos = &b->mg_ch_buf[1];

	b->mg_is_interactive = file ? isatty( fileno(file) ) : 0;

	b->mg_fill_buffer = 1;

	b->mg_eof_status = EOF_NOT_SEEN;
	}


#ifdef MG_USE_PROTOS
static void mg_push_state( int new_state )
#else
static void mg_push_state( new_state )
int new_state;
#endif
	{
	if ( mg_start_stack_ptr >= mg_start_stack_depth )
		{
		int new_size;

		mg_start_stack_depth += MG_START_STACK_INCR;
		new_size = mg_start_stack_depth * sizeof( int );

		if ( ! mg_start_stack )
			mg_start_stack = (int *) mg_flex_alloc( new_size );

		else
			mg_start_stack = (int *) mg_flex_realloc(
					(void *) mg_start_stack, new_size );

		if ( ! mg_start_stack )
			MG_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	mg_start_stack[mg_start_stack_ptr++] = MG_START;

	BEGIN(new_state);
	}


static void mg_pop_state()
	{
	if ( --mg_start_stack_ptr < 0 )
		MG_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(mg_start_stack[mg_start_stack_ptr]);
	}


static int mg_top_state()
	{
	return mg_start_stack[mg_start_stack_ptr - 1];
	}


#ifdef MG_USE_PROTOS
static void mg_fatal_error( const char msg[] )
#else
static void mg_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( 1 );
	}



/* Redefine mgless() so it works in section 3 code. */

#undef mgless
#define mgless(n) \
	do \
		{ \
		/* Undo effects of setting up mgtext. */ \
		mgtext[mgleng] = mg_hold_char; \
		mg_c_buf_p = mgtext + n - MG_MORE_ADJ; \
		mg_hold_char = *mg_c_buf_p; \
		*mg_c_buf_p = '\0'; \
		mgleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef mgtext_ptr
#ifdef MG_USE_PROTOS
static void mg_flex_strcpy( char *s1, const char *s2 )
#else
static void mg_flex_strcpy( s1, s2 )
char *s1;
const char *s2;
#endif
	{
	while ( (*(s1++) = *(s2++)) )
		;
	}
#endif


#ifdef MG_USE_PROTOS
static void *mg_flex_alloc( unsigned int size )
#else
static void *mg_flex_alloc( size )
unsigned int size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef MG_USE_PROTOS
static void *mg_flex_realloc( void *ptr, unsigned int size )
#else
static void *mg_flex_realloc( ptr, size )
void *ptr;
unsigned int size;
#endif
	{
	return (void *) realloc( ptr, size );
	}

#ifdef MG_USE_PROTOS
static void mg_flex_free( void *ptr )
#else
static void mg_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}
# line 96 "mg2mbk.lex"


int mgwrap()
{
	return 1;
}

static void zweep(find_it)
char find_it;
{
char c;

	while (1) {
		if ((c = input()) == 0) {
			(void)fprintf(stderr, "reached EOF before expected end line %d\n",
								mglineno);
			exit(12);
		}
		/* special case for comments */
		if (c == '*')
			if (find_it == '/')
				if ((c = input()) == 0) {
					(void)fprintf(stderr,
										"reached EOF before expected end of comment\n");
					exit(12);
				}
		if (c == find_it)
			return;
	}
}

int mgerror(s)
char *s;
{
	fflush(stdout);
	fprintf(stderr, "modgen parser : syntax error line %d on %s file %s\n",
				mglineno, mgtext, filenameforlex());
	exit(13);
}
