
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: pat_addpains.c					*/
/* date		: Nov 22 1994						*/
/* version	: v105							*/
/* authors	: Pirouz BAZARGAN SABET					*/
/* content	: low-level pat function				*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H
#include PAT_H

/* ###--------------------------------------------------------------### */
/* function	: pat_addpains						*/
/* description	: create an empty PAINS (inspected instance) structure	*/
/*		  at the top of a list					*/
/* called func.	: mbkalloc						*/
/* ###--------------------------------------------------------------### */

struct pains *pat_addpains (lastpains, insname, filname)

struct pains   *lastpains;	/* pointer on the last pains structure	*/
char           *insname  ;	/* name of instance			*/
char           *filname  ;	/* name of generated file		*/

  {
  struct pains *ptins;

  ptins           = (struct pains *) mbkalloc (sizeof(struct pains));

  ptins->INSNAME  = insname;
  ptins->FILNAME  = filname;
  ptins->MODEL    = NULL;
  ptins->BUFFER   = NULL;
  ptins->INSTANCE = NULL;
  ptins->FILPNT   = NULL;

  ptins->NEXT     = lastpains;

  return (ptins);
  }
