
/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit :synthetiseur de FPGA                                         */
/*    Fichier :genx3000.c                                                     */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) :Burgun L.                              le : 08/07/1992     */
/*                                                                          */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/

#include <stdio.h>
#include MUT_H
#include LOG_H
#include BEH_H
#include "mapp3000.h"

/* ----------------------------------------------------------------------
typePtype_list : recherche si un variable existe dans une ptype_list en
               tant que PTYPE 
---------------------------------------------------------------------------
retour 	: NULL ou le pointeur 
---------------------------------------------------------------------------*/
ptype_list *typePtype_list(ptl,name)
ptype_list *ptl;
char *name;
{
ptype_list *tete = ptl;

while (tete)
   {
   if (!strcmp((char *) tete->TYPE,name))
      return tete;
   tete = tete->NEXT;
   }
return NULL;
}

/* ----------------------------------------------------------------------
CLB2Beh : creation d'une befig a partir d'une structure CLB
---------------------------------------------------------------------------
retour 	: une befig decrivant le clb 
---------------------------------------------------------------------------*/
befig_list *CLB2Beh(clb)
pCLB clb;
{
befig_list *befigAux;
chain_list *abl;
begen_list *genAux = NULL;
int *pentier;
biabl_list *biabl = NULL;
chain_list *cndabl = NULL;
chain_list *valabl = NULL;

befigAux = beh_addbefig(NULL,clb->NAME);


if (clb->BLOCK == CONFIOB)	/* ======== IOB =========*/
   {
   if (clb->PADTAG == CONFI)	/* entree */
      {
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("a"));
          
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("a"),'I','B');
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("s"),'O','B');

      befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("s"),
                                     createAtom("a"),NULL);
      }
   else				/* sortie */
      {
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("a"));
          
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("a"),'I','B');
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("s"),'O','B');

      if (clb->OITAG == CONFDIRECT)
         befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("s"),
                                     createAtom("a"),NULL);
      else
         befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("s"),
                                     notExpr(createAtom("a")),NULL);
      }
   }
else				/* ========== CLB ========== */
   {
		/* interface */

		/* berin */

   if (clb->YTAG == CONFQY)
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("qy"));

   if (clb->XTAG == CONFQX)
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("qx"));

   if (clb->XTAG == CONFQX || clb->YTAG == CONFQY)
      {
      if (clb->RSTDIRTAG == CONFRD)
         befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("rd"));
   
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("ck"));

      if (clb->ENCLKTAG == CONFEC)
         befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("ec"));
      }

   if (clb->DXTAG == CONFDI || clb->DYTAG == CONFDI)
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("di"));

   if ((typePtype_list(clb->ASSOCF,namealloc("e"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("e"))))
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("e"));

   if ((typePtype_list(clb->ASSOCF,namealloc("d"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("d"))))
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("d"));

   if ((typePtype_list(clb->ASSOCF,namealloc("c"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("c"))))
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("c"));
   
   if ((typePtype_list(clb->ASSOCF,namealloc("b"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("b"))))
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("b"));

   if ((typePtype_list(clb->ASSOCF,namealloc("a"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("a"))))
      befigAux->BERIN = beh_addberin(befigAux->BERIN,namealloc("a"));

		/* bepor */

   if (clb->YTAG != NIL)
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("y"),'O','B');

   if (clb->XTAG != NIL)
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("x"),'O','B');

   if (clb->XTAG == CONFQX || clb->YTAG == CONFQY)
      {
      if (clb->RSTDIRTAG == CONFRD)
         befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("rd"),'I','B');

      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("ck"),'I','B');

      if (clb->ENCLKTAG == CONFEC)
         befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("ec"),'I','B');
      }

   if (clb->DXTAG == CONFDI || clb->DYTAG == CONFDI)
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("di"),'I','B');

   if ((typePtype_list(clb->ASSOCF,namealloc("e"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("e"))))
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("e"),'I','B');

   if ((typePtype_list(clb->ASSOCF,namealloc("d"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("d"))))
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("d"),'I','B');

   if ((typePtype_list(clb->ASSOCF,namealloc("c"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("c"))))
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("c"),'I','B');

   if ((typePtype_list(clb->ASSOCF,namealloc("b"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("b"))))
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("b"),'I','B');

   if ((typePtype_list(clb->ASSOCF,namealloc("a"))) ||
       (typePtype_list(clb->ASSOCG,namealloc("a"))))
      befigAux->BEPOR = beh_addbepor(befigAux->BEPOR,namealloc("a"),'I','B');

   befigAux->BEPOR = (bepor_list *)reverse((chain_list *)befigAux->BEPOR);

		/* les sorties */

   if (clb->YTAG != NIL)
      {
      if (clb->YTAG == CONFQY)
         abl = createAtom("qy");
      else
         abl = (chain_list *) substAssocExpr(clb->EQUATEG,clb->ASSOCG);
      befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("y"),abl,NULL);
      }

   if (clb->XTAG != NIL)
      {
      if (clb->XTAG == CONFQX)
         abl = createAtom("qx");
      else
         abl = (chain_list *) substAssocExpr(clb->EQUATEF,clb->ASSOCF);
      befigAux->BEOUT = beh_addbeout(befigAux->BEOUT,namealloc("x"),abl,NULL);
      }

		/* les registres */

   if (clb->YTAG == CONFQY)
      {
      if (clb->DYTAG == CONFDI)
         valabl = charToExpr("di");
      if (clb->DYTAG == CONFF)
         valabl = (chain_list *) substAssocExpr(clb->EQUATEF,clb->ASSOCF);
      if (clb->DYTAG == CONFG)
         valabl = (chain_list *) substAssocExpr(clb->EQUATEG,clb->ASSOCG);

      if (clb->CLKTAG == CONFDIRECT)
         cndabl = charToExpr("(and (not ck) (not (stable ck)))");
      else
         cndabl = charToExpr("(and ck (not (stable ck)))");
      biabl = beh_addbiabl(NULL,"qy", cndabl, valabl);
      biabl->USER = NULL;
      befigAux->BEREG = beh_addbereg(befigAux->BEREG,namealloc("qy"),biabl,NULL);
      }

   if (clb->XTAG == CONFQX)
      {
      if (clb->DXTAG == CONFDI)
         valabl = charToExpr("di");
      if (clb->DXTAG == CONFF)
         valabl = (chain_list *) substAssocExpr(clb->EQUATEF,clb->ASSOCF);
      if (clb->DXTAG == CONFG)
         valabl = (chain_list *) substAssocExpr(clb->EQUATEG,clb->ASSOCG);

      if (clb->CLKTAG == CONFDIRECT)
         cndabl = charToExpr("(and (not ck) (not (stable ck)))");
      else
         cndabl = charToExpr("(and ck (not (stable ck)))");
      biabl = beh_addbiabl(NULL,"qx", cndabl, valabl);
      biabl->USER = NULL;
      befigAux->BEREG = beh_addbereg(befigAux->BEREG,namealloc("qx"),biabl,NULL);
      }

		/* les generic */

   pentier = (int *) mbkalloc(sizeof(int));
   *pentier = 1;
   genAux = beh_addbegen(genAux,"area","natural",(void *)pentier);
   befigAux->BEGEN = genAux;
   }

befigAux->CIRCUI = NULL;
befigAux->NEXT = NULL;
return befigAux;
}
