/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit :  Synthetiseur Logique                                       */
/*    Fichier :  sl_systempdea.c                                             */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) :  L. Burgun                            le : 30/09/1993     */
/*                                                                          */
/*    Modifie par : N. Dictus (STAGE DEA 95 : Bugs)     le : 01/02/1995     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/

#include "stdio.h"
#include "sys/ioctl.h"
#include MUT_H
#include LOG_H
#include BEH_H
#include MLO_H
#include "ctype.h"
#include "../menu/sl_corps.h"
#include "../ablorder/sl_order.h"
#include "../compil/lax_param.h"
#include "../mapping/types.h"
#include "../mapping/compile.h"
#include "../mapping/util.h"
#include "../mbk/sl_mbk.h"
#include "../cccc/c4_debug.h"
#include "../cccc/c4.h"
#include "sl_type.h"
#include "../compil/sl_util.h"

char AuVol ()
{
char car_lu = 10;

while (car_lu == 10)
	{
        system("stty -echo");	
	car_lu = getchar ();
        system("stty echo");	
	}
return ( car_lu );
}

void Continue()
{
char car_lu;

        system("stty echo");	
        printf("Press any key to continue...");
        system("stty -echo");	
	car_lu = getchar();
        system("stty echo");	
}
 
/*----------------------------------------------------------------------------
initializeParam : initialise les parametres de la synthese.
------------------------------------------------------------------------------
retour          : un pointeur sur une structure param.
------------------------------------------------------------------------------*/

param *initializeParam(optim,aux,level,delayPI,intermediate,optimPO,numTransN,numTransP)
int optim;
int aux;
int level;
ptype_list *delayPI;
chain_list *intermediate;
chain_list *optimPO;
int numTransN,numTransP;
{
param *par;

par = (param *) malloc (sizeof(param));
par->mode = optim;
par->aux = aux;
par->level = level;
par->delayPI = delayPI;
par->intermediate = intermediate;
par->earlyPO = optimPO;
par->numTransN = numTransN;
par->numTransP = numTransP;

par->maxSlopeTime = 1000;
par->impedancePI = NULL;
par->capaPO = NULL;
par->capaPI = NULL;

return(par);
}

/*----------------------------------------------------------------------------
initializeSLSystem:  alloue sys 
------------------------------------------------------------------------------
retour		: un pointeur sur une structure systeme. 
------------------------------------------------------------------------------*/

sl_system *initializeSLSystem()
{
sl_system *sl;

sl = (sl_system *) malloc (sizeof(sl_system));

sl->orderPI	= NULL;
sl->order	= 0;
sl->version	= (char *) malloc (100);
sl->fileVhdl	= (char *) malloc (100);
sl->fileOut	= (char *) malloc (100);
sl->file	= (char *) malloc (100);
sl->fileParam	= (char *) malloc (100);
sl->filePar	= (char *) malloc (100);

sl->file_lib	= (char *) malloc (10);
sl->cata_lib	= (char *) malloc (200);
sl->cata_save	= (char *) malloc (200);
sl->c4_lib	= (char *) malloc (10);
sl->in_lo	= (char *) malloc (5);
sl->out_lo	= (char *) malloc (5);
sl->out_ph	= (char *) malloc (5);

return( sl );
}

/* ===========================================================================================
msgBiblio : on trappe les exit -1 lors de la compilation de la bibliotheque 
---------------------------------------------------------------------------------------------
retour : void 
=========================================================================================== */

msgBiblio()
{
printf("Fatal Error\n");
exit(-1);
}


/* ================================================================================
mappingSC : fonction de mapping SC
---------------------------------------------------------------------------------------------
retour : une lofig
=================================================================================== */

lofig_list *mappingSC()
{
chain_list *fileLib;
int lit,maxLit,litRed,litReg,profMax,delaisMax,operBin;
char *sauve_cata_lib;
lofig_list * fig;
char *sauve_work_lib;

printf("Running Standard Cell Mapping...\n");
displayBefig(SL_BEH);

		/* compilation de la bibliotheque */
fileLib = (chain_list *) SLgetFile(SL_CATA_LIB,"vbe");
if (!fileLib)
   {
   printf("Mapping SC : Error\n--> There is no cell in directory '%s'\n",SL_CATA_LIB);
   exit(-1);
   }
 
VHB_HEDFIG = NULL;

coutAblBeh(SL_BEH,&lit,&maxLit,&litRed,&profMax,&delaisMax,&operBin,
           &litReg,0,SL_DELAYPI);

printf("=============================  INITIAL COST  ==================================\n");
 

printf("Total number of literals    = %d\n",lit);
printf("Number of reduced literals  = %d\n",litRed);
printf("Number of latches           = %d\n",litReg);
printf("Maximum logical depth       = %d\n",profMax);
printf("Maximum delay               = %.3f\n",((float) delaisMax)/1000);


printf("===============================================================================\n");

if (SL_TRACE)
   printf("Removing the auxiliary signals...\n");

mapCarExprBeh(SL_BEH,simplif10Expr);

if (SL_AUX == 0)
   compactExprBeh(SL_BEH,SL_OPTIM,SL_DELAYPI,SL_OPTIMPO,1,SL_GUARDEDAUX);

mapCarExprBeh(SL_BEH,simplif10Expr);

if (SL_TRACE)
   {
   coutAblBeh(SL_BEH,&lit,&maxLit,&litRed,&profMax,&delaisMax,&operBin,
              &litReg,0,SL_DELAYPI);
   printf("==============================  INITIAL COST  ==================================\n");

   printf("Total number of literals    = %d\n",lit);
   printf("Number of reduced literals  = %d\n",litRed);
   printf("Number of latches           = %d\n",litReg);
   printf("Maximum logical depth       = %d\n",profMax);
   printf("Maximum delay               = %.3f\n",((float) delaisMax)/1000);

   printf("===============================================================================\n");
   }

if (SL_TRACE && SL_AUX == 0)
   {
   printf("apres decompactage\n");
   displayBeh(SL_BEH,1);
   }

	/* on sauvegarde et on positionne MBK_CATA_LIB a SL_CATA_LIB */

sauve_cata_lib = (char *) mbkalloc (200);
sauve_work_lib = WORK_LIB;
WORK_LIB = *CATA_LIB;

if (!getenv("MBK_CATA_LIB"))
   strcpy(sauve_cata_lib,".");
else
   strcpy(sauve_cata_lib,getenv("MBK_CATA_LIB"));

put_CATA_LIB((char *) genNAME("%s",SL_CATA_LIB));

printf("Compiling library '%s'\n",SL_CATA_LIB);

signal(SIGTERM,msgBiblio);

while (fileLib)		
   {
   if (SL_TRACE)
      printf("compile %s\n",fileLib->DATA);
   if (compileVHDL(fileLib->DATA,NULL,0,NULL,1,0,1,1,0,renameSig,NULL) != NULL)
      {
      removeAuxBeh(VHB_HEDFIG,NULL);
      bddToAblBeh(VHB_HEDFIG, 0, 0);
      }
   fileLib = fileLib->NEXT;
   }

WORK_LIB = sauve_work_lib;

if (SL_TRACE)
   printf("Init Mapping \n");

mappSys = initMapping();

printf("Generating Expert System ...\n");
if (compileLibrary() == 0)
   return(NULL);

mapper();

printf("\n");

	/* Generation de la netlist en memoire */

fig = genMBKBeh(SL_BEH, 1, 1, SL_FILEOUT);

changeAblBeh(SL_BEH);

endMapping();

if (SL_TRACE)
   printf("End of mappingSC\n");
else
   printf("\n");

		/* on restore MBK_CATA_LIB */

put_CATA_LIB(sauve_cata_lib);
mbkfree(sauve_cata_lib);

return fig;
}

/*----------------------------------------------------------------------------
laxMap	: Encapsulation des fonctions de mapping pour LAX 
------------------------------------------------------------------------------
retour	: une lofig
------------------------------------------------------------------------------*/
lofig_list *laxMap(beh,trace,optim,aux,level,optimPO,delayPI,typeMap,c4_lib,target_lib)
befig_list *beh;
int trace;
int optim;
int aux;
int level;
chain_list *optimPO;
ptype_list *delayPI;
char typeMap;
char *c4_lib;
char *target_lib;
{
lofig_list *fig;

sl_sys = initializeSLSystem();

	/* initialisation de la structure sl_sys */

sl_sys->beh = beh;

sl_sys->fileVhdl = NULL;
sl_sys->file = NULL;
sl_sys->fileOut = beh->NAME;
sl_sys->file_lib = NULL;

sl_sys->mode = 1;
sl_sys->version = "3.01";
sl_sys->trace = trace;
sl_sys->option = typeMap; 
sl_sys->cata_lib = target_lib;
sl_sys->c4_lib = c4_lib;

sl_sys->par = initializeParam(optim,aux,level,delayPI,NULL,optimPO,4,4);

	/* la befig a deja ete compile, 
           on ne cree que les graphes avec compileVHDL */

if (compileVHDL(SL_VHDL,SL_ORDERPI,SL_ORDER,SL_PAR,
                SL_AUX,1,1,0,trace,nameInt,beh) == NULL)
   {
   printf("Compile VHDL : Error \n---> Compilation Aborted\n");
   return NULL;
   }
else
   {
		/* elimination des DC */

   removeDCBeh(SL_BEH);
   mapCarExprBeh(SL_BEH,simplif10Expr);

   if (SL_OPTION == 's')
      fig = mappingSC();
   else
      {
      printf("Bad Option : %c\n\n", SL_OPTION);
      exit(-1);
      }
   }

resetBdd();

return fig;
}
