
/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit :  synthese ACT1                                              */
/*    Fichier :  act1.h                                                     */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) :  Eudes Prado Lopes                       le : 20 /10/1993 */
/*                                                                          */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/


#define TYPE_T 0
#define TYPE_A 1
#define TYPE_I 3
#define TYPE_G 5

/* ======================================================================

Tableau de codage   :  T = 0, A = 1, I = 3, G = 5

  TYPE(L)	TYPE(H)		Resultat	Coupure		Somme
  ----------------------------------------------------------------------
  T		T		A				0
			        I				0
  T		A		G				1
  T		I		G				3
  				A		x		3
  T		G		A		x		5
  ----------------------------------------------------------------------
  A		A		G				2
  A		I		A		x		4
  A		G		A		x		6
  ----------------------------------------------------------------------
  I		I		A		x		6
  I		G		A		x		8
  G		G		A		x		10
  ----------------------------------------------------------------------

  ====================================================================== */

int coAct1;
char **tabName;
#define NAME_ATOM createAtom(*(tabName + pt->index - 2))
#define NAME_ZERO createAtom("'0'")
#define NAME_ONE createAtom("'1'")

chain_list *cutAct1();
int cutIntAct1();

	/* les defines pour les operateurs de la bibliotheque de macros */

#define INBUF 100
#define CLKBUF 101
#define OUTBUF 102
#define TRIBUFF 103
#define BIBUF 104
#define GAND2 105

#define GNAND2 106
#define GOR2 107
#define GNOR2 108
#define GXOR2 109
#define GMX4 110

#define AND2 111
#define AND2A 112
#define AND2B 113

#define NAND2 114
#define NAND2A 115
#define NAND2B 116

#define OR2 117
#define OR2A 118
#define OR2B 119

#define NOR2 120
#define NOR2A 121
#define NOR2B 122

#define AND3 123
#define AND3A 124
#define AND3B 125
#define AND3C 126

#define NAND3 127
#define NAND3A 128
#define NAND3B 129
#define NAND3C 130

#define OR3 131
#define OR3A 132
#define OR3B 133
#define OR3C 134

#define NOR3 135
#define NOR3A 136
#define NOR3B 137
#define NOR3C 138

#define AND4 139
#define AND4A 140
#define AND4B 141
#define AND4C 142
#define AND4D 143

#define NAND4 144
#define NAND4A 145
#define NAND4B 146
#define NAND4C 147
#define NAND4D 148

#define OR4 149
#define OR4A 150
#define OR4B 151
#define OR4C 152
#define OR4D 153

#define NOR4 154
#define NOR4A 155
#define NOR4B 156
#define NOR4C 157
#define NOR4D 158

#define XOR2 164
#define NXOR2 165

#define XO1 166
#define XO1A 167

#define XA1 168
#define XA1A 169

#define AX1 170
#define AX1A 171
#define AX1B 172

#define AO1 173
#define AO1A 174
#define AO1B 175

#define AO1C 176
#define AOI1A 177
#define AOI1B 178

#define AO2 179
#define AO2A 180
#define AOI2A 181

#define AOI2B 182
#define AO3 183
#define MAJ3 184
#define AO4A 185
#define AOI1 186
#define AO5A 187
#define AOI4 188
#define AOI3A 189

#define OA1 190
#define OA1A 191
#define OA1B 192

#define OA1C 193
#define OA2 194
#define OA2A 195

#define OA3 196
#define OA3A 197
#define OA3B 198

#define OA4A 200
#define OA5 201

#define OAI1 202
#define OAI2A 203

#define OAI3 204
#define OAI3A 205

#define BUF 206
#define BUFA 207
#define INV 208
#define INVA 209

#define MX2 210
#define MX2A 211
#define MX2B 212
#define MX2C 213
#define MX4 214
#define MXT 215
#define MXC1 216
#define CM8A 217

#define DL1 218
#define DL1A 219
#define DL1B 220
#define DL1C 221

#define DF1 222
#define DF1A 223
#define DF1B 224
#define DF1C 225
