
/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit :synthetiseur de FPGA					    */
/*    Fichier :driverX3000.c                                                */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) :PRADO LOPES E.                         le : 03/04/1992     */
/*                                                                          */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/

#include MUT_H
#include MLO_H
#include LOG_H
#include BEH_H
#include <math.h>
#include "../compil/lax_param.h"
#include "fp_type.h"
#include "../compil/sl_util.h"
#include "../bddorder/bdd_order.h"
#include "fpga.h"
#include "act1.h"




/*-------------------------------------------------------------------------
driverX3000 	: driving the Lofig to an ACT1 Actel file 
---------------------------------------------------------------------------
---------------------------------------------------------------------------*/
void driverX3000(lof)
lofig_list *lof;
{

}
/*-------------------------------------------------------------------------
driveX3000 	:generates a .xnf file from an optimized  Lofig {befig}
---------------------------------------------------------------------------
retour		: nothing
---------------------------------------------------------------------------*/
void driveX3000(myFig)
lofig_list *myFig;
{
beout_list *out;
beaux_list *aux;
bebus_list *bus;
bebux_list *bux;
bereg_list *reg;
binode_list *binode;
biabl_list *biabl;
list_locon *por;
FILE *myXnf;
char *fileName;

fileName = mbkalloc(sizeof(beh->name) +4)) ;
(void) strcpy(fileName,beh->NAME) ;
(void) strcat(fileName,".xnf") ;

if(!(myXnf = fopen(fileName,"w")))
	{
	(void) fprintf(stderr,"driveX3000 : File creation impossible.\n");
	return(-1);
	}

(void) fprintf(myXnf,"LCANET, 4\n") ;
(void) fprintf(myXnf,"USER, LAX, DATE : , Option: Area\n") ;
(void) fprintf(myXnf,"PROG, LAX,Lib = 3000\n") ;
(void) fprintf(myXnf,"PART, 3090PG175-70\n") ;
(void) fprintf(myXnf,"PWR, 0, GND\n") ;
(void) fprintf(myXnf,"PWR, 1, VCC\n") ;

por = myFig->LOCON ;
while(por)
	{
	if(por->DIRECTION == IN)
		{
		(void) fprintf(myXnf,"SYM, %s_IBUF, IBUF\n",por->NAME) ;
		(void) fprintf(myXnf,"PIN, I, I, %s,\n",por->NAME) ;
		(void) fprintf(myXnf,"PIN, O, O, _IN_%s,\n",por->NAME) ;
		(void) fprintf(myXnf,"END\n") ;
		(void) fprintf(myXnf,"EXT, %s, I,\n",por->NAME) ;
		}
	else if(por->DIRECTION == OUT)
		{
		(void) fprintf(myXnf,"SYM, %s_OBUF, OBUF\n",por->NAME) ;
		(void) fprintf(myXnf,"PIN, I, I, OUT_%s,\n",por->NAME) ;
		(void) fprintf(myXnf,"PIN, O, O, %s,\n",por->NAME) ;
		(void) fprintf(myXnf,"END\n") ;
		(void) fprintf(myXnf,"EXT, %s, O,\n",por->NAME) ;
		}
	else
		{
		(void) fprintf(stderr,"driveX3000: Bidirectional signal cannot be mapped\n") ;
		exit(-1) ;
		}
	por = por->NEXT ;
	}

ins = myFig->LOINS;
while (ins)
	{
	support = supportBdd(user->) ; ************************ HE HE *************/
	(void) fprintf(myXnf,"SYM, _OUT_%s_CLB%d, CLB, BLKNM=_OUT_%s\n",ins->INSNAME,driv_num3000,ins->INSNAME) ;
	user = ins->USER ;
	if (user->TYPE == F_TYPE)
		(void) fprintf(myXnf,"CFG, Base F\n") ;
	/*else if (user->TYPE == G_TYPE)
		(void) fprintf(myXnf,"CFG, Base G\n") ;*/
	else if (user->TYPE == FG_TYPE)
		(void) fprintf(myXnf,"CFG, Base FG\n") ;

	if(support == 2)
		(void) fprintf(myXnf,"CFG, Config X:F Y: RSTDIR: ENCLK: DX: DY: CLK: F:A:B\n") ;
	else if(support == 3)
		(void) fprintf(myXnf,"CFG, Config X:F Y: RSTDIR: ENCLK: DX: DY: CLK: F:A:B:C\n") ;
	else if(support == 4)
		(void) fprintf(myXnf,"CFG, Config X:F Y: RSTDIR: ENCLK: DX: DY: CLK: F:A:B:C:D\n") ;
	else if(support == 5)
		(void) fprintf(myXnf,"CFG, Config X:F Y: RSTDIR: ENCLK: DX: DY: CLK: F:A:B:C:D:E\n") ;

	equate = abl2Xnf(user->DATA) ;
	(void) fprintf(myXnf,"CFG, Equate F= (%s)\n",equate) ;
	free(equate) ;

	if(user->TYPE == FG_TYPE)
		{
		user = user->NEXT ;
		equate = abl2Xnf(user->DATA) ;
		(void) fprintf(myXnf,"CFG, Equate G= (%s)\n",equate) ;
		free(equate) ;
		}

	}

	/* on prend en compte les "aux" passes dans les "input" du circuit */

aux = beh->BEAUX;
while (aux)
   {
   if (searchInputCct(beh->CIRCUI,aux->NAME) != EMPTYTH ||
       searchOutputCct(beh->CIRCUI,aux->NAME) !=  NULL)
      if (aux->NODE != NULL && numberNodeBdd(aux->NODE)>numnode)
         numberAbl++;
   aux = aux->NEXT;
   }

reg = beh->BEREG;
while (reg)
   {
   binode = reg->BINODE;
   while (binode)
      {
      if (binode->CNDNODE != NULL && numberNodeBdd(binode->CNDNODE)>numnode)
         numberAbl++;
      if (binode->VALNODE != NULL && numberNodeBdd(binode->VALNODE)>numnode)
         numberAbl++;
      binode = binode->NEXT;
      }
   reg = reg->NEXT;
   }

bus = beh->BEBUS;
while (bus)
   {
   binode = bus->BINODE;
   while (binode)
      {
      if (binode->CNDNODE != NULL && numberNodeBdd(binode->CNDNODE)>numnode)
         numberAbl++;
      if (binode->VALNODE != NULL && numberNodeBdd(binode->VALNODE)>numnode)
         numberAbl++;
      binode = binode->NEXT;
      }
   bus = bus->NEXT;
   }

bux = beh->BEBUX;
while (bux)
   {
   binode = bux->BINODE;
   while (binode)
      {
      if (binode->CNDNODE != NULL && numberNodeBdd(binode->CNDNODE)>numnode)
        numberAbl++;
      if (binode->VALNODE != NULL && numberNodeBdd(binode->VALNODE)>numnode)
         numberAbl++;
      binode = binode->NEXT;
      }
   bux = bux->NEXT;
   }


return(numberAbl);
}


*----------------------------------------------------------------------------
abl2Xnf		: Constructs an xnf form an abl 
------------------------------------------------------------------------------
retour		: nothing
------------------------------------------------------------------------------*/
char *abl2Xnf(abl)
chaine_list *abl ;
{
}
