/*-------------------------------------------------------
 *
 *                Chaine de CAO & VLSI  Alliance
 *
 *   Produit: synthese FPGA
 *   Fichier: Mapp3000.h
 *
 *-------------------------------------------------------
 */

#ifndef __MAPPX3000__
/* #define __MAPPX3000__ __MAPPX#3000__*/

#define __MAPPX3000__ 

extern void MappX300Beh();

#endif

#define CONFIOB 0
#define CONFCLB 1

#define BASEF 0			/* 1 fonction */
#define BASEFG 1		/* 2 fonctions */
#define BASEFGM 2		/* 2 fonctions multiplexees par e */

#define NIL 0
#define CONFF 1
#define CONFG 2
#define CONFQX 3
#define CONFQY 4
#define CONFDI 6
#define CONFDIRECT 7
#define CONFNOT 8
#define CONFNORMAL 9
#define CONFRD 10
#define CONFEC 11
#define CONFB 12
#define CONFC 13
#define CONFD 14
#define CONFE 15
#define CONFI 16
#define CONFO 17


/* ================================================================== */
/* pour plus d'informations : p300-303 user guide and tutorial Xilinx */
/* 			      p470-478 user guide and tutorial Xilinx */
/* ================================================================== */


typedef struct CLB {
	char *NAME;

	int BLOCK;		/* CONFIOB ou CONFCLB */

	/*================= les champs IOB ===================*/


	/* entree ou sortie */

	int PADTAG;		/* CONFI ou CONFO */

	/* sortie inversee ou non */

	int OITAG;		/* CONFDIRECT ou CONFNOT */

	/* signal rattache au port */

        char *SIGNALPAD;
	chain_list *EQUATEO;

	/*================= les champs CLB ===================*/

	/* utilisation de F et G : BASEF, BASEFG ou BASEFGM */

	int BASE;	

	/* config : Programmation des interconnections (multiplexeur) */

	int XTAG;		/* CONFQX ou CONFF ou NIL */
	int YTAG;		/* CONFQY ou CONFG ou NIL */
	int DXTAG;		/* CONFDI ou CONFF ou CONFG ou NIL */
	int DYTAG;		/* CONFDI ou CONFF ou CONFG ou NIL */ 
	int CLKTAG;		/* CONFDIRECT ou CONFNOT ou NIL */
	int RSTDIRTAG;		/* CONFNORMAL ou CONFRD ou NIL */
	int ENCLKTAG;		/* CONFNORMAL ou CONFEC ou NIL */

	/* expressions des fonctions F et G */

	chain_list *EQUATEF,*EQUATEG;	

	/* definition des supports de F et G */

	ptype_list *ASSOCF;
	ptype_list *ASSOCG;

	/* pointeurs sur la befig */

	char *SIGNALF, *SIGNALG, *SIGNALQX, *SIGNALQY;
        char *SIGNALDI;
        char *SIGNALCK;

	/*================== champs communs ====================*/

	/* befig associee */

	befig_list *BEH;

	/* suivant */

	struct CLB *NEXT;
        } * pCLB;


		/* la liste des CLBs pour un circuit */

pCLB lstCLB;

		/* la table de hachage signal-CLB */

pTH pSignalCLB;


		/* la table des couples de signaux correspondant aux CLB4 */

pTH pTabVar2;
int coCLB;
int coIOB;
int coX3000;
