/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit :  Compilateur de cellules CMOS  & Synthetiseur Logique       */
/*    Fichier :  c4_lofig.c                                                 */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) :  L. Burgun                            le : 28/04/1992     */
/*                                                                          */
/*    Modifie par : N. Dictus (MAJ modeles + BD + N1P)  le : 31/01/1995     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/

#include "genlib.h"

void lofigNot(name,lc_io,out,in)
char *name;
chain_list *lc_io;
char *out;
char *in;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 10, 1, in, "vdd", out);
LOTRS(TRANSN, 5, 1, in, "vss", out);
SAVE_LOFIG();
}

void lofigNotP(name,lc_io,out,in)
char *name;
chain_list *lc_io;
char *out;
char *in;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 20, 1, in, out, "vdd");
LOTRS(TRANSN, 10, 1, in, out, "vss");
SAVE_LOFIG();
}


void lofigBuf(name,lc_io,out,in)
char *name;
chain_list *lc_io;
char *out;
char *in;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 13, 1, in, "mbk_sig2", "vdd");
LOTRS(TRANSP, 20, 1, "mbk_sig2", out, "vdd");
LOTRS(TRANSP, 20, 1, "mbk_sig2", "vdd", out);
LOTRS(TRANSN,  8, 1, in, "mbk_sig2", "vss");
LOTRS(TRANSN, 10, 1, "mbk_sig2", out, "vss");
LOTRS(TRANSN, 10, 1, "mbk_sig2", "vss", out);
SAVE_LOFIG();
}

void lofigHigh(name,lc_io, out)
char *name;
chain_list *lc_io;
char *out;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 13, 1, "vss", "vdd", out);
SAVE_LOFIG();
}

void lofigLow(name,lc_io, out)
char *name;
chain_list *lc_io;
char *out;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSN, 10, 1, "vdd", "vss", out);
SAVE_LOFIG();
}

	/* BUS  i1 = data   i2 = commande */
void lofigBus(name,lc_io,out,i1,i2)
char *name;
chain_list *lc_io;
char * out;
char *i1, *i2;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 20, 1, "mbk_sig3", "vdd", out);
LOTRS(TRANSP, 20, 1, "mbk_sig3", out, "vdd");
LOTRS(TRANSP, 12, 1, i1 , "mbk_sig3", "vdd");
LOTRS(TRANSP, 12, 1, i2 , "vdd", "mbk_sig3");
LOTRS(TRANSP, 12, 1, i2 , "mbk_sig2", "vdd");
LOTRS(TRANSP, 12, 1, "mbk_sig2", "mbk_sig1", "mbk_sig3");
LOTRS(TRANSN, 6, 1, i1 , "mbk_sig1", "vss");
LOTRS(TRANSN, 6, 1, i2 , "mbk_sig1", "mbk_sig3");
LOTRS(TRANSN, 6, 1, i2 , "mbk_sig2", "vss");
LOTRS(TRANSN, 6, 1, "mbk_sig2", "vss", "mbk_sig1");
LOTRS(TRANSN, 10, 1, "mbk_sig1", "vss", out);
LOTRS(TRANSN, 10, 1, "mbk_sig1", out, "vss");
SAVE_LOFIG();
}

void lofigTie(name,lc_io)
char *name;
chain_list *lc_io;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
SAVE_LOFIG();
}

	/* LATCH1 & LATCH1N : i1 = data   i2 = commande
                              i3 = point memorisant       */

void lofigLatch1(name,lc_io,out,i1,i2,i3)
char *name;
chain_list *lc_io;
char *out;
char *i1, *i2, *i3;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 1, 3, "mbk_sig5", "vdd", i3);
LOTRS(TRANSP, 4, 1, i3, "vdd", "mbk_sig5");
LOTRS(TRANSP, 20, 1, "mbk_sig5", out, "vdd");
LOTRS(TRANSN, 2, 6, "mbk_sig5", "vss", i3);
LOTRS(TRANSN, 5, 1, i2, i1, i3);
LOTRS(TRANSN, 4, 1, i3, "vss", "mbk_sig5");
LOTRS(TRANSN, 10, 1, "mbk_sig5", out, "vss");
SAVE_LOFIG();
}

void lofigLatch1N(name,lc_io,out,i1,i2,i3)
char *name;
chain_list *lc_io;
char *out;
char *i1, *i2, *i3;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 1, 3, "mbk_sig1", "vdd", i3);
LOTRS(TRANSP, 2, 1, i3, "vdd", "mbk_sig1");
LOTRS(TRANSP, 10, 1, i3, out, "vdd");
LOTRS(TRANSN, 1, 6, "mbk_sig1", "vss", i3);
LOTRS(TRANSN, 5, 1, i2, i1, i3);
LOTRS(TRANSN, 2, 1, i3, "vss", "mbk_sig1");
LOTRS(TRANSN, 9, 1, i3, out, "vss");
SAVE_LOFIG();
}

	/* LATCH2 & LATCH2N : i1 = data   i2 = commande
                              i3 = data   i4 = commande
                              i5 = point memorisant    */

void lofigLatch2(name,lc_io,out,i1,i2,i3,i4,i5)
char *name;
chain_list *lc_io;
char *out;
char *i1, *i2, *i3, *i4, *i5;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 1, 2, "mbk_sig5", "vdd", i5);
LOTRS(TRANSP, 4, 1, i5, "vdd", "mbk_sig5");
LOTRS(TRANSP, 20, 1, "mbk_sig5", out, "vdd");
LOTRS(TRANSN, 1, 6, "mbk_sig5", "vss", i5);
LOTRS(TRANSN, 5, 1, i4, i5, i3);
LOTRS(TRANSN, 5, 1, i2, i1, i5);
LOTRS(TRANSN, 4, 1, i5, "vss", "mbk_sig5");
LOTRS(TRANSN, 10, 1, "mbk_sig5", out, "vss");
SAVE_LOFIG();
}

void lofigLatch2N(name,lc_io,out,i1,i2,i3,i4,i5)
char *name;
chain_list *lc_io;
char *out;
char *i1, *i2, *i3, *i4, *i5;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 20, 1, i5, out, "vdd");
LOTRS(TRANSP, 2, 1, i5, "vdd", "mbk_sig2");
LOTRS(TRANSP, 1, 3, "mbk_sig2", "vdd", i5);
LOTRS(TRANSN, 20, 1, i5, out, "vss");
LOTRS(TRANSN, 2, 1, i5, "vss", "mbk_sig2");
LOTRS(TRANSN, 5, 1, i2, i1, i5);
LOTRS(TRANSN, 5, 1, i4, i5, i3);
LOTRS(TRANSN, 1, 6, "mbk_sig2", "vss", i5);
SAVE_LOFIG();
}

	/* BD  i1 = data   i2 = commande
               i3 = 1er point memorisant  (master)
               i4 = 2eme point memorisant (slave)      */

void lofigBd1(name,lc_io,out,i1,i2,i3,i4)
char *name;
chain_list *lc_io;
char *out;
char *i1, *i2, *i3, *i4;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 10, 1, "mbk_sig1", "vdd", "mbk_sig8");
LOTRS(TRANSP, 4, 1, i3, "mbk_sig1", "vdd");
LOTRS(TRANSP, 15, 1, i2, "vdd", "mbk_sig10");
LOTRS(TRANSP, 1, 3, "mbk_sig11", "vdd", i4);
LOTRS(TRANSP, 4, 1, i4, "mbk_sig11", "vdd");
LOTRS(TRANSP, 20, 1, i4, "vdd", out);
LOTRS(TRANSP, 1, 3, "mbk_sig1", "vdd", i3);
LOTRS(TRANSP, 10, 1, i1, "vdd", "mbk_sig4");
LOTRS(TRANSN, 2, 6, "mbk_sig1", i3, "vss");
LOTRS(TRANSN, 5, 1, "mbk_sig1", "vss", "mbk_sig8");
LOTRS(TRANSN, 5, 1, "mbk_sig10", "mbk_sig8", i4);
LOTRS(TRANSN, 2, 6, "mbk_sig11", i4, "vss");
LOTRS(TRANSN, 4, 1, i3, "mbk_sig1", "vss");
LOTRS(TRANSN, 5, 1, i2, "mbk_sig4", i3);
LOTRS(TRANSN, 8, 1, i2, "vss", "mbk_sig10");
LOTRS(TRANSN, 4, 1, i4, "mbk_sig11", "vss");
LOTRS(TRANSN, 10, 1, i4, "vss", out);
LOTRS(TRANSN, 5, 1, i1, "vss", "mbk_sig4");
SAVE_LOFIG();
}

	/* BDN  i1 = data   i2 = commande
                i3 = 1er point memorisant  (master)
                i4 = 2eme point memorisant (slave)      */
void lofigBd1n(name,lc_io,out,i1,i2,i3,i4)
char *name;
chain_list *lc_io;
char *out;
char *i1, *i2, *i3, *i4;
{
DEF_LOFIG(name);
while (lc_io)
   {
   LOCON(lc_io->DATA, UNKNOWN,lc_io->DATA);
   lc_io = lc_io->NEXT;
   }
LOTRS(TRANSP, 10, 1, "mbk_sig1", "vdd", "mbk_sig8");
LOTRS(TRANSP, 4, 1, i3, "mbk_sig1", "vdd");
LOTRS(TRANSP, 15, 1, i2, "vdd", "mbk_sig10");
LOTRS(TRANSP, 1, 3, "mbk_sig11", "vdd", i4);
LOTRS(TRANSP, 4, 1, i4, "mbk_sig11", "vdd");
LOTRS(TRANSP, 20, 1, "mbk_sig11", "vdd", out);
LOTRS(TRANSP, 1, 3, "mbk_sig1", "vdd", i3);
LOTRS(TRANSP, 10, 1, i1, "vdd", "mbk_sig4");
LOTRS(TRANSN, 2, 6, "mbk_sig1", i3, "vss");
LOTRS(TRANSN, 5, 1, "mbk_sig1", "vss", "mbk_sig8");
LOTRS(TRANSN, 5, 1, "mbk_sig10", "mbk_sig8", i4);
LOTRS(TRANSN, 2, 6, "mbk_sig11", i4, "vss");
LOTRS(TRANSN, 4, 1, i3, "mbk_sig1", "vss");
LOTRS(TRANSN, 5, 1, i2, "mbk_sig4", i3);
LOTRS(TRANSN, 8, 1, i2, "vss", "mbk_sig10");
LOTRS(TRANSN, 4, 1, i4, "mbk_sig11", "vss");
LOTRS(TRANSN, 10, 1, "mbk_sig11", "vss", out);
LOTRS(TRANSN, 5, 1, i1, "vss", "mbk_sig4");
SAVE_LOFIG();
}
