/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : TAS Version 3.50                                            */
/*    Fichier : slofile.c                                                   */
/*                                                                          */
/*    (c) copyright 1991-1992 Laboratoire MASI equipe CAO & VLSI            */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Payam KIANI                           le : 28/05/1991     */
/*                                                                          */
/*    Modifie par : Payam KIANI                         le : 16/10/1991     */
/*    Modifie par : Payam KIANI                         le : 22/07/1992     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/
/* fichier slofile.c: driver des fronts de cone                             */
/****************************************************************************/
#include "tas_all.h"

int slopefile(ptfig)
desafig_list *ptfig ;

{
cone_list *cone ;
FILE      *file ;
long      counter ;

if((file = mbkfopen(ptfig->NAME,"slo",WRITE_TEXT)) == NULL)
    {
    char straux[100] ;

    sprintf(straux,"%s.slo",ptfig->NAME) ;
    tas_error(8,straux,TAS_WARNING) ;

    return ;
    }

time( &counter ) ;
/* entete du fichier ".slo" */
if(TAS_LANG == 'E')
fprintf(file,"FILE OF SLOPES OF THE BLOCK %s\n",ptfig->NAME) ;
else if(TAS_LANG == 'F')
fprintf(file,"FICHIER DES FRONTS DU BLOC %s\n",ptfig->NAME) ;
fprintf(file,"TAS VERSION %s ",VERSION) ;
if(TAS_LANG == 'E')
fprintf(file,"of %s\n",DATE_VER) ;
else if(TAS_LANG == 'F')
fprintf(file,"du %s\n",DATE_VER) ;

for(cone = ptfig->CONE ; cone != NULL ; cone = cone->NEXT)
    {
    ptype_list *user = getptype(cone->USER,SLOPE) ;

    if(user != NULL)
        {
        front_list *slope = (front_list *)user->DATA ;

        fprintf(file,"cone %ld (%s)\t: FUP = ",cone->INDEX,cone->NAME) ;
        if(slope->FUP == NOTIME) fprintf(file,"NO SLOPE") ;
        else fprintf(file,"%ld",slope->FUP) ;
        fprintf(file,"\tFDOWN = ") ;
        if(slope->FDOWN == NOTIME) fprintf(file,"NO SLOPE ;\n") ;
        else fprintf(file,"%ld ;\n",slope->FDOWN) ;
        }
    else
        {
        if(TAS_LANG == 'E')
        fprintf(file,"!!! attention !!! cone %ld (%s)\n",cone->INDEX,
                cone->NAME) ;
        else if(TAS_LANG == 'F')
        fprintf(file,"!!! warning !!! cone %ld (%s)\n",cone->INDEX,
                cone->NAME) ;
        }
    }

if(fclose(file) != 0)
    {
    char straux[100] ;

    sprintf(straux,"%s.slo",ptfig->NAME) ;
    tas_error(10,straux,TAS_WARNING) ;
    }

return ;
}
