/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : TAS version 3.50                                            */
/*    Fichier : tas_all.h                                                   */
/*                                                                          */
/*    (c) copyright 1991-1992 Laboratoire MASI equipe CAO & VLSI            */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Payam KIANI                           le : 19/11/1991     */
/*                                                                          */
/*    Modifie par : Payam KIANI                         le : 22/07/1992     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/
/* fichier tas_all.h: fichier header a inclure dans tous les fichiers .c    */
/*                    sauf pour le module generateur TATOO. Il contient donc*/
/*                    toute les bases de donnees                            */
/****************************************************************************/
/* les inclusions systemes */
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/times.h>
#include <signal.h>

/* inclusion mbk */
#include MUT_H
#include MLO_H

/* inclusion techno */
#include ELP_H

/* inclusion DESB */
#include <desb.h>
#include <vars.h>

/* inclusions TAS */
#include "tas.h"

/* liste des define */
#define tas_TAG     '1'

/* erreurs de tas */
#define TAS_NULL 0
#define TAS_ERROR 1
#define TAS_WARNING 2

/* variables des librairies */
extern char DEB_LANG ;
extern char TEC_LANG ;

/* VARIABLES GLOBALES D'UTILISATEUR */
extern desafig_list *HEAD_DESBFIG ;
extern char   *FILENAME      ;  /* nom de la figure d'entree            */
extern char   TAS_TRACE_MODE ;
extern char   TAS_LANG       ;
extern float  TAS_TRAN_STEP  ;
extern char   TAS_BULLIT     ;  /* flag pour traitement latches BULLIT  */
extern char   SLOFILE        ;  /* generation du ".slo" si a 'Y'        */
extern char   PERFORD        ;  /* ordnnancement du ".prf" si a 'Y'     */
extern char   PERFINT        ;  /* generation du perfmodule si a 'Y'    */
extern char   INT_END        ;  /* sortie du prg apres perfint si a 'Y' */
extern long   TAS_SEUIL_MAX  ;  /* seuil de temps pour ch. crit.        */
extern long   TAS_SEUIL_MIN  ;  /* seuil de temps pour ch. crit.        */
extern char   TECFILE[]      ;  /* nom du fichier technologie           */
extern char   VERSION[]      ;  /* numero de version                    */ 
extern char   DATE_VER[]     ;  /* date de la version                   */
extern short  tas_LEVEL      ;  /* niveau d'analyse pour le ttv         */
extern char   *PARAM[] ;
extern long   NB_COUPLE ;
extern long   NB_CHAINE ;
extern char   NOTAS ;
extern double CAPARAPREC ;
extern double CAPASWITCH ;      /* capacite des switches sur conn. in    */
extern char   PRFTYPE ;
extern char   INTTYPE ;
extern char   TAS_PWL ;
extern double TAS_CAPAOUT ;
extern ptype_list *HEADMEMO ;
extern char   DEB_FILE ;
extern char   TAS_GARBAGE ;
extern char   TAS_TREATPRECH ;
extern char   TAS_SILENTMODE ;
extern char   TAS_HIER ;
extern perf_list     *PERFFIG ;
extern chemcr_list   *TAS_MAXPATH ;
extern long    NP ;
extern char   TAS_MAIL ;
extern struct precharge *tas_PRECHR ; /* liste des points precharges */
extern struct information TAS_INFO ;
extern struct list *pathcomm ;
extern struct list *INF_SIGLIST ;
extern double  RN        ,
               RP        ,
               FRONT_CON ,
               AN        ,
               BN        ,
               AP        ,
               BP        ,
               RNT       ,
               RPT       ,
               VDDmax    ,
               VTP       ,
               VTN       ,
               SEUIL     ,
               RNDD      ,
               RPDD      ,
               KNDD      ,
               KPDD      ,
               RNDF      ,
               RPDF      ,
               VSSdeg    ,
               VDDdeg    ,
               RNUD      ,
               RPUD      ,
               KNUD      ,
               KPUD      ,
               RNUF      ,
               RPUF      ,
               QN        ,
               QP        ,
               KGUD      ,
               KGDD      ,
               INFB      ,
               IPFB      ;

/* liste des fonctions */
/* fonctions systemes */
extern char *getenv() ;

/* fonctions DESB */
extern desafig_list *desb() ;
extern void         savedesa() ;
extern char         *get_name() ;

/* fichier class.c */
extern int       visu_branche() ;
extern int       res_branche() ;
extern int       clas_liste_branche() ;
extern void      clas_branche() ;
extern long      valfupfdown() ;
extern list_list *decision() ;
extern long      front() ;
extern int       timing() ;

/* fichier perf.c */
extern biname_list *addbiname() ;
extern biname_list *getbiname() ;
extern long        linktype() ;
extern ptype_list  *memosync() ;
extern int         writememosync() ;
extern long        getrs() ;
extern int         unit_port() ;
extern int         prf() ;

/* fichier pre.c */
extern long      prelink() ;
extern int       delpath() ;
extern int       del_para() ;
extern long      number_maillon() ;
extern int       para() ;
extern int       switch_cmos() ;
extern int       tas_AddCapaOut() ;
extern list_list *tas_GetAliasSig() ;
extern int       tas_BullitLatch() ;

/* fichier slofile.c */
extern int slopefile() ;

/* fichier tas_util.c */
extern int    tas_version() ;
extern short  tas_PathFonc() ;
extern int    caseerror() ;
extern int    tas_setenv() ;
extern short  retkey() ;
extern int    optionword() ;
extern int    option() ;
extern char   *tasalloc() ;
extern int    tas_CloseTerm() ;
extern int    tas_RestoreTerm() ;
extern int    *tas_GetKill() ;
extern double tas_CompCapa() ;
extern char   *tas_DeVect() ;
extern char   *tas_ReVect() ;
extern list_list *tas_GetInLink() ;

/* fichier tasgraph.c */
extern event_list *getnode() ;
extern int        addline() ;
extern int        linknode() ;
extern chain_list *pushnode() ;
extern chain_list *initial() ;
extern chain_list *loop_2() ;
extern int        addlist() ;
extern perf_list  *timecat() ;

/* fichier tp.c */
extern int        affiche_maillon() ;
extern int        affiche_time() ;
extern link_list  *existe_tpd_maillon() ;
extern list_list  *existe_tpd() ;
extern link_list  *existe_conflit() ;
extern double     f1() ;
extern double     f2() ;
extern double     i_branch() ;
extern double     f3() ;
extern double     f4() ;
extern double     f5() ;
extern long       capa_de_conflit() ;
extern long       tpd_dual() ;
extern delay_list *val_dual() ;
extern int        capa_equi() ;
extern long       tpd_path() ;
extern int        affiche_conec() ;
extern list_list  *tas_GiveActivExtPath() ;
extern delay_list *val_con() ;
extern double     f6() ;
extern long       tpd_trans_good() ;
extern long       tpd_trans_false() ;
extern long       calcul_FB() ;
extern delay_list *val_non_dual() ;
extern int        tpd() ;
extern int        tas_PwlFile() ;
extern int        tas_GenPwl() ;

/* fichier drittv */
extern link_list *getcmd() ;
extern char      getdir() ;
extern int       tas_tvheader() ;
extern int       drittv() ;

/* fichier dridtv */
extern char *dtv_getcmd() ;
extern int  dridtv() ;
