/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : TAS Verison 3.66                                            */
/*    Fichier : tas_err.c                                                   */
/*                                                                          */
/*    (c) copyright 1991-1992 Laboratoire MASI equipe CAO & VLSI            */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Payam KIANI                           le : 22/07/1992     */
/*                                                                          */
/*    Modifie par : Payam KIANI                         le : 03/05/1993     */
/*    Modifie par :                                     le : ../../....     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/
/* fichier tm_error.c: traitement des erreurs fatales et avertissements     */
/****************************************************************************/
#include "tas_all.h"

/****************************************************************************/
/*                          fonction tas_error()                            */
/* traitement des erreurs et avertissements.                                */
/****************************************************************************/
int tas_error(numero,message,type)
short numero   ; /* numero de l'erreur                                 */
char  *message ;
long  type     ; /* dit si c'est un avertissement ou une erreur fatale */	

{
if(type == TAS_ERROR)
    {
    if(TAS_LANG == 'E')
    fprintf(stderr,"\n*** tas error: %d ***\n",numero) ;
    else if(TAS_LANG == 'F')
    fprintf(stderr,"\n*** erreur tas: %d ***\n",numero) ;
    }
 
else if(type == TAS_WARNING)
    {
    if(TAS_LANG == 'E')
    fprintf(stderr,"\n!!! tas warning: %d !!!\n",numero) ;
    else if(TAS_LANG == 'F')
    fprintf(stderr,"\n!!! avertissement tas: %d !!!\n",numero) ;
    }

switch(numero)
    {
    /* option -h:affichage des options */
    case 0 : fprintf(stdout,"\ntas version %s\n",VERSION) ;
             if(TAS_LANG == 'E')
    {
fprintf(stdout,"of %s\n",DATE_VER) ;
fprintf(stdout,"\nusage : tas <options> <filename>\n") ;
fprintf(stdout,"  -t($)           : intermediate perfmodule file. With '$', TAS means exit\n") ;
fprintf(stdout,"                    after its generation\n") ;
fprintf(stdout,"  -e              : slope file ('.slo') generation.\n") ;
fprintf(stdout,"  -i              : makes the program to read the '.inf' file\n") ;
fprintf(stdout,"  -tec=<nom>      : technology file specification.\n") ;
fprintf(stdout,"  -in=<format>    : input format (al, fne, fdn, hns, hdn, spi).\n") ;
fprintf(stdout,"  -s              : silent mode.\n") ;
#ifdef BULL
fprintf(stdout,"  -m              : to take the '_l' convention into account.\n") ;
fprintf(stdout,"  -na             : '_s' convention ignored.\n") ;
#else
fprintf(stdout,"  -a              : to take the '_s' convention into account.\n") ;
#endif
fprintf(stdout,"  -p=<prof>       : depth level of the functional analysis.\n") ;
fprintf(stdout,"  -x=<min>:<max>  : detail of the critical paths which delay is between <min>\n") ;
fprintf(stdout,"                    and <max>. All paths if no argument.\n") ;
fprintf(stdout,"  -pch            : precharged signals taked into account\n") ;
fprintf(stdout,"  -hr             : hierarchical mode.\n") ;
fprintf(stdout,"  -opc=<prec>     : out of path capacitance factor.\n") ;
fprintf(stdout,"  -swc=<prec>     : input pass-transistor capacitance.\n") ;
fprintf(stdout,"  -cout           : output terminals charge.\n") ;
fprintf(stdout,"  -pwl($)         : PwlFall and PwlRise generation. With '$' means exit\n") ;
fprintf(stdout,"                    after their generations\n") ;
fprintf(stdout,"  -uk             : english language.\n") ;
fprintf(stdout,"  -fr             : french language.\n") ;
fprintf(stdout,"  -h              : help option. Shows the current page.\n") ;
    }
else if(TAS_LANG == 'F')
    {
fprintf(stdout,"du %s\n",DATE_VER) ;
fprintf(stdout,"\nusage : tas <options> <nomfic>\n") ;
fprintf(stdout,"  -t($)           : demande du perfmodule intermediaire. Avec '$', le programme\n") ;
fprintf(stdout,"                    s'arrete apres sa generation.\n") ;
fprintf(stdout,"  -e              : generation des temps de commutation en fichier '.slo'.\n") ;
fprintf(stdout,"  -i              : lecture du fichier d'information '.inf'.\n") ;
fprintf(stdout,"  -tec=<nom>      : specification du fichier technologie.\n") ;
fprintf(stdout,"  -in=<format>    : format d'entree (al, fne, fdn, hns, hdn, spi).\n") ;
fprintf(stdout,"  -s              : mode silencieux.\n") ;
#ifdef BULL
fprintf(stdout,"  -m              : prise en compte de la convention '_l'.\n") ;
fprintf(stdout,"  -na             : inhibition de la convention '_s'.\n") ;
#else
fprintf(stdout,"  -a              : prise en compte de la convention '_s'.\n") ;
#endif
fprintf(stdout,"  -p=<prof>       : niveau de profondeur de l'analyse fonctionnelle.\n") ;
fprintf(stdout,"  -x=<min>:<max>  : detail des chemins dont le temps de propagation est entre\n") ;
fprintf(stdout,"                    <min> et <max>. Tous les chemins si pas d'argument.\n") ;
fprintf(stdout,"  -pch            : traitement des signaux precharges.\n") ;
fprintf(stdout,"  -hr             : mode hierarchique.\n") ;
fprintf(stdout,"  -opc=<fact>     : facteur des capacites hors chemin.\n") ;
fprintf(stdout,"  -swc=<fact>     : capacite des transistors de passage en entree.\n") ;
fprintf(stdout,"  -cout           : charge des connecteurs de sortie ou d'entree/sortie.\n") ;
fprintf(stdout,"  -pwl($)         : generation des signaux tgh dans les fichiers PwlFall et\n") ;
fprintf(stdout,"                    PwlRise. Lancement en mode reduit avec '$'.\n") ;
fprintf(stdout,"  -uk             : langue anglaise.\n") ;
fprintf(stdout,"  -fr             : langue francaise.\n") ;
fprintf(stdout,"  -h              : option d'aide. Affiche cette page.\n") ;
    }
             break ;

    /* 1ere serie: fichier class.c */
    /* front de valeur nulle */
    case 1 : if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"slope computing error:\n") ;
                 fprintf(stderr,"circuit not extracted or wrong extraction\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"erreur dans l'evaluation des fronts:\n") ;
                 fprintf(stderr,"circuit non extrait ou mauvaise extraction\n") ;
                 }
             break ;

    /* mauvaise direction d'un connecteur d'entree */
    case 2 : if(TAS_LANG == 'E')
             fprintf(stderr,"netlist error: the terminal %s is not an input\n",
                     message) ;
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"erreur de netlist: le connecteur %s n'est pas",
                         message) ;
                 fprintf(stderr," une entree\n") ;
                 }
             break ;

    /* mauvaise direction d'un connecteur de sortie */
    case 3 : if(TAS_LANG == 'E')
             fprintf(stderr,"netlist error: the terminal %s is not an output\n",
                     message) ;
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"erreur de netlist: le connecteur %s n'est pas",
                         message) ;
                 fprintf(stderr," une sortie\n") ;
                 }
             break ;

    /* pas de cone associe au connecteur */
    case 4 : if(TAS_LANG == 'E')
             fprintf(stderr,"the connector %s is not used\n",message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"le connecteur %s n'est pas utilise\n",message) ;
             break ;

    /* connecteur ne pouvant pas atteindre le niveau haut */
    case 5 : if(TAS_LANG == 'E')
             fprintf(stderr,"the terminal %s can not reach the high level\n",
                     message) ;
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"le connecteur %s ne peut pas atteindre le ",
                         message) ;
                 fprintf(stderr,"niveau haut\n") ;
                 }
             break ;

    /* connecteur ne pouvant pas atteindre le niveau bas */
    case 6 : if(TAS_LANG == 'E')
             fprintf(stderr,"the terminal %s can not reach the low level\n",
                     message) ;
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"le connecteur %s ne peut pas atteindre le ",
                         message) ;
                 fprintf(stderr,"niveau bas\n") ;
                 }
             break ;

    /* signal de sortie dont la valeur ne peut pas etre imposee */
    case 7 : if(TAS_LANG == 'E')
             fprintf(stderr,"can not force the level of %s\n",message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"le niveau de %s ne peut pas etre imposee\n",
                     message) ;
             break ;

    /* 2nd serie: fichier dricar.c */
    /* ouverture de fichier impossible */
    case 8 : if(TAS_LANG == 'E')
             fprintf(stderr,"can not open the file %s\n",message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"le fichier %s ne peut pas etre ouvert\n",message) ;
             break ;

    /* signal inexistant a partir du fichier '.inf' */
    case 9 : if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"the signal %s doesn't exist in the circuit\n",
                         message) ;
                 fprintf(stderr,"or is not a transistor grid\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"le signal %s n'existe pas dans le bloc\n",
                         message) ;
                 fprintf(stderr,"ou n'est pas une grille de transistor\n") ;
                 }
             break ;

    /* impossible de fermer le fichier */
    case 10: if(TAS_LANG == 'E')
             fprintf(stderr,"can not close the file %s\n",message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"le fichier %s ne peut pas etre ferme\n",message) ;
             break ;

    /* 3eme serie: fichier dridtv.c */
    /* latch sans controle */
    case 11: if(TAS_LANG == 'E')
             fprintf(stderr,"no control signal in the latch %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"pas de signal de control dans le latch %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             break ;

    /* 4eme serie: fichier driprf.c */
    /* liste d'entree incomplete */
    case 12: if(TAS_LANG == 'E')
             fprintf(stderr,"incomplete input list for the cone %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"liste d'entree incomplete pour le cone %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             break ;

    /* latch n'etant pas de type BULLIT */
    case 13: if(TAS_LANG == 'E')
             fprintf(stderr,"the latch %s is not a bullit latch\n",message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"le latch %s n'est pas un latch bullit\n",message) ;
             break ;

    /* 5eme serie: fichier main.c */
    /* erreur de lecture de la techno */
    case 14: if(TAS_LANG == 'E')
             fprintf(stderr,"error in technology file %s\n",message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"erreur dans le fichier techno %s\n",message) ;
             break ;

    /* si circuit sans capacite, on calcule des capas de diff avec ACM=1 */
    case 15: if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"block without diffusion capacitance\n") ;
                 fprintf(stderr,"can not measure the drain or source ") ;
                 fprintf(stderr,"capacitance\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"bloc sans capacites de diffusion\n") ;
                 fprintf(stderr,"aucune capacite ne peut etre associee\n") ;
                 fprintf(stderr,"au drain ou a la source des transistors\n") ;
                 }
             break ;

    case 16: if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"block without diffusion capacitance\n") ;
                 fprintf(stderr,"drain and source capacitance wil be\n") ;
                 fprintf(stderr,"measured with ACM=1 SPICE method\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"bloc sans capacites de diffusion\n") ;
                 fprintf(stderr,"les capacites de diffusion seront\n") ;
                 fprintf(stderr,"calculees selon la methode SPICE ACM=1\n") ;
                 }
             break ;

    /* 6eme serie: fichier matherr.c */
    /* erreur mathematique de type inconnu */
/*    case 17: if(TAS_LANG == 'E')
             fprintf(stderr,"can not calculate %s(%le)\n",
                     ((struct exception *)message)->name,
                     ((struct exception *)message)->arg1) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"%s(%le) ne peut pas etre calculee\n",
                     ((struct exception *)message)->name,
                     ((struct exception *)message)->arg1) ;
             break ;*/
    case 17: if(TAS_LANG == 'E')
             fprintf(stderr,"floating exception\n") ;
             else
             fprintf(stderr,"erreur de calcul flottant\n") ;
             break ;

    /* 7eme serie: t_xmain.c */
    /* front pas trouve */
    case 19: if(TAS_LANG == 'E')
             fprintf(stderr,"can not find the slopes of the cone %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"les fronts du cone %ld (%s) ne sont pas trouves\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             break ;

    /* pas de branche active */
    case 20: if(TAS_LANG == 'E')
             fprintf(stderr,"no active path found in the cone %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"pas de branche active dans le cone %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             break ;

    /* 8eme serie: ta2_util.c */
    /* erreur dans la table de verite */
    case 21: if(TAS_LANG == 'E')
             fprintf(stderr,"error in the truth table %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"erreur dans la table de verite %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             break ;

    /* caractere representant un etat inconnu */
    case 22: if(TAS_LANG == 'E')
             fprintf(stderr,"unknown state %c\n",(char)message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"etat %c inconnu\n",(char)message) ;
             break ;

    /* colonne de type inconnu */
    case 23: if(TAS_LANG == 'E')
             fprintf(stderr,"unknown column type %c\n",(char)message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"type de colonne %c inconnu\n",(char)message) ;
             break ;

    /* 9eme serie: ta2_vect.c */
    /* branche alimentation terminee par un connecteur */
    case 24: if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"non external branch containing terminal\n") ;
                 fprintf(stderr,"cone %ld (%s)\n",
                         ((cone_list *)message)->INDEX,
                         ((cone_list *)message)->NAME) ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"branche non externe terminee par un ") ;
                 fprintf(stderr,"connecteur\ncone %ld (%s)",
                         ((cone_list *)message)->INDEX,
                         ((cone_list *)message)->NAME) ;
                 }
             break ;

    /* 10eme serie: fichier tas_util.c */
    case 25: if(TAS_LANG == 'E')
             fprintf(stderr,"no slope on the node %s in the SPICE file\n",
                     message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"front nul sur le noeud %s dans le fichier SPICE\n",
                     message) ;
             break ;

    /* mauvaise utilisation de TAS */
    case 26: fprintf(stderr,"\ntas version %s ",VERSION) ;
             if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"of %s\nusage : tas ",DATE_VER) ;
#ifdef BULL
                 fprintf(stderr,"[-derlsimb -na -x=<min>:<max> ") ;
#else
                 fprintf(stderr,"[-esia -x=<min>:<max> ") ;
#endif
                 fprintf(stderr,"-h -pch -pwl($) -uk -fr -hr -t($)\n       ") ;
                 fprintf(stderr,"      -tec=<tecfile> -opc=<factor> ") ;
                 fprintf(stderr,"-cout=<capa> -p=<depth> \n       ") ;
                 fprintf(stderr,"      -in=<input format> -swc=<factor>") ;
                 fprintf(stderr,"] <filename>\n\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"du %s\nusage : tas ",DATE_VER) ;
#ifdef BULL
                 fprintf(stderr,"[-delsimb -na -x=<min>:<max>") ;
#else
                 fprintf(stderr,"[-esia -x=<min>:<max>") ;
#endif
                 fprintf(stderr," -h -pch -pwl($) -uk -fr -hr -t($)\n      ") ;
                 fprintf(stderr,"       -tec=<fictec> -opc=<facteur> ") ;
                 fprintf(stderr,"-cout=<capa> -p=<prof> \n       ") ;
                 fprintf(stderr,"      -in=<format entree> -swc=<facteur>") ;
                 fprintf(stderr,"] <nomfic>\n\n") ;
                 }
             break ;

    /* pas assez de memoire: avant liberation */
    case 27: if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"tasalloc() error: not enough memory\n") ;
                 fprintf(stderr,"only the critical path will be retained\n") ;
                 fprintf(stderr,"freeing memory space\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"erreur tasalloc(): pas assez de memoire\n") ;
                 fprintf(stderr,"seul le chemin critique va etre garde\n") ;
                 fprintf(stderr,"liberation d'espace memoire\n") ;
                 }
             break ;

    /* pas assez de memoire: apres liberation */
    case 28: if(TAS_LANG == 'E')
             fprintf(stderr,"fatal error: not enough memory\n") ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"erreur fatale: pas assez de memoire\n") ;
             break ;

    /* 11eme serie: tasgraph.c */
    /* evenement d'index inconnu */
    case 29: if(TAS_LANG == 'E')
             fprintf(stderr,"unknown event token %ld\n",(long)message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"evenement d'index %ld inconnu\n",(long)message) ;
             break ;

    /* pas de connecteur de sortie */
    case 30: if(TAS_LANG == 'E')
             fprintf(stderr,"no inout or output terminal\n") ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"pas de connecteur de sortie ou d'e/s\n") ;
             break ;

    /* boucle detectee */
    case 31: if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"loop detected: see the %s.LOOP file for\n",
                         message) ;
                 fprintf(stderr,"more informations\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"boucle detectee: voir le fichier %s.LOOP\n",
                         message) ;
                 fprintf(stderr,"pour plus d'informations\n") ;
                 }
             break ;

    /* chaine monophase */
    case 32: if(TAS_LANG == 'E')
             fprintf(stderr,"monolatch chain %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"chaine monolatch %ld (%s)\n",
                     ((cone_list *)message)->INDEX,
                     ((cone_list *)message)->NAME) ;
             break ;

    /* 12eme serie: tp.c */
    /* cone type bleeder mais n'ayant pas de branche de contre-reaction */
    case 33: if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"the cone %ld (%s) do not contain feedback ",
                         ((cone_list *)message)->INDEX,
                         ((cone_list *)message)->NAME) ;
                 fprintf(stderr,"pathes\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"le cone %ld (%s) ne contient pas de branche",
                         ((cone_list *)message)->INDEX,
                         ((cone_list *)message)->NAME) ;
                 fprintf(stderr," de contre-reaction\n") ;
                 }
             break ;

    /* mauvaise base de donnees: branche non externe */
    case 34: if(TAS_LANG == 'E')
             fprintf(stderr,"non external branch in the cone %ld (%s)\n",
                         ((cone_list *)message)->INDEX,
                         ((cone_list *)message)->NAME) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"branche non-externe dans le cone %ld (%s)\n",
                         ((cone_list *)message)->INDEX,
                         ((cone_list *)message)->NAME) ;
             break ;

    /* delai nul entre deux noeuds */
    case 37: if(TAS_LANG == 'E')
             fprintf(stderr,"no delay between %s\n",message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"delai nul entre %s\n",message) ;
             break ;

    /* maillon non trouve */
    case 38: if(TAS_LANG == 'E')
             fprintf(stderr,"transistor link losed\n") ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"maillon non trouve\n") ;
             break ;

    /* l'option precharge non-utilisee avec la nouvelle chaine */
    case 41: if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"the precharge processing must be used with \n") ;
                 fprintf(stderr,"the 'ttv' file\n") ;
                 fprintf(stderr,"the '-n' option will be set\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"le traitement des precharges doit etre ") ;
                 fprintf(stderr,"utilse\navec le fichier 'ttv'. ") ;
                 fprintf(stderr,"l'option '-n' va etre activee\n") ;
                 }
             fflush(stderr) ;
             break ;

    /* si pas de chemin extractible */
    case 42: if(TAS_LANG == 'E')
             fprintf(stderr,"there is no extractible path in the figure %s\n",
                     (char *)message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"pas de branche extractible dans la figure %s\n",
                     (char *)message) ;
             break ;

    /* mauvaise valeur de variable d'environnement */
    case 43: if(TAS_LANG == 'E')
             fprintf(stderr,"bad environment variable %s\n",(char *)message) ;
             else if(TAS_LANG == 'F')
             fprintf(stderr,"mauvaise variable d'environnement %s\n",
                     (char *)message) ;
             break ;

    /* incompatibilite de l'option '-l' avec le fichier '.deb' */
    case 44: if(TAS_LANG == 'E')
                 {
                 fprintf(stderr,"the cell characterization option is\n") ;
                 fprintf(stderr,"incompitable with the 'deb' file\n") ;
                 }
             else if(TAS_LANG == 'F')
                 {
                 fprintf(stderr,"l'option de caracterisation de cellule\n") ;
                 fprintf(stderr,"est incompatible avec le fichier 'deb'\n") ;
                 }
             break ;
    }

fflush(stderr) ;

if((type == TAS_ERROR) || (type == TAS_NULL))
    {
    if(TAS_SILENTMODE == 'Y')
    tas_RestoreTerm() ;
    exit(numero) ;
    }

return ;
}
