/* les inclusions */
#include <stdio.h>
#include <varargs.h>
#include MUT_H
#include MLO_H

#define elperrorFCT  /* identification des fonctions du fichier elperror.c */
#define elpFCT       /* identification des fonctions du fichier elp.c      */

extern char elpLang ;
#define elpTRANSNUM      2         /* nombre de type de transistor     */
#define elpNMOS          0         /* pour les parametres du NMOS      */
#define elpPMOS          1         /* pour les parametres du PMOS      */
#define elpSTRINGSIZE    50        /* taille des chaines de caracteres */
#define elpENGLISH      'E'        /* langue anglaise                  */
#define elpFRENCH       'F'        /* langue francaise                 */
#define elpDEFLANG      elpENGLISH /* langue par defaut                */

/* definition du chemin d'acces de quelques fichiers techno */
#define elpECPD10
#define elpECPD12
#define elpECPD15
#define elpAMS12
#define elpHCMOS5

/* les informations sur la technologie utilisee */
extern char   elpTechnoName[elpSTRINGSIZE] ;
extern double elpTechnoVersion             ;

/* les parametres du shrink du transistor */
#define elpSHRINKNUM 6   /* nombre de parametres du tableau Shrink     */
extern double elpShrink[elpSHRINKNUM] ;
#define elpLMLT      0   /* parametre multiplicatif de la longueur     */
#define elpWMLT      1   /* parametre multiplicatif de la largeur      */
#define elpDLN       2   /* parametre de reduction de la longueur NMOS */
#define elpDWN       3   /* parametre de reduction de la largeur NMOS  */
#define elpDLP       4   /* parametre de reduction de la longueur PMOS */
#define elpDWP       5   /* parametre de reduction de la largeur PMOS  */

/* les parametres du modele des transistors (modele MCC) */
#define elpMODELNUM 4   /* nombre de parametres pour chaque modele */
extern double elpModel[elpTRANSNUM][elpMODELNUM] ;
#define elpVT       0   /* tension de seuil                        */
#define elpA        1   /* parametre A                             */
#define elpB        2   /* parametre B                             */
#define elpRT       3   /* resistance en mode lineaire             */

/* les parametres definissant les tensions */
#define elpVOLTNUM 4   /* nombre d'elements du tableau Voltage */
extern double elpVoltage[elpVOLTNUM] ;
#define elpVDDMAX  0   /* tension d'alimentation               */
#define elpVDDDEG  1   /* tension du niveau degrade haut       */
#define elpVSSDEG  2   /* tension du niveau degrade bas        */
#define elpVTHR    3   /* seuil de mesure des temps de propa   */

/* les parametres definissant les capacites dynamiques */
#define elpCAPANUM 8   /* nombre de capacites carrees               */
extern double elpCapa[elpTRANSNUM][elpCAPANUM] ;
#define elpCGS     0   /* capacite grille contribution en surface   */
#define elpCGP     1   /* capacite grille contribution en perimetre */
#define elpCDS     2   /* capacite drain contribution en surface    */
#define elpCDP     3   /* capacite drain contribution en perimetre  */
#define elpCDW     4   /* capacite drain contribution en largeur    */
#define elpCSS     5   /* capacite source contribution en surface   */
#define elpCSP     6   /* capacite source contribution en perimetre */
#define elpCSW     7   /* capacite source contribution en largeur   */

/* les parametres du simulateur electrique */
extern char   elpEsimName[elpSTRINGSIZE] ;
extern double elpEsimLevel               ;

/* les parametres generaux */
#define elpGENERALNUM 3  /* nombre de parametres du tableau General    */
extern double elpGeneral[elpGENERALNUM] ;
#define elpACM        0  /* methode de calcul des capacites dynamiques */
#define elpTEMP       1  /* temperature de simulation et d'analyse     */
#define elpSLOPE      2  /* front sur les connecteurs d'entree         */


/* les fonctions externes */
extern short elpLoadElp() ;
extern int elpLotrsShrink() ;
extern float elpLotrsCapaDrain() ;
extern float elpLotrsCapaSource() ;
extern float elpLotrsCapaGrid() ;
extern int elpLofigCapaDiff() ;
extern int elpLofigCapaGrid() ;
extern int elpLofigShrink() ;
extern short elpError() ;
