/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : TAS Verison 3.54                                            */
/*    Fichier : dridtv.c                                                    */
/*                                                                          */
/*    (c) copyright 1991-1992 Laboratoire MASI equipe CAO & VLSI            */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Payam KIANI                           le : 28/05/1992     */
/*                                                                          */
/*    Modifie par : Payam KIANI                         le : 22/07/1992     */
/*    Modifie par : Payam KIANI                         le : 07/10/1992     */
/*    Modifie par :                                     le : ../../....     */
/*                                                                          */
/****************************************************************************/
/* fichier dridtv.c : driver du nouveau format du perfmodule intermediaire  */
/****************************************************************************/
#include "tas_all.h"


/****************************************************************************/
/*                         fonction tas_GetRint()                           */
/* renvoie la resistance de la sortie lorsque 'entree' commute.             */
/****************************************************************************/
double tas_GetRint(cone,incone,typebr,typetr)
cone_list *cone   ;
list_list *incone ;
long      typebr  ,
          typetr  ;

{
list_list *path = NULL ;
link_list *link  ,
          *prevlink = NULL ;
long      Ptype ;
double    rs ;

if((incone->TYPE & EXT) == EXT)
    {
    list_list *auxpath ;

    for(auxpath = cone->PATH ; auxpath != NULL ; auxpath = auxpath->NEXT)
    if((auxpath->TYPE & EXT) == EXT)
        {
        for(link = (link_list *)auxpath->DATA ; link->NEXT != NULL ;
            link = link->NEXT) ;
        if(link->TRANS == (lotrs_list *)incone->DATA)
        if((path == NULL) || ((long)path->USER < (long)auxpath->USER))
        path = auxpath ;
        }
    }
else path = existe_tpd(cone,(cone_list *)incone->DATA,typebr,typetr,&link) ;

if(path == NULL) return(0.0) ;

pathcomm = path ;

link = (link_list *)path->DATA ;
if((link->TYPE & (IN | INOUT)) != 0) return(0.0) ;

for( /* initialise */ ; link->NEXT != NULL ; link = link->NEXT)
prevlink = link ;
if((link->TYPE & (IN | INOUT)) != 0) link = prevlink ;

Ptype = path->TYPE ;

if(
   ((Ptype & (TPINVSS | TNINVDD)) == 0) ||
   (((Ptype & EXT) == EXT) && (((typebr == VDD) && ((Ptype & TNINVDD) == 0)) ||
                               ((typebr == VSS) && ((Ptype & TPINVSS) == 0))))
  )
rs = VDDmax/(2*i_branch((link_list *)path->DATA,link)) ;

else /* branche degradante */
    {
    for(link = (link_list *)path->DATA ; link != NULL ;
        link = link->NEXT)
        {
        if((((path->TYPE & VDD) == VDD) && ((link->TYPE & TP) == TP)) ||
           (((path->TYPE & VSS) == VSS) && ((link->TYPE & TN) == TN)) ||
(((path->TYPE & EXT) == EXT) && ((typebr == VDD) && ((link->TYPE & TN) == TN)))
||
(((path->TYPE & EXT) == EXT) && ((typebr == VSS) && ((link->TYPE & TP) == TP)))
           )
        break ;

        if((link->TYPE & TP) == TP)
        rs += RPDD*(double)link->TRANS->LENGTH/
                   (double)link->USER->TYPE ;
        else
        rs += RNUD*(double)link->TRANS->LENGTH/
                   (double)link->USER->TYPE ;
        }

    if(link != NULL) rs += (VDDmax/(2*i_branch(link,link))) ;
    }

return(rs/1000.0) ;
}


/***************************************************************************/
/*                         fonction dtv_getcmd()                           */
/* renvoie, si elle existe, la commande qui concerne la donnee arrivant a  */
/* un point latch par une entree donnee. Cette fonction concerne le .dtv   */
/* et le similire existe pour le .ttv.                                     */
/***************************************************************************/
char *dtv_getcmd(cone,incone,level)
cone_list *cone   ;
list_list *incone ;
long      level   ;

{
list_list *path       ;
char      *cmd  = "*" ;

if((cone->TYPE & (LATCH | MEMORY)) != 0)
for(path = cone->PATH ; path != NULL ; path = path->NEXT)
if((path->TYPE & BLEEDER) != BLEEDER)
if(((path->TYPE & EXT) == EXT) || ((path->TYPE & level) == level))
    {
    link_list *link ;

    for(link = (link_list *)path->DATA ; link != NULL ; link = link->NEXT)
        {
        if((incone->TYPE & EXT) != EXT)
            {
            if(link->TRANS->GRID == (locon_list *)incone->DATA)
            break ;
            }
        else
            {
            if(link->TRANS == (lotrs_list *)incone->DATA)
            break ;
            }
        }

    if(link != NULL)
        {
        for(link = (link_list *)path->DATA ; link != NULL ;
            link = link->NEXT)
        /* dans le cas du switch-cmos, il faut donner la bonne branche */
        if((tas_GetInLink(cone,link)->TYPE & COMMAND) == COMMAND)
        if(((link->TYPE & SWITCH) != SWITCH) ||
           (((link->TYPE & TP) == TP) && (level == VDD)) ||
           (((link->TYPE & TN) == TN) && (level == VSS))   )
         break ;

        if(link != NULL)
            {
            cmd = ((link->TYPE & (IN | INOUT)) == 0)     ?
                  ((cone_list *)link->TRANS->GRID)->NAME :
                  ((locon_list *)link->TRANS)->NAME      ;
            break ;
            }
        }
    } /* fin de parcours des branches */

return(cmd) ;
}


/***************************************************************************/
/*                         fonction dridtv()                               */
/* driver du nouveau format de perfmodule.                                 */
/***************************************************************************/
int dridtv(desbfig)
desafig_list *desbfig ;

{
FILE        *file   = mbkfopen(desbfig->NAME,"dtv",WRITE_TEXT) ;
long        counter                                            ;
cone_list   *cone                                              ;

/* test d'ouverture de fichier */
if(file == NULL)
    {
    char straux[100] ;

    sprintf(straux,"%s.dtv",desbfig->NAME) ;

    if(INT_END == 'Y')
    tas_error(8,straux,TAS_ERROR) ;
    else
    tas_error(8,straux,TAS_WARNING) ;
    }

/* pour avoir le temps d'ecriture du fichier */
time(&counter) ;

tas_tvheader(desbfig,file,'d') ;
 
for(cone = desbfig->CONE ; cone != NULL ; cone = cone->NEXT)
if((cone->TYPE & (CONE_CONNECT | VDD | VSS)) == 0)
    {
    list_list *input ;

    for(input = cone->INCONE ; input != NULL ; input = input->NEXT)
    if((input->TYPE & (COMMAND | LOOP | VDD | VSS)) == 0)
        {
        char       *name                                                 ;
        delay_list *delay  = (delay_list *)input->USER                   ;
        cone_list  *incone = NULL                                        ;
        long       capa    = (long)((link_list *)cone->PATH->DATA)->CAPA ;
        float      rs                                                    ;

        /*-----------------------------------------------------------*/
        /* pour les latches memory, il faut enlever la transition du */
        /* latch associe.                                            */
        /*-----------------------------------------------------------*/
        if((cone->TYPE & MEMORY) == MEMORY)
            {
            ptype_list *ptype = getptype(cone->USER,MEMORY) ;

            if(ptype != NULL)
            if(input->DATA == ptype->DATA)
            continue ;
            }

        if((input->TYPE & EXT) == EXT)
        name = ((locon_list *)input->DATA)->NAME ;
        else
            {
            incone = (cone_list *)input->DATA ;
            name = incone->NAME ;
            }

        if((cone->TYPE & PRECHARGE) == PRECHARGE)
            {
            /* phase precharge */
            if((delay->TPHH != NOTIME) || (delay->TPLH != NOTIME))
                {
                fprintf(file,"T P P %s %s (",name,cone->NAME) ;
    
                if(delay->TPHH != NOTIME)
                    {
                    float rs = tas_GetRint(cone,input,VDD,TN) ;
    
                    if((cone->TYPE & EXT) == EXT)
                    fprintf(file,"\n\t(%s (UU MAX %ld %ld %.2f 0 %ld))",
                            dtv_getcmd(cone,input,VDD),
                            delay->TPHH,(long)rs*capa,rs,
                            valfupfdown(pathcomm)) ;
                    else
                    fprintf(file,"\n\t(%s (UU MAX %ld %ld))",
                            dtv_getcmd(cone,input,VDD),
                            delay->TPHH,(long)rs*capa) ;
    
                    pathcomm = NULL ;
                    }
                else if(delay->TPLH != NOTIME)
                fprintf(file,"\n\t(%s (UZ MAX 0 0))",
                        dtv_getcmd(cone,input,VDD)) ;
    
                if(delay->TPLH != NOTIME)
                    {
                    float rs = tas_GetRint(cone,input,VDD,TP) ;
    
                    if((cone->TYPE & EXT) == EXT)
                    fprintf(file,"\n\t(%s (DU MAX %ld %ld %.2f 0 %ld))",
                            dtv_getcmd(cone,input,VDD),
                            delay->TPLH,(long)rs*capa,rs,
                            valfupfdown(pathcomm)) ;
                    else
                    fprintf(file,"\n\t(%s (DU MAX %ld %ld))",
                            dtv_getcmd(cone,input,VDD),
                            delay->TPLH,(long)rs*capa) ;
    
                    pathcomm = NULL ;
                    }
                else if(delay->TPHH != NOTIME)
                fprintf(file,"\n\t(%s (DZ MAX 0 0))",
                        dtv_getcmd(cone,input,VDD)) ;
    
                fprintf(file,");\n") ;
                } /* fin de la precharge */

            /* phase evaluation */
            if((delay->TPHL != NOTIME) || (delay->TPLL != NOTIME))
                {
                fprintf(file,"T E E %s %s (",name,cone->NAME) ;
    
                if(delay->TPHL != NOTIME)
                    {
                    float rs = tas_GetRint(cone,input,VSS,TN) ;
    
                    if((cone->TYPE & EXT) == EXT)
                    fprintf(file,"\n\t(%s (UD MAX %ld %ld %.2f 0 %ld))",
                            dtv_getcmd(cone,input,VSS),
                            delay->TPHL,(long)rs*capa,rs,
                            valfupfdown(pathcomm)) ;
                    else
                    fprintf(file,"\n\t(%s (UD MAX %ld %ld))",
                            dtv_getcmd(cone,input,VSS),
                            delay->TPHL,(long)rs*capa) ;
    
                    pathcomm = NULL ;
                    }
                else if(delay->TPLL != NOTIME)
                fprintf(file,"\n\t(%s (UZ MAX 0 0))",
                        dtv_getcmd(cone,input,VSS)) ;
    
                if(delay->TPLL != NOTIME)
                    {
                    float rs = tas_GetRint(cone,input,VSS,TP) ;
    
                    if((cone->TYPE & EXT) == EXT)
                    fprintf(file,"\n\t(%s (DD MAX %ld %ld %.2f 0 %ld))",
                            dtv_getcmd(cone,input,VSS),
                            delay->TPLL,(long)rs*capa,rs,
                            valfupfdown(pathcomm)) ;
                    else
                    fprintf(file,"\n\t(%s (DD MAX %ld %ld))",
                            dtv_getcmd(cone,input,VSS),
                            delay->TPLL,(long)rs*capa) ;
    
                    pathcomm = NULL ;
                    }
                else if(delay->TPHL != NOTIME)
                fprintf(file,"\n\t(%s (DZ MAX 0 0))",
                        dtv_getcmd(cone,input,VSS)) ;
    
                fprintf(file,");\n") ;
                } /* fin de l'evaluation */
            } /* fin de sortie precharge */
        else /* sortie normale */
            {
            fprintf(file,"T X X %s %s (",name,cone->NAME) ;

            if(delay->TPHH != NOTIME)
                {
                rs  = tas_GetRint(cone,input,VDD,TN) ;

                if((cone->TYPE & EXT) == EXT)
                fprintf(file,"\n\t(%s (UU MAX %ld %ld %.2f 0 %ld))",
                        dtv_getcmd(cone,input,VDD),
                        delay->TPHH,(long)rs*capa,rs,
                        valfupfdown(pathcomm)) ;
                else
                fprintf(file,"\n\t(%s (UU MAX %ld %ld))",
                        dtv_getcmd(cone,input,VDD),
                        delay->TPHH,(long)rs*capa) ;

                pathcomm = NULL ;
                }
            if(delay->TPHL != NOTIME)
                {
                rs  = tas_GetRint(cone,input,VSS,TN) ;

                if((cone->TYPE & EXT) == EXT)
                fprintf(file,"\n\t(%s (UD MAX %ld %ld %.2f 0 %ld))",
                        dtv_getcmd(cone,input,VSS),
                        delay->TPHL,(long)rs*capa,rs,
                        valfupfdown(pathcomm)) ;
                else
                fprintf(file,"\n\t(%s (UD MAX %ld %ld))",
                        dtv_getcmd(cone,input,VSS),
                        delay->TPHL,(long)rs*capa) ;

                pathcomm = NULL ;
                }
            if(delay->TPLH != NOTIME)
                {
                rs  = tas_GetRint(cone,input,VDD,TP) ;

                if((cone->TYPE & EXT) == EXT)
                fprintf(file,"\n\t(%s (DU MAX %ld %ld %.2f 0 %ld))",
                        dtv_getcmd(cone,input,VDD),
                        delay->TPLH,(long)rs*capa,rs,
                        valfupfdown(pathcomm)) ;
                else
                fprintf(file,"\n\t(%s (DU MAX %ld %ld))",
                        dtv_getcmd(cone,input,VDD),
                        delay->TPLH,(long)rs*capa) ;

                pathcomm = NULL ;
                }
            if(delay->TPLL != NOTIME)
                {
                rs  = tas_GetRint(cone,input,VSS,TP) ;

                if((cone->TYPE & EXT) == EXT)
                fprintf(file,"\n\t(%s (DD MAX %ld %ld %.2f 0 %ld))",
                        dtv_getcmd(cone,input,VSS),
                        delay->TPLL,(long)rs*capa,rs,
                        valfupfdown(pathcomm)) ;
                else
                fprintf(file,"\n\t(%s (DD MAX %ld %ld))",
                        dtv_getcmd(cone,input,VSS),
                        delay->TPLL,(long)rs*capa) ;

                pathcomm = NULL ;
                }
            fprintf(file,");\n") ;
            } /* fin de sortie normale */

        fflush(file) ;
        } /* fin de la liste des entrees */
    } /* fin de la liste des cones */


fprintf(file,"E ;\n") ;

if(fclose(file) != 0)
    {
    char straux[100] ;

    sprintf(straux,"%s.dtv",desbfig->NAME) ;
    tas_error(10,straux,TAS_WARNING) ;
    }

return ;
}
