/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : TAS Version 3.54                                            */
/*    Fichier : main.c                                                      */
/*                                                                          */
/*    (c) copyright 1991-1992 Laboratoire MASI equipe CAO & VLSI            */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*    Auteur(s) : Payam KIANI                           le : 28/05/1991     */
/*                                                                          */
/*    Modifie par : Payam KIANI                         le : 16/10/1991     */
/*    Modifie par : Payam KIANI                         le : 22/07/1992     */
/*    Modifie par : Payam KIANI                         le : 07/10/1992     */
/*                                                                          */
/****************************************************************************/
/* fichier main.c : fichier principal. Elle fait appel aux differnts modules*/
/****************************************************************************/
#include "tas_all.h"

/*****************************************************************************/
/*                           focntion InitInfo()                             */
/* initialise les champs d'une variable d'information.                       */
/*****************************************************************************/
struct information tas_InitInfo(info)
struct information info ;

{
info.lo_t = info.db_t = info.el_t = info.gr_t = info.pr_t = 0 ;
info.comp = info.nb_trans = info.nb_cone = 0 ;

return(info) ;
}


/*****************************************************************************/
/*                           fonction PrintTime()                            */
/* affiche les temps systemes et utilisateurs.                               */
/*****************************************************************************/
int tas_PrintTime(start,end,temps)
struct tms start ,
           end   ;
long       temps ;

{
long user = end.tms_utime - start.tms_utime ,
     syst = end.tms_stime - start.tms_stime ;
long userM = (long)(user/3600)      ,
     userS = (long)((user%3600)/60) ,
     userD = (long)((user%60)/6)    ;
long systM = (long)(syst/3600)      ,
     systS = (long)((syst%3600)/60) ,
     systD = (long)((syst%60)/6)    ;

fprintf(stdout," %02dmin %02ds\n",(long)(temps/60),(long)(temps%60)) ;
fprintf(stdout,"tas user   : %02d'%02d.%d''\n",userM,userS,userD) ;
fprintf(stdout,"    system : %02d'%02d.%d''\n",systM,systS,systD) ;
fflush(stdout) ;
}


/*****************************************************************************
*                            fonction main()                                 *
*****************************************************************************/
main(argc,argv,arge)
int 	argc    ;
char 	*argv[] ,
     	*arge[] ;

{
struct tms Tstart  ,
           Tend    ,
           start   ,
           end     ;
long       tTstart ,
           tTend   ,
           tstart  ,
           tend    ;
short      i       ;
lofig_list *lofig  ;


TAS_INFO = tas_InitInfo(TAS_INFO) ;

TAS_INFO.argc = argc ;
TAS_INFO.argv = argv ;

times(&Tstart) ;
time(&tTstart) ;

mbkenv() ; /* sinon => traitement normal */
/* forcage de SCALE_X: la variable d'environnement ne sert plus */
SCALE_X = 100 ;

/* environnement desb */
desa_setenv() ;

/* allocation memeoire desb */
dsbInitMem() ;

/* environnement tas: les variables globales */
signal(SIGINT,tas_GetKill) ;
tas_setenv();

/* DESB MAIS A ENLEVER */
DESB_VERSION=namealloc("2.89");

/* traitement des options en ligne de commande */
option(argc,argv);

/* banniere */
alliancebanner("tAs",VERSION,"CMOS-VLSI Timing Analyzer","90-93","2.0") ;

/* debut du chargement du fichier techno */
if(TAS_LANG == 'E')
fprintf(stdout,"TECHNOLGY FILE IS '%s'\n",TECFILE) ;
else if(TAS_LANG == 'F')
fprintf(stdout,"FICHIER TECHNOLOGIE: '%s'\n",TECFILE) ;

if(tasTechnoParameters(TECFILE))
tas_error(14,TECFILE,TAS_ERROR) ;

if(TAS_LANG == 'E')
fprintf(stdout,"TECHNOLOGY") ;
else if(TAS_LANG == 'F')
fprintf(stdout,"TECHNOLOGIE") ;
fprintf(stdout,":%s VERSION:%.2f\n",elpTechnoName,elpTechnoVersion) ;
fprintf(stdout,"REFERENCE  : %s, LEVEL=%.2f\n",elpEsimName,elpEsimLevel) ;
fprintf(stdout,"-----------------------------------\n") ;
fflush(stdout) ;

if (TAS_TRACE_MODE == 'Y')
    {
    fprintf(stdout,"\n\nparametres finaux\n\n");
    fflush(stdout) ;
    visu();
    }

if(TAS_PWL == 'Y')
    {
    if(TAS_LANG == 'E') fprintf(stdout,"WRITING OF 'PwlRise' and 'PwlFall'\n") ;
    else fprintf(stdout,"ECRITURE DE 'PwlRise' et 'PwlFall'\n") ;
    tas_PwlFile(HEAD_DESBFIG) ;
    fprintf(stdout,"-----------------------------------\n") ;
    fflush(stdout) ;
    }

if(NOTAS == 'N')
    {
    /* parsing du fichier ".deb" */
    if(TAS_LANG == 'E')
    fprintf(stdout,"LOADING FILE %s.%s:",FILENAME,IN_LO) ;
    else if(TAS_LANG == 'F')
    fprintf(stdout,"CHARGEMENT DU FICHIER %s.%s:",FILENAME,IN_LO) ;
    fflush(stdout) ;
    times( &start ) ;
    time( &tstart ) ;

    /*---------------------------------------------------------------------*/
    /* sinon, on charge la figure MBK, on la met a plat, on rajoute les    */
    /* capas des transistors, on la desassemble et, s'il le faut, on crache*/
    /* le fichier .deb                                                     */
    /*---------------------------------------------------------------------*/
    /* Lecture du fichier INFO */ 
    if(DSB_INF !=0)
        {
        if(mbkfopen(FILENAME,"inf",READ_TEXT) == NULL)
            {
            char buff[50] ;

            sprintf(buff,"%s.inf",FILENAME) ;
            tas_error(8,buff,TAS_WARNING) ;
            }
        else
            {
            if(TAS_LANG == 'E')
            fprintf(stdout,"\nreading information file %s.inf\n",FILENAME) ;
            else if(TAS_LANG == 'F')
            fprintf(stdout,"\nlecture du fichier info %s.inf\n",FILENAME) ;
   
            infLit(FILENAME,TAS_LANG);
            }
        }

    lofig = HEAD_LOFIG = getlofig(FILENAME,'A') ; /* chargement */

    if(HEAD_LOFIG != NULL)
    FILENAME = HEAD_LOFIG->NAME ;


    /* mise a plat */
    while(lofig->LOINS != NULL)
    flattenlofig(lofig,lofig->LOINS->INSNAME,'Y') ;

    /*----------------------------------------------------------*/
    /* si option -l activee, on rajoute les capas de sortie:    */
    /* En donnant une valeur a la variable TAS_CAPAOUT, plus    */
    /* loin dans cette meme fonction, les connecteurs de sortie */
    /* vont etre charges.                                       */
    /*----------------------------------------------------------*/
    if(PRFTYPE == 'C')
    TAS_CAPAOUT = tas_CompCapa(lofig) ;

    /* les shrinks */
    elpLofigShrink(lofig) ;

    /*-----------------------------------------------------------------*/
    /* calcul des capacites dynamiques: les capas de grille sont       */
    /* systematiquement calculees. Les capas de diff ne sont calculees */
    /* que si les dimensions du transistor sont non-nulles.            */
    /*-----------------------------------------------------------------*/
    elpLofigCapaGrid(lofig) ;

    if(lofig->LOTRS != NULL)
    elpLofigCapaDiff(lofig) ;

    INF_SIGLIST = tas_GetAliasSig(lofig,INF_SIGLIST) ;

    /*-----------------------------------------------------------------*/
    /* ajout de la capacite cout passee en parametre sur tous les con- */
    /* necteurs. Plus tard, apres le desassemblage, il y a retrait de  */
    /* la meme capacite de sur les connecteurs IN et UNKNOWN.          */
    /*-----------------------------------------------------------------*/
    tas_AddCapaOut(lofig) ;

    /* information */
    times( &end ) ;
    time( &tend ) ;
    tas_PrintTime(start,end,tend-tstart) ;
    TAS_INFO.lo_t = (long)(((end.tms_utime   + end.tms_stime  )-
                            (start.tms_utime + start.tms_stime) ) / 60.0) ;
    fprintf(stdout,"-----------------------------------\n") ;

    /* desassemblage */
    if(TAS_LANG == 'E')
    fprintf(stdout,"DESASSEMBLING\n\n") ;
    else if(TAS_LANG == 'F')
    fprintf(stdout,"DESASSEMBLAGE\n\n") ;

    HEAD_DESBFIG = desb(FILENAME,lofig) ;

    /* retrait de la capa cout des connecteurs IN et UNKNOWN */
    if(TAS_CAPAOUT != 0.0)
    tas_DelCapaOut(HEAD_DESBFIG) ;

    /* driver du fichier .deb si l'utilisateur l'a demande */
    if(DEB_FILE == 'Y') savedesa(HEAD_DESBFIG) ;

    times( &end ) ;
    time( &tend ) ;
    tas_PrintTime(start,end,tend-tstart) ;
    TAS_INFO.db_t = (long)(((end.tms_utime   + end.tms_stime  )-
                            (start.tms_utime + start.tms_stime) ) / 60.0) ;
    fprintf(stdout,"-----------------------------------\n") ;
    fflush(stdout) ;

    /* calcul des temps elementaires */
    times( &start ) ;
    time( &tstart ) ;
    if(TAS_LANG  == 'E')
    fprintf(stdout,"COMPUTING GATE DELAYS:") ;
    else if(TAS_LANG == 'F')
    fprintf(stdout,"CALCUL DES TEMPS ELEMENTAIRES:");
    fflush(stdout) ;

    timing(HEAD_DESBFIG) ;
    times( &end ) ;
    time( &tend ) ;
    tas_PrintTime(start,end,tend-tstart) ;
    TAS_INFO.el_t = (long)(((end.tms_utime   + end.tms_stime  )-
                            (start.tms_utime + start.tms_stime) ) / 60.0) ;
    fprintf(stdout,"-----------------------------------\n") ;
    fflush(stdout);

    /* fichier des fronts du cone de la figure */
    if(SLOFILE == 'Y')
        {
        if(TAS_LANG == 'E')
        fprintf(stdout,"CONE SLOPES : %s.slo:",HEAD_DESBFIG->NAME) ;
        else if(TAS_LANG == 'F')
        fprintf(stdout,"LES FRONTS DU CONE : %s.slo:",HEAD_DESBFIG->NAME) ;
        fflush(stdout) ;
        times( &start ) ;
        time( &tstart ) ;
        slopefile(HEAD_DESBFIG) ;
        times( &end ) ;
        time( &tend ) ;
        tas_PrintTime(start,end,tend-tstart) ;
        fprintf(stdout,"-----------------------------------\n") ;
        fflush(stdout) ;
        }

    /*perfmodule intermediaire */
    if(PERFINT == 'Y')
        {
        fflush(stdout) ;
        times( &start ) ;
        time( &tstart ) ;
        if(TAS_LANG == 'E')
        fprintf(stdout,"INTERMEDIATE PERFMODULE : %s.dtv\n",
                HEAD_DESBFIG->NAME) ;
        else if(TAS_LANG == 'F')
        fprintf(stdout,"PERFMODULE INTERMEDIAIRE : %s.dtv\n",
                HEAD_DESBFIG->NAME) ;

        fflush(stdout) ;
        dridtv(HEAD_DESBFIG) ;

        times( &end ) ;
        time( &tend ) ;
        tas_PrintTime(start,end,tend-tstart) ;
        fprintf(stdout,"-----------------------------------\n") ;
        fflush(stdout) ;
        }

    if(INT_END != 'Y')
        {
        /* parcours de graphe et perfmodule */
        if(TAS_LANG == 'E')
        fprintf(stdout,"SEARCHING OF CRITICAL PATHES\n") ;
        else if(TAS_LANG == 'F')
        fprintf(stdout,"RECHERCHE DES CHEMINS CRITIQUES\n") ;
        times( &start ) ;
        time( &tstart ) ;

        {
        perf_list *perfig ;

        perfig = timecat(HEAD_DESBFIG) ;

        if(TAS_MAXPATH->DELAY != NOTIME)
            {
            TAS_INFO.maxdelay = TAS_MAXPATH->DELAY ;
            TAS_INFO.comp = NP ;

            if(TAS_LANG == 'E')
                {
                fprintf(stdout,"the circuit worst case delay is %ldpS\n",
                        TAS_MAXPATH->DELAY) ;

                if(TAS_MAXPATH->FRIN == 'U')
                fprintf(stdout,"--> from _/- ") ;
                else fprintf(stdout,"--> from -\\_ ") ;

                fprintf(stdout,"%s\n--> to ",tas_NODENAME(TAS_MAXPATH->UP)) ;

                if(TAS_MAXPATH->FROUT == 'U')
                fprintf(stdout,"_/- ") ;
                else if(TAS_MAXPATH->FROUT == 'D')
                fprintf(stdout,"-\\_ ") ;
                else fprintf(stdout,"HighZ ") ;

                fprintf(stdout,"%s)\n\n",tas_NODENAME(TAS_MAXPATH->BOTTOM)) ;

                fprintf(stdout,"nb couple = %ld\n",NB_COUPLE) ;
                fprintf(stdout,"nb chain = %ld\n\n",NB_CHAINE) ;
                }
            else if(TAS_LANG == 'F')
                { 
                fprintf(stdout,"le delai maximal est de %ldpS\n",
                        TAS_MAXPATH->DELAY) ;

                if(TAS_MAXPATH->FRIN == 'U')
                fprintf(stdout,"--> de _/- ") ;
                else fprintf(stdout,"--> de -\\_ ") ;

                fprintf(stdout,"%s\n--> a ",tas_NODENAME(TAS_MAXPATH->UP)) ;

                if(TAS_MAXPATH->FROUT == 'U')
                fprintf(stdout,"_/- ") ;
                else if(TAS_MAXPATH->FROUT == 'D')
                fprintf(stdout,"-\\_ ") ;
                else fprintf(stdout,"HighZ ") ;

                fprintf(stdout,"%s\n\n",tas_NODENAME(TAS_MAXPATH->BOTTOM)) ;

                fprintf(stdout,"nb couple = %ld\n",NB_COUPLE) ;
                fprintf(stdout,"nb chaine = %ld\n\n",NB_CHAINE) ;
                }
            }
        else /* si pas de temps de propagation */
            {
            if(TAS_LANG == 'E')
            fprintf(stdout,"no signal propagtion\n") ;
            else if(TAS_LANG == 'F')
            fprintf(stdout,"pas de propagation de signal\n") ;
            }

        times( &end ) ;
        time( &tend ) ;
        tas_PrintTime(start,end,tend-tstart) ;
        TAS_INFO.gr_t = (long)(((end.tms_utime   + end.tms_stime  )-
                                (start.tms_utime + start.tms_stime) ) / 60.0) ;
        fprintf(stdout,"-----------------------------------\n") ;
        fflush(stdout) ;

        /* ecriture perfmodule */
        if(TAS_LANG == 'E')
        fprintf(stdout,"WRITING OF THE GENERAL PERFMODULE:\n") ;
        else if(TAS_LANG == 'F')
        fprintf(stdout,"ECRITURE DU PERFMODULE GENERAL:\n") ;

        times( &start ) ;
        time( &tstart ) ;

        /* ecriture du perfmodule general */
        if(PRFTYPE == 'C') /* fichier de caracterisation */
            {
            fprintf(stdout,"%s.car\n",FILENAME) ;
            fflush(stdout) ;
            dricar(HEAD_DESBFIG,perfig) ;
            }
        else
            { /* nouveau perfmodule general */
            fprintf(stdout,"%s.ttv\n",FILENAME) ;
            fflush(stdout) ;
            drittv(HEAD_DESBFIG,perfig) ;
            }

        times( &end ) ;
        time( &tend ) ;
        tas_PrintTime(start,end,tend-tstart) ;
        TAS_INFO.pr_t = (long)(((end.tms_utime   + end.tms_stime  )-
                                (start.tms_utime + start.tms_stime) ) / 60.0) ;
        fprintf(stdout,"-----------------------------------\n") ;
        fflush(stdout) ;
        }
        }
    }

/* fin du traitement */
times(&Tend) ;
time(&tTend) ;

if(TAS_LANG == 'E')
    {
    fprintf(stdout,"total run time:") ;
    tas_PrintTime(Tstart,Tend,tTend-tTstart) ;
    fprintf(stdout,"%.2f%% CPU---end!!!\n",(100.0*
            (Tend.tms_utime-Tstart.tms_utime +
             Tend.tms_stime-Tstart.tms_stime )) /
            ((tTend-tTstart)*60.0)) ;
    }
else if(TAS_LANG == 'F')
    {
    fprintf(stdout,"Temps total du traitement:") ;
    tas_PrintTime(Tstart,Tend,tTend-tTstart) ;
    fprintf(stdout,"%.2f%% CPU---fini!!!\n",(100.0*
            (Tend.tms_utime-Tstart.tms_utime +
             Tend.tms_stime-Tstart.tms_stime )) /
            ((tTend-tTstart)*60.0)) ;
    }
fprintf(stdout,"-----------------------------------\n") ;
fflush(stdout) ;

if(TAS_SILENTMODE == 'Y')
tas_RestoreTerm() ;

#ifdef BULL
/*if(TAS_MAIL == 'Y')*/
/*tas_Mail(TAS_INFO) ;*/
#endif

return 0 ;
}
